/* --------------------------------------------------------------- */
/* Licensed Materials - Property of IBM                            */
/* 5724-S84                                                        */
/* (C) Copyright IBM Corp. 2007,2008, All Rights Reserved          */
/* US Government Users Restricted Rights - Use, duplication or     */
/* disclosure restricted by GSA ADP Schedule Contract with         */
/* IBM Corp.                                                       */
/* --------------------------------------------------------------- */
/* PROLOG END TAG zYx                                              */
//$Revision: 1.17 $

#ifndef _MC_RAND_MT_H_
#define _MC_RAND_MT_H_

//  C++ interface
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct mt_struct {  
    unsigned int mexp;
    unsigned int magic_value;
    unsigned int split_index;
    unsigned int sta_size;
    unsigned int umask;
    unsigned int shift0;
    unsigned int shift1;
    unsigned int shiftB;
    unsigned int shiftC;
    unsigned int maskB;
    unsigned int maskC;
    unsigned char padding[4];
} mt_param_list; 

#ifdef __SPU__

    // error codes
    #define DC_GET_MTS_OK           0
    #define DC_GET_MTS_DMA_ERROR    -1
    #define DC_GET_MTS_WRONG_INDEX  -2

    void mc_rand_mt_init(const unsigned int seed);

    int mc_rand_mt_get_mtps(
            unsigned long long int eadr,
            void *LS_params, 
            unsigned int mexp, 
            unsigned int index);

    vector unsigned int     mc_rand_mt_u4();
    vector float            mc_rand_mt_minus1_to_1_f4();
    vector float            mc_rand_mt_0_to_1_f4();
    vector double           mc_rand_mt_0_to_1_d2();
    vector double           mc_rand_mt_0_to_1_d2e();
    vector double           mc_rand_mt_minus1_to_1_d2();
    vector double           mc_rand_mt_minus1_to_1_d2e();

    void mc_rand_mt_array_u4( 
            unsigned int count, 
            vector unsigned int *array );

    void mc_rand_mt_0_to_1_array_f4(
            unsigned int count, 
            vector float *array );

    void mc_rand_mt_minus1_to_1_array_f4(
            unsigned int count, 
            vector float *array );

    void mc_rand_mt_0_to_1_array_d2(
            unsigned int count, 
            vector double *array );

    void mc_rand_mt_minus1_to_1_array_d2(
            unsigned int count, 
            vector double *array );

    void mc_rand_mt_0_to_1_array_d2e(
            unsigned int count, 
            vector double *array );

    void mc_rand_mt_minus1_to_1_array_d2e(
            unsigned int count, 
            vector double *array );

#endif // SPU
#ifdef __PPU__

mt_param_list mts[2048] __attribute__ ((aligned (128))) = {
    { 1279U, 3555883008UL, 20,40,4294967294UL, 12, 18, 7, 15, 2646568320UL, 1868267520UL,   {0}},
    { 1279U, 2187503617UL, 20,40,4294967294UL, 12, 18, 7, 15, 2373283712UL, 3998711808UL,   {0}},
    { 1279U, 3308625922UL, 20,40,4294967294UL, 12, 18, 7, 15, 3488970624UL, 3983245312UL,   {0}},
    { 1279U, 2766825475UL, 20,40,4294967294UL, 12, 18, 7, 15, 852948864UL, 4015357952UL,   {0}},
    { 1279U, 2488702980UL, 20,40,4294967294UL, 12, 18, 7, 15, 701852544UL, 4014309376UL,   {0}},
    { 1279U, 3808077829UL, 20,40,4294967294UL, 12, 18, 7, 15, 3948262272UL, 2006417408UL,   {0}},
    { 1279U, 2530115590UL, 20,40,4294967294UL, 12, 18, 7, 15, 729640320UL, 4015423488UL,   {0}},
    { 1279U, 4207255559UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151322496UL, 2002223104UL,   {0}},
    { 1279U, 2502324232UL, 20,40,4294967294UL, 12, 18, 7, 15, 634746752UL, 3981803520UL,   {0}},
    { 1279U, 3540895753UL, 20,40,4294967294UL, 12, 18, 7, 15, 1845329792UL, 4138041344UL,   {0}},
    { 1279U, 3989823498UL, 20,40,4294967294UL, 12, 18, 7, 15, 913668992UL, 3882188800UL,   {0}},
    { 1279U, 4182081547UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629131136UL, 2006417408UL,   {0}},
    { 1279U, 3952793612UL, 20,40,4294967294UL, 12, 18, 7, 15, 3019142528UL, 4016537600UL,   {0}},
    { 1279U, 4202334221UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117767296UL, 2010480640UL,   {0}},
    { 1279U, 3952752654UL, 20,40,4294967294UL, 12, 18, 7, 15, 1255438208UL, 3981672448UL,   {0}},
    { 1279U, 3400679439UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557821056UL, 3990192128UL,   {0}},
    { 1279U, 3713089552UL, 20,40,4294967294UL, 12, 18, 7, 15, 861204096UL, 3721756672UL,   {0}},
    { 1279U, 2655209489UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706550144UL, 3983835136UL,   {0}},
    { 1279U, 3376597010UL, 20,40,4294967294UL, 12, 18, 7, 15, 3432299392UL, 4149575680UL,   {0}},
    { 1279U, 3810951187UL, 20,40,4294967294UL, 12, 18, 7, 15, 3438638976UL, 3999760384UL,   {0}},
    { 1279U, 3715739668UL, 20,40,4294967294UL, 12, 18, 7, 15, 1987410816UL, 3882188800UL,   {0}},
    { 1279U, 2409185301UL, 20,40,4294967294UL, 12, 18, 7, 15, 3488970624UL, 3982852096UL,   {0}},
    { 1279U, 3617480726UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117898624UL, 2001960960UL,   {0}},
    { 1279U, 2661431319UL, 20,40,4294967294UL, 12, 18, 7, 15, 2402645888UL, 3982852096UL,   {0}},
    { 1279U, 3221737496UL, 20,40,4294967294UL, 12, 18, 7, 15, 1743091584UL, 4116021248UL,   {0}},
    { 1279U, 2640547865UL, 20,40,4294967294UL, 12, 18, 7, 15, 729083776UL, 3990323200UL,   {0}},
    { 1279U, 3484899354UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470089088UL, 2072739840UL,   {0}},
    { 1279U, 3668795419UL, 20,40,4294967294UL, 12, 18, 7, 15, 3597986432UL, 4023746560UL,   {0}},
    { 1279U, 2440597532UL, 20,40,4294967294UL, 12, 18, 7, 15, 3543460480UL, 4023681024UL,   {0}},
    { 1279U, 3051587613UL, 20,40,4294967294UL, 12, 18, 7, 15, 1768650624UL, 3866329088UL,   {0}},
    { 1279U, 3513081886UL, 20,40,4294967294UL, 12, 18, 7, 15, 4017470080UL, 2077589504UL,   {0}},
    { 1279U, 3292508191UL, 20,40,4294967294UL, 12, 18, 7, 15, 3571281280UL, 1866825728UL,   {0}},
    { 1279U, 2206269472UL, 20,40,4294967294UL, 12, 18, 7, 15, 1955952512UL, 3981934592UL,   {0}},
    { 1279U, 3572746273UL, 20,40,4294967294UL, 12, 18, 7, 15, 3436534656UL, 2008514560UL,   {0}},
    { 1279U, 4029724706UL, 20,40,4294967294UL, 12, 18, 7, 15, 2643702656UL, 2001436672UL,   {0}},
    { 1279U, 3673526307UL, 20,40,4294967294UL, 12, 18, 7, 15, 1733588608UL, 3990192128UL,   {0}},
    { 1279U, 3685914660UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641328000UL, 3992682496UL,   {0}},
    { 1279U, 2269636645UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557821056UL, 3990192128UL,   {0}},
    { 1279U, 2171015206UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151785344UL, 4015489024UL,   {0}},
    { 1279U, 2180769831UL, 20,40,4294967294UL, 12, 18, 7, 15, 1550513792UL, 3990192128UL,   {0}},
    { 1279U, 3532349480UL, 20,40,4294967294UL, 12, 18, 7, 15, 2639748224UL, 2010873856UL,   {0}},
    { 1279U, 2343319593UL, 20,40,4294967294UL, 12, 18, 7, 15, 2358537088UL, 4015489024UL,   {0}},
    { 1279U, 2245406762UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627039104UL, 3981803520UL,   {0}},
    { 1279U, 3652843563UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983900672UL,   {0}},
    { 1279U, 2600362028UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629137280UL, 1879015424UL,   {0}},
    { 1279U, 2488725549UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117604736UL, 4116021248UL,   {0}},
    { 1279U, 2751311918UL, 20,40,4294967294UL, 12, 18, 7, 15, 903313152UL, 3981803520UL,   {0}},
    { 1279U, 3566964783UL, 20,40,4294967294UL, 12, 18, 7, 15, 2643945856UL, 1876262912UL,   {0}},
    { 1279U, 4069330992UL, 20,40,4294967294UL, 12, 18, 7, 15, 3149323136UL, 4141187072UL,   {0}},
    { 1279U, 2872764465UL, 20,40,4294967294UL, 12, 18, 7, 15, 2360702848UL, 3864494080UL,   {0}},
    { 1279U, 3214921778UL, 20,40,4294967294UL, 12, 18, 7, 15, 852948864UL, 4015357952UL,   {0}},
    { 1279U, 3861082163UL, 20,40,4294967294UL, 12, 18, 7, 15, 2642832768UL, 4015751168UL,   {0}},
    { 1279U, 4066367540UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117837056UL, 4015226880UL,   {0}},
    { 1279U, 4034125877UL, 20,40,4294967294UL, 12, 18, 7, 15, 3704806272UL, 4149706752UL,   {0}},
    { 1279U, 3440007222UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480582016UL, 3982852096UL,   {0}},
    { 1279U, 3972948023UL, 20,40,4294967294UL, 12, 18, 7, 15, 3099880064UL, 4019552256UL,   {0}},
    { 1279U, 2640242744UL, 20,40,4294967294UL, 12, 18, 7, 15, 3114691456UL, 4011032576UL,   {0}},
    { 1279U, 3415050297UL, 20,40,4294967294UL, 12, 18, 7, 15, 920057728UL, 4015357952UL,   {0}},
    { 1279U, 4223082554UL, 20,40,4294967294UL, 12, 18, 7, 15, 3463804800UL, 3982983168UL,   {0}},
    { 1279U, 3912509499UL, 20,40,4294967294UL, 12, 18, 7, 15, 3313332096UL, 3998711808UL,   {0}},
    { 1279U, 2560546876UL, 20,40,4294967294UL, 12, 18, 7, 15, 3108333440UL, 1851752448UL,   {0}},
    { 1279U, 2216359997UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117833088UL, 4149444608UL,   {0}},
    { 1279U, 3391621182UL, 20,40,4294967294UL, 12, 18, 7, 15, 3703237760UL, 4024401920UL,   {0}},
    { 1279U, 2156564543UL, 20,40,4294967294UL, 12, 18, 7, 15, 601158528UL, 4015882240UL,   {0}},
    { 1279U, 2175232064UL, 20,40,4294967294UL, 12, 18, 7, 15, 1733588608UL, 4007100416UL,   {0}},
    { 1279U, 3921539137UL, 20,40,4294967294UL, 12, 18, 7, 15, 2944333696UL, 4141187072UL,   {0}},
    { 1279U, 4094910530UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641196928UL, 3992289280UL,   {0}},
    { 1279U, 3243194435UL, 20,40,4294967294UL, 12, 18, 7, 15, 647427456UL, 4023746560UL,   {0}},
    { 1279U, 2610270276UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117603712UL, 4149444608UL,   {0}},
    { 1279U, 3994624069UL, 20,40,4294967294UL, 12, 18, 7, 15, 903280512UL, 3981803520UL,   {0}},
    { 1279U, 3558981702UL, 20,40,4294967294UL, 12, 18, 7, 15, 2816961408UL, 2069200896UL,   {0}},
    { 1279U, 3162611783UL, 20,40,4294967294UL, 12, 18, 7, 15, 2645915520UL, 4009066496UL,   {0}},
    { 1279U, 4121303112UL, 20,40,4294967294UL, 12, 18, 7, 15, 1280769920UL, 3939860480UL,   {0}},
    { 1279U, 2378772553UL, 20,40,4294967294UL, 12, 18, 7, 15, 2359127936UL, 3998711808UL,   {0}},
    { 1279U, 4054333514UL, 20,40,4294967294UL, 12, 18, 7, 15, 861232896UL, 4126638080UL,   {0}},
    { 1279U, 2993578059UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706550144UL, 4000808960UL,   {0}},
    { 1279U, 3714555980UL, 20,40,4294967294UL, 12, 18, 7, 15, 3142933888UL, 2009694208UL,   {0}},
    { 1279U, 3479507021UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641262208UL, 4026236928UL,   {0}},
    { 1279U, 2162454606UL, 20,40,4294967294UL, 12, 18, 7, 15, 2625989504UL, 1868005376UL,   {0}},
    { 1279U, 2529515599UL, 20,40,4294967294UL, 12, 18, 7, 15, 3958659968UL, 2002092032UL,   {0}},
    { 1279U, 2860181584UL, 20,40,4294967294UL, 12, 18, 7, 15, 3949288832UL, 2008383488UL,   {0}},
    { 1279U, 3758123089UL, 20,40,4294967294UL, 12, 18, 7, 15, 3181178496UL, 4022697984UL,   {0}},
    { 1279U, 2671325266UL, 20,40,4294967294UL, 12, 18, 7, 15, 903149440UL, 3981803520UL,   {0}},
    { 1279U, 3592224851UL, 20,40,4294967294UL, 12, 18, 7, 15, 729640320UL, 4023746560UL,   {0}},
    { 1279U, 3450452052UL, 20,40,4294967294UL, 12, 18, 7, 15, 2576639616UL, 4023877632UL,   {0}},
    { 1279U, 3684376661UL, 20,40,4294967294UL, 12, 18, 7, 15, 2614409984UL, 4157964288UL,   {0}},
    { 1279U, 2800930902UL, 20,40,4294967294UL, 12, 18, 7, 15, 3032251264UL, 4016799744UL,   {0}},
    { 1279U, 3606884439UL, 20,40,4294967294UL, 12, 18, 7, 15, 1939176320UL, 3883237376UL,   {0}},
    { 1279U, 2554785880UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627041152UL, 3984424960UL,   {0}},
    { 1279U, 4244639833UL, 20,40,4294967294UL, 12, 18, 7, 15, 3067541376UL, 4015357952UL,   {0}},
    { 1279U, 2400954458UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480713088UL, 3982852096UL,   {0}},
    { 1279U, 2474590299UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151818112UL, 4014440448UL,   {0}},
    { 1279U, 4025403484UL, 20,40,4294967294UL, 12, 18, 7, 15, 1968469632UL, 3990192128UL,   {0}},
    { 1279U, 3971901533UL, 20,40,4294967294UL, 12, 18, 7, 15, 3472251776UL, 2001895424UL,   {0}},
    { 1279U, 3227836510UL, 20,40,4294967294UL, 12, 18, 7, 15, 4080364928UL, 1876787200UL,   {0}},
    { 1279U, 3200403551UL, 20,40,4294967294UL, 12, 18, 7, 15, 3411474048UL, 3990192128UL,   {0}},
    { 1279U, 3241361504UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706550144UL, 4000808960UL,   {0}},
    { 1279U, 3557060705UL, 20,40,4294967294UL, 12, 18, 7, 15, 2580830464UL, 4158095360UL,   {0}},
    { 1279U, 2244067426UL, 20,40,4294967294UL, 12, 18, 7, 15, 3602180736UL, 4023681024UL,   {0}},
    { 1279U, 4165539939UL, 20,40,4294967294UL, 12, 18, 7, 15, 2849663872UL, 4014178304UL,   {0}},
    { 1279U, 2539069540UL, 20,40,4294967294UL, 12, 18, 7, 15, 2642243456UL, 3998711808UL,   {0}},
    { 1279U, 2693767269UL, 20,40,4294967294UL, 12, 18, 7, 15, 2622839424UL, 2010480640UL,   {0}},
    { 1279U, 3828265062UL, 20,40,4294967294UL, 12, 18, 7, 15, 3721753344UL, 1868398592UL,   {0}},
    { 1279U, 3664734311UL, 20,40,4294967294UL, 12, 18, 7, 15, 2359587712UL, 4026499072UL,   {0}},
    { 1279U, 3549341800UL, 20,40,4294967294UL, 12, 18, 7, 15, 771061632UL, 4116021248UL,   {0}},
    { 1279U, 4023228521UL, 20,40,4294967294UL, 12, 18, 7, 15, 2614386048UL, 4149182464UL,   {0}},
    { 1279U, 2684151914UL, 20,40,4294967294UL, 12, 18, 7, 15, 3116789376UL, 3985997824UL,   {0}},
    { 1279U, 3727499371UL, 20,40,4294967294UL, 12, 18, 7, 15, 3469915904UL, 4158095360UL,   {0}},
    { 1279U, 2577674348UL, 20,40,4294967294UL, 12, 18, 7, 15, 2640276608UL, 1876656128UL,   {0}},
    { 1279U, 3332917357UL, 20,40,4294967294UL, 12, 18, 7, 15, 2883416960UL, 2002223104UL,   {0}},
    { 1279U, 3135594606UL, 20,40,4294967294UL, 12, 18, 7, 15, 1987411840UL, 3983376384UL,   {0}},
    { 1279U, 3426869359UL, 20,40,4294967294UL, 12, 18, 7, 15, 594376576UL, 3983900672UL,   {0}},
    { 1279U, 4287977584UL, 20,40,4294967294UL, 12, 18, 7, 15, 1987410816UL, 4016930816UL,   {0}},
    { 1279U, 3811836017UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641196928UL, 3992289280UL,   {0}},
    { 1279U, 4041668722UL, 20,40,4294967294UL, 12, 18, 7, 15, 1256093312UL, 3990192128UL,   {0}},
    { 1279U, 3723606131UL, 20,40,4294967294UL, 12, 18, 7, 15, 3461840768UL, 3948183552UL,   {0}},
    { 1279U, 2437480564UL, 20,40,4294967294UL, 12, 18, 7, 15, 1859500672UL, 4157964288UL,   {0}},
    { 1279U, 2159820917UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117705856UL, 4019552256UL,   {0}},
    { 1279U, 2746607734UL, 20,40,4294967294UL, 12, 18, 7, 15, 2877125504UL, 2010611712UL,   {0}},
    { 1279U, 2578778231UL, 20,40,4294967294UL, 12, 18, 7, 15, 1817505664UL, 3713368064UL,   {0}},
    { 1279U, 3543853176UL, 20,40,4294967294UL, 12, 18, 7, 15, 2729341824UL, 4017848320UL,   {0}},
    { 1279U, 2674528377UL, 20,40,4294967294UL, 12, 18, 7, 15, 2750182272UL, 4017520640UL,   {0}},
    { 1279U, 3073013882UL, 20,40,4294967294UL, 12, 18, 7, 15, 2410968576UL, 3990192128UL,   {0}},
    { 1279U, 2178209915UL, 20,40,4294967294UL, 12, 18, 7, 15, 3662474880UL, 4023877632UL,   {0}},
    { 1279U, 3395311740UL, 20,40,4294967294UL, 12, 18, 7, 15, 2642243456UL, 3998711808UL,   {0}},
    { 1279U, 4199149693UL, 20,40,4294967294UL, 12, 18, 7, 15, 3489061504UL, 4157964288UL,   {0}},
    { 1279U, 3754401918UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480714112UL, 3949297664UL,   {0}},
    { 1279U, 2631735423UL, 20,40,4294967294UL, 12, 18, 7, 15, 1481963136UL, 3990192128UL,   {0}},
    { 1279U, 2228236416UL, 20,40,4294967294UL, 12, 18, 7, 15, 601159552UL, 3981803520UL,   {0}},
    { 1279U, 3795196033UL, 20,40,4294967294UL, 12, 18, 7, 15, 1989507968UL, 3891625984UL,   {0}},
    { 1279U, 4065403010UL, 20,40,4294967294UL, 12, 18, 7, 15, 3109482112UL, 3721756672UL,   {0}},
    { 1279U, 3926354051UL, 20,40,4294967294UL, 12, 18, 7, 15, 3461592960UL, 2002092032UL,   {0}},
    { 1279U, 2348079236UL, 20,40,4294967294UL, 12, 18, 7, 15, 4092947328UL, 1868005376UL,   {0}},
    { 1279U, 4071442565UL, 20,40,4294967294UL, 12, 18, 7, 15, 729116544UL, 3981737984UL,   {0}},
    { 1279U, 3498107014UL, 20,40,4294967294UL, 12, 18, 7, 15, 3315918720UL, 4017586176UL,   {0}},
    { 1279U, 3787376775UL, 20,40,4294967294UL, 12, 18, 7, 15, 1701672832UL, 4158095360UL,   {0}},
    { 1279U, 3836416136UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983835136UL,   {0}},
    { 1279U, 2541109385UL, 20,40,4294967294UL, 12, 18, 7, 15, 3551887232UL, 4115955712UL,   {0}},
    { 1279U, 3877116042UL, 20,40,4294967294UL, 12, 18, 7, 15, 3971308416UL, 2002157568UL,   {0}},
    { 1279U, 3658256523UL, 20,40,4294967294UL, 12, 18, 7, 15, 724922240UL, 3981803520UL,   {0}},
    { 1279U, 2452091020UL, 20,40,4294967294UL, 12, 18, 7, 15, 3150736768UL, 4015489024UL,   {0}},
    { 1279U, 3576799373UL, 20,40,4294967294UL, 12, 18, 7, 15, 2388356992UL, 3977609216UL,   {0}},
    { 1279U, 2304989326UL, 20,40,4294967294UL, 12, 18, 7, 15, 2390062976UL, 3982852096UL,   {0}},
    { 1279U, 2761201807UL, 20,40,4294967294UL, 12, 18, 7, 15, 1507096192UL, 4007100416UL,   {0}},
    { 1279U, 2911137936UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629137792UL, 1878360064UL,   {0}},
    { 1279U, 4287537297UL, 20,40,4294967294UL, 12, 18, 7, 15, 2606529408UL, 4025974784UL,   {0}},
    { 1279U, 2670567570UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706550144UL, 4000808960UL,   {0}},
    { 1279U, 3967101075UL, 20,40,4294967294UL, 12, 18, 7, 15, 3478240000UL, 2079817728UL,   {0}},
    { 1279U, 3161301140UL, 20,40,4294967294UL, 12, 18, 7, 15, 3611618176UL, 4023877632UL,   {0}},
    { 1279U, 2829039765UL, 20,40,4294967294UL, 12, 18, 7, 15, 1941266048UL, 4124540928UL,   {0}},
    { 1279U, 3907999894UL, 20,40,4294967294UL, 12, 18, 7, 15, 2640276608UL, 1876656128UL,   {0}},
    { 1279U, 2933155991UL, 20,40,4294967294UL, 12, 18, 7, 15, 648248192UL, 4157833216UL,   {0}},
    { 1279U, 3978694808UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151158144UL, 4149706752UL,   {0}},
    { 1279U, 3059859609UL, 20,40,4294967294UL, 12, 18, 7, 15, 2631162752UL, 4149706752UL,   {0}},
    { 1279U, 3918850202UL, 20,40,4294967294UL, 12, 18, 7, 15, 3702844544UL, 4024401920UL,   {0}},
    { 1279U, 3279880347UL, 20,40,4294967294UL, 12, 18, 7, 15, 3606408064UL, 1867874304UL,   {0}},
    { 1279U, 3535558812UL, 20,40,4294967294UL, 12, 18, 7, 15, 3002495872UL, 4016799744UL,   {0}},
    { 1279U, 2784475293UL, 20,40,4294967294UL, 12, 18, 7, 15, 3461708672UL, 3874979840UL,   {0}},
    { 1279U, 3904671902UL, 20,40,4294967294UL, 12, 18, 7, 15, 2359127936UL, 4006969344UL,   {0}},
    { 1279U, 4082499743UL, 20,40,4294967294UL, 12, 18, 7, 15, 635270016UL, 4149575680UL,   {0}},
    { 1279U, 4040089760UL, 20,40,4294967294UL, 12, 18, 7, 15, 3438631808UL, 2002157568UL,   {0}},
    { 1279U, 2315696289UL, 20,40,4294967294UL, 12, 18, 7, 15, 2790586240UL, 3990192128UL,   {0}},
    { 1279U, 2233215138UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983900672UL,   {0}},
    { 1279U, 2809194659UL, 20,40,4294967294UL, 12, 18, 7, 15, 3646257024UL, 1851228160UL,   {0}},
    { 1279U, 3795019940UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983835136UL,   {0}},
    { 1279U, 2246348965UL, 20,40,4294967294UL, 12, 18, 7, 15, 2358603648UL, 3999236096UL,   {0}},
    { 1279U, 3585126566UL, 20,40,4294967294UL, 12, 18, 7, 15, 1716877184UL, 4015357952UL,   {0}},
    { 1279U, 4188154023UL, 20,40,4294967294UL, 12, 18, 7, 15, 3738491776UL, 4149575680UL,   {0}},
    { 1279U, 3556710568UL, 20,40,4294967294UL, 12, 18, 7, 15, 1901360768UL, 3990192128UL,   {0}},
    { 1279U, 3830544553UL, 20,40,4294967294UL, 12, 18, 7, 15, 4067915392UL, 1877311488UL,   {0}},
    { 1279U, 2581418154UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557821056UL, 3990192128UL,   {0}},
    { 1279U, 2159804587UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641000064UL, 4025974784UL,   {0}},
    { 1279U, 3697905836UL, 20,40,4294967294UL, 12, 18, 7, 15, 861232896UL, 4126638080UL,   {0}},
    { 1279U, 3632083117UL, 20,40,4294967294UL, 12, 18, 7, 15, 2914499456UL, 2069528576UL,   {0}},
    { 1279U, 3884656814UL, 20,40,4294967294UL, 12, 18, 7, 15, 919958912UL, 4015357952UL,   {0}},
    { 1279U, 3054573743UL, 20,40,4294967294UL, 12, 18, 7, 15, 3434404736UL, 4149575680UL,   {0}},
    { 1279U, 2466463920UL, 20,40,4294967294UL, 12, 18, 7, 15, 855078784UL, 4016406528UL,   {0}},
    { 1279U, 3322747057UL, 20,40,4294967294UL, 12, 18, 7, 15, 3455475072UL, 2002419712UL,   {0}},
    { 1279U, 2494429362UL, 20,40,4294967294UL, 12, 18, 7, 15, 1716961152UL, 4124409856UL,   {0}},
    { 1279U, 3648712883UL, 20,40,4294967294UL, 12, 18, 7, 15, 2883349888UL, 4015489024UL,   {0}},
    { 1279U, 3145408692UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117837056UL, 4015226880UL,   {0}},
    { 1279U, 2523330741UL, 20,40,4294967294UL, 12, 18, 7, 15, 3455475072UL, 2002419712UL,   {0}},
    { 1279U, 2656305334UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470220160UL, 2008252416UL,   {0}},
    { 1279U, 3499450551UL, 20,40,4294967294UL, 12, 18, 7, 15, 1935306368UL, 3990454272UL,   {0}},
    { 1279U, 3866312888UL, 20,40,4294967294UL, 12, 18, 7, 15, 2376431488UL, 4009066496UL,   {0}},
    { 1279U, 4180594873UL, 20,40,4294967294UL, 12, 18, 7, 15, 1901491840UL, 3990192128UL,   {0}},
    { 1279U, 2275045562UL, 20,40,4294967294UL, 12, 18, 7, 15, 1221883520UL, 4002906112UL,   {0}},
    { 1279U, 2598195387UL, 20,40,4294967294UL, 12, 18, 7, 15, 2010479488UL, 4015357952UL,   {0}},
    { 1279U, 3617575100UL, 20,40,4294967294UL, 12, 18, 7, 15, 3438638976UL, 3999760384UL,   {0}},
    { 1279U, 3298793661UL, 20,40,4294967294UL, 12, 18, 7, 15, 3116686208UL, 4149575680UL,   {0}},
    { 1279U, 3001639102UL, 20,40,4294967294UL, 12, 18, 7, 15, 863335296UL, 4016930816UL,   {0}},
    { 1279U, 2149529791UL, 20,40,4294967294UL, 12, 18, 7, 15, 3469826944UL, 2069200896UL,   {0}},
    { 1279U, 3780622528UL, 20,40,4294967294UL, 12, 18, 7, 15, 920057728UL, 4015357952UL,   {0}},
    { 1279U, 2624919745UL, 20,40,4294967294UL, 12, 18, 7, 15, 842363776UL, 4016865280UL,   {0}},
    { 1279U, 3061876930UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629072256UL, 4025843712UL,   {0}},
    { 1279U, 3676299459UL, 20,40,4294967294UL, 12, 18, 7, 15, 1848998784UL, 3882188800UL,   {0}},
    { 1279U, 3436196036UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983835136UL,   {0}},
    { 1279U, 3522908357UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480582016UL, 3982852096UL,   {0}},
    { 1279U, 2241482950UL, 20,40,4294967294UL, 12, 18, 7, 15, 4074073472UL, 1867874304UL,   {0}},
    { 1279U, 2918676679UL, 20,40,4294967294UL, 12, 18, 7, 15, 920057216UL, 4023746560UL,   {0}},
    { 1279U, 2973843656UL, 20,40,4294967294UL, 12, 18, 7, 15, 3948262144UL, 2010611712UL,   {0}},
    { 1279U, 3443153097UL, 20,40,4294967294UL, 12, 18, 7, 15, 2631233280UL, 4006969344UL,   {0}},
    { 1279U, 2167394506UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117837056UL, 4015226880UL,   {0}},
    { 1279U, 2818965707UL, 20,40,4294967294UL, 12, 18, 7, 15, 2648863616UL, 4148920320UL,   {0}},
    { 1279U, 3093506252UL, 20,40,4294967294UL, 12, 18, 7, 15, 2750182272UL, 4017520640UL,   {0}},
    { 1279U, 2678550733UL, 20,40,4294967294UL, 12, 18, 7, 15, 3116788480UL, 4015226880UL,   {0}},
    { 1279U, 2510766286UL, 20,40,4294967294UL, 12, 18, 7, 15, 1716877184UL, 4015357952UL,   {0}},
    { 1279U, 3692642511UL, 20,40,4294967294UL, 12, 18, 7, 15, 3602344832UL, 1867677696UL,   {0}},
    { 1279U, 2429456592UL, 20,40,4294967294UL, 12, 18, 7, 15, 3950336640UL, 2010415104UL,   {0}},
    { 1279U, 2989385937UL, 20,40,4294967294UL, 12, 18, 7, 15, 3704976256UL, 2008514560UL,   {0}},
    { 1279U, 3709919442UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117870976UL, 3980754944UL,   {0}},
    { 1279U, 4145137875UL, 20,40,4294967294UL, 12, 18, 7, 15, 1238824832UL, 4015357952UL,   {0}},
    { 1279U, 3662670036UL, 20,40,4294967294UL, 12, 18, 7, 15, 766868864UL, 4157964288UL,   {0}},
    { 1279U, 2965854421UL, 20,40,4294967294UL, 12, 18, 7, 15, 3184810880UL, 4136861696UL,   {0}},
    { 1279U, 4242911446UL, 20,40,4294967294UL, 12, 18, 7, 15, 2608165504UL, 2010480640UL,   {0}},
    { 1279U, 2983905495UL, 20,40,4294967294UL, 12, 18, 7, 15, 1247737472UL, 3990192128UL,   {0}},
    { 1279U, 2406586584UL, 20,40,4294967294UL, 12, 18, 7, 15, 3721721728UL, 4017586176UL,   {0}},
    { 1279U, 2303930585UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480582016UL, 3982852096UL,   {0}},
    { 1279U, 2694969562UL, 20,40,4294967294UL, 12, 18, 7, 15, 2935289728UL, 4149706752UL,   {0}},
    { 1279U, 3611295963UL, 20,40,4294967294UL, 12, 18, 7, 15, 1721072512UL, 4017979392UL,   {0}},
    { 1279U, 2229321948UL, 20,40,4294967294UL, 12, 18, 7, 15, 3564469120UL, 3881205760UL,   {0}},
    { 1279U, 3701326045UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641719168UL, 3998580736UL,   {0}},
    { 1279U, 2897760478UL, 20,40,4294967294UL, 12, 18, 7, 15, 3118951296UL, 1867743232UL,   {0}},
    { 1279U, 4234639583UL, 20,40,4294967294UL, 12, 18, 7, 15, 3139810176UL, 2002092032UL,   {0}},
    { 1279U, 3701817568UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627497344UL, 4023746560UL,   {0}},
    { 1279U, 3768250593UL, 20,40,4294967294UL, 12, 18, 7, 15, 779582336UL, 4157833216UL,   {0}},
    { 1279U, 3682414818UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983900672UL,   {0}},
    { 1279U, 2640500963UL, 20,40,4294967294UL, 12, 18, 7, 15, 1742042752UL, 3990192128UL,   {0}},
    { 1279U, 4290164964UL, 20,40,4294967294UL, 12, 18, 7, 15, 2765386624UL, 4015489024UL,   {0}},
    { 1279U, 3699118309UL, 20,40,4294967294UL, 12, 18, 7, 15, 3590156160UL, 3998580736UL,   {0}},
    { 1279U, 3941224678UL, 20,40,4294967294UL, 12, 18, 7, 15, 3453793152UL, 4149575680UL,   {0}},
    { 1279U, 2425125095UL, 20,40,4294967294UL, 12, 18, 7, 15, 3476387712UL, 3982852096UL,   {0}},
    { 1279U, 2909747432UL, 20,40,4294967294UL, 12, 18, 7, 15, 1713732480UL, 4016930816UL,   {0}},
    { 1279U, 2582474985UL, 20,40,4294967294UL, 12, 18, 7, 15, 884273024UL, 3990323200UL,   {0}},
    { 1279U, 3452512490UL, 20,40,4294967294UL, 12, 18, 7, 15, 1726838656UL, 4149706752UL,   {0}},
    { 1279U, 3119644907UL, 20,40,4294967294UL, 12, 18, 7, 15, 2639558528UL, 4007100416UL,   {0}},
    { 1279U, 2486499564UL, 20,40,4294967294UL, 12, 18, 7, 15, 3992284032UL, 2069200896UL,   {0}},
    { 1279U, 3218012397UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470228352UL, 3881140224UL,   {0}},
    { 1279U, 2514307310UL, 20,40,4294967294UL, 12, 18, 7, 15, 2547496576UL, 4124540928UL,   {0}},
    { 1279U, 3903641839UL, 20,40,4294967294UL, 12, 18, 7, 15, 3135139200UL, 4014702592UL,   {0}},
    { 1279U, 4160610544UL, 20,40,4294967294UL, 12, 18, 7, 15, 2375904896UL, 4007100416UL,   {0}},
    { 1279U, 4172427505UL, 20,40,4294967294UL, 12, 18, 7, 15, 3008683264UL, 4126638080UL,   {0}},
    { 1279U, 3092414706UL, 20,40,4294967294UL, 12, 18, 7, 15, 3704941184UL, 4019552256UL,   {0}},
    { 1279U, 4285137139UL, 20,40,4294967294UL, 12, 18, 7, 15, 601159040UL, 4015489024UL,   {0}},
    { 1279U, 2208698612UL, 20,40,4294967294UL, 12, 18, 7, 15, 638941056UL, 4015489024UL,   {0}},
    { 1279U, 3627841781UL, 20,40,4294967294UL, 12, 18, 7, 15, 1020615552UL, 4149575680UL,   {0}},
    { 1279U, 2955999478UL, 20,40,4294967294UL, 12, 18, 7, 15, 1932882816UL, 4016865280UL,   {0}},
    { 1279U, 2912481527UL, 20,40,4294967294UL, 12, 18, 7, 15, 958066304UL, 3721494528UL,   {0}},
    { 1279U, 2393010424UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117738880UL, 4015357952UL,   {0}},
    { 1279U, 4195408121UL, 20,40,4294967294UL, 12, 18, 7, 15, 3114625920UL, 1866825728UL,   {0}},
    { 1279U, 3987126522UL, 20,40,4294967294UL, 12, 18, 7, 15, 3210014080UL, 3992289280UL,   {0}},
    { 1279U, 2264137979UL, 20,40,4294967294UL, 12, 18, 7, 15, 3486219136UL, 3881140224UL,   {0}},
    { 1279U, 2262331644UL, 20,40,4294967294UL, 12, 18, 7, 15, 3386177408UL, 4015489024UL,   {0}},
    { 1279U, 2637011197UL, 20,40,4294967294UL, 12, 18, 7, 15, 1716877184UL, 4015357952UL,   {0}},
    { 1279U, 2519943422UL, 20,40,4294967294UL, 12, 18, 7, 15, 2644405632UL, 4015751168UL,   {0}},
    { 1279U, 2855393535UL, 20,40,4294967294UL, 12, 18, 7, 15, 2598859520UL, 2010873856UL,   {0}},
    { 1279U, 3633600768UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557821056UL, 3990192128UL,   {0}},
    { 1279U, 3525607681UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151846784UL, 2001174528UL,   {0}},
    { 1279U, 4236769538UL, 20,40,4294967294UL, 12, 18, 7, 15, 3704806272UL, 4153901056UL,   {0}},
    { 1279U, 3432290563UL, 20,40,4294967294UL, 12, 18, 7, 15, 2312862592UL, 4015095808UL,   {0}},
    { 1279U, 3456796932UL, 20,40,4294967294UL, 12, 18, 7, 15, 1289075584UL, 4149641216UL,   {0}},
    { 1279U, 2453451013UL, 20,40,4294967294UL, 12, 18, 7, 15, 1958576000UL, 3991633920UL,   {0}},
    { 1279U, 4248148230UL, 20,40,4294967294UL, 12, 18, 7, 15, 2644274560UL, 4023746560UL,   {0}},
    { 1279U, 2858508551UL, 20,40,4294967294UL, 12, 18, 7, 15, 1983216512UL, 3882123264UL,   {0}},
    { 1279U, 3252961544UL, 20,40,4294967294UL, 12, 18, 7, 15, 2406840192UL, 3983245312UL,   {0}},
    { 1279U, 3931703561UL, 20,40,4294967294UL, 12, 18, 7, 15, 729116544UL, 3981737984UL,   {0}},
    { 1279U, 3132733706UL, 20,40,4294967294UL, 12, 18, 7, 15, 4015372928UL, 2010480640UL,   {0}},
    { 1279U, 2346858763UL, 20,40,4294967294UL, 12, 18, 7, 15, 3466050432UL, 2001895424UL,   {0}},
    { 1279U, 4088164620UL, 20,40,4294967294UL, 12, 18, 7, 15, 2748607360UL, 4015489024UL,   {0}},
    { 1279U, 2815406349UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480451968UL, 3880878080UL,   {0}},
    { 1279U, 4228425998UL, 20,40,4294967294UL, 12, 18, 7, 15, 2337568384UL, 3990192128UL,   {0}},
    { 1279U, 2222942479UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117636224UL, 2006024192UL,   {0}},
    { 1279U, 3923984656UL, 20,40,4294967294UL, 12, 18, 7, 15, 903313280UL, 3981803520UL,   {0}},
    { 1279U, 4280305937UL, 20,40,4294967294UL, 12, 18, 7, 15, 919959424UL, 3998580736UL,   {0}},
    { 1279U, 3251417362UL, 20,40,4294967294UL, 12, 18, 7, 15, 3969235584UL, 2010480640UL,   {0}},
    { 1279U, 2905313555UL, 20,40,4294967294UL, 12, 18, 7, 15, 2607577728UL, 4025778176UL,   {0}},
    { 1279U, 3989135636UL, 20,40,4294967294UL, 12, 18, 7, 15, 1425305472UL, 3981934592UL,   {0}},
    { 1279U, 3176943893UL, 20,40,4294967294UL, 12, 18, 7, 15, 867496832UL, 4024401920UL,   {0}},
    { 1279U, 3771138326UL, 20,40,4294967294UL, 12, 18, 7, 15, 1574369152UL, 4015357952UL,   {0}},
    { 1279U, 2817061143UL, 20,40,4294967294UL, 12, 18, 7, 15, 3115805568UL, 1863548928UL,   {0}},
    { 1279U, 2864640280UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151818112UL, 4015489024UL,   {0}},
    { 1279U, 4283808025UL, 20,40,4294967294UL, 12, 18, 7, 15, 2406840192UL, 3982852096UL,   {0}},
    { 1279U, 3276513562UL, 20,40,4294967294UL, 12, 18, 7, 15, 3593792128UL, 4023681024UL,   {0}},
    { 1279U, 3231404315UL, 20,40,4294967294UL, 12, 18, 7, 15, 3472317312UL, 2001960960UL,   {0}},
    { 1279U, 2311588124UL, 20,40,4294967294UL, 12, 18, 7, 15, 3438116736UL, 3849682944UL,   {0}},
    { 1279U, 3303624989UL, 20,40,4294967294UL, 12, 18, 7, 15, 2580855680UL, 2002092032UL,   {0}},
    { 1279U, 3022082334UL, 20,40,4294967294UL, 12, 18, 7, 15, 729116544UL, 3981737984UL,   {0}},
    { 1279U, 3265583391UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627496576UL, 4024008704UL,   {0}},
    { 1279U, 3851235616UL, 20,40,4294967294UL, 12, 18, 7, 15, 836169600UL, 3981803520UL,   {0}},
    { 1279U, 2496397601UL, 20,40,4294967294UL, 12, 18, 7, 15, 2580855680UL, 4149510144UL,   {0}},
    { 1279U, 3347429666UL, 20,40,4294967294UL, 12, 18, 7, 15, 2506979200UL, 3866525696UL,   {0}},
    { 1279U, 2915774755UL, 20,40,4294967294UL, 12, 18, 7, 15, 2344054400UL, 3986128896UL,   {0}},
    { 1279U, 3339503908UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117870976UL, 3981803520UL,   {0}},
    { 1279U, 2184952101UL, 20,40,4294967294UL, 12, 18, 7, 15, 3571248512UL, 4015489024UL,   {0}},
    { 1279U, 3410260262UL, 20,40,4294967294UL, 12, 18, 7, 15, 3714938752UL, 4000743424UL,   {0}},
    { 1279U, 2213763367UL, 20,40,4294967294UL, 12, 18, 7, 15, 3704715008UL, 3981803520UL,   {0}},
    { 1279U, 2375342376UL, 20,40,4294967294UL, 12, 18, 7, 15, 601550720UL, 3982065664UL,   {0}},
    { 1279U, 2553469225UL, 20,40,4294967294UL, 12, 18, 7, 15, 3149716352UL, 4149313536UL,   {0}},
    { 1279U, 2683246890UL, 20,40,4294967294UL, 12, 18, 7, 15, 2573959040UL, 3992027136UL,   {0}},
    { 1279U, 2748750123UL, 20,40,4294967294UL, 12, 18, 7, 15, 3113970560UL, 1866694656UL,   {0}},
    { 1279U, 3389364524UL, 20,40,4294967294UL, 12, 18, 7, 15, 4076303232UL, 1869250560UL,   {0}},
    { 1279U, 3017765165UL, 20,40,4294967294UL, 12, 18, 7, 15, 3704937088UL, 4157702144UL,   {0}},
    { 1279U, 2550982958UL, 20,40,4294967294UL, 12, 18, 7, 15, 3701271424UL, 4023877632UL,   {0}},
    { 1279U, 2809753903UL, 20,40,4294967294UL, 12, 18, 7, 15, 3612666752UL, 4023353344UL,   {0}},
    { 1279U, 4127277360UL, 20,40,4294967294UL, 12, 18, 7, 15, 1726838656UL, 4149706752UL,   {0}},
    { 1279U, 4248572209UL, 20,40,4294967294UL, 12, 18, 7, 15, 1855306368UL, 4157964288UL,   {0}},
    { 1279U, 2841336114UL, 20,40,4294967294UL, 12, 18, 7, 15, 577599360UL, 3983900672UL,   {0}},
    { 1279U, 3474143539UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151814016UL, 4148658176UL,   {0}},
    { 1279U, 2553174324UL, 20,40,4294967294UL, 12, 18, 7, 15, 749566848UL, 3883237376UL,   {0}},
    { 1279U, 4135160117UL, 20,40,4294967294UL, 12, 18, 7, 15, 3463804800UL, 3982852096UL,   {0}},
    { 1279U, 2819096886UL, 20,40,4294967294UL, 12, 18, 7, 15, 3437948800UL, 4015357952UL,   {0}},
    { 1279U, 3206900023UL, 20,40,4294967294UL, 12, 18, 7, 15, 664598400UL, 3989536768UL,   {0}},
    { 1279U, 3570340152UL, 20,40,4294967294UL, 12, 18, 7, 15, 3654645632UL, 4006969344UL,   {0}},
    { 1279U, 4193509689UL, 20,40,4294967294UL, 12, 18, 7, 15, 2575591808UL, 4023877632UL,   {0}},
    { 1279U, 4149363002UL, 20,40,4294967294UL, 12, 18, 7, 15, 1861581696UL, 4149575680UL,   {0}},
    { 1279U, 2289629499UL, 20,40,4294967294UL, 12, 18, 7, 15, 1973122944UL, 3883368448UL,   {0}},
    { 1279U, 3294048572UL, 20,40,4294967294UL, 12, 18, 7, 15, 3455475072UL, 2002419712UL,   {0}},
    { 1279U, 2574788925UL, 20,40,4294967294UL, 12, 18, 7, 15, 729117440UL, 4158095360UL,   {0}},
    { 1279U, 3348478270UL, 20,40,4294967294UL, 12, 18, 7, 15, 1693283712UL, 4149706752UL,   {0}},
    { 1279U, 3149988159UL, 20,40,4294967294UL, 12, 18, 7, 15, 584513408UL, 4015357952UL,   {0}},
    { 1279U, 2207787328UL, 20,40,4294967294UL, 12, 18, 7, 15, 2406971264UL, 3982852096UL,   {0}},
    { 1279U, 2548459841UL, 20,40,4294967294UL, 12, 18, 7, 15, 3488930432UL, 4157964288UL,   {0}},
    { 1279U, 3710091586UL, 20,40,4294967294UL, 12, 18, 7, 15, 2876601088UL, 2010611712UL,   {0}},
    { 1279U, 2245460291UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706550144UL, 3983900672UL,   {0}},
    { 1279U, 2979590468UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627497088UL, 4023877632UL,   {0}},
    { 1279U, 3526052165UL, 20,40,4294967294UL, 12, 18, 7, 15, 937343616UL, 4086661120UL,   {0}},
    { 1279U, 3259584838UL, 20,40,4294967294UL, 12, 18, 7, 15, 3489101696UL, 3982852096UL,   {0}},
    { 1279U, 3971248455UL, 20,40,4294967294UL, 12, 18, 7, 15, 3421854592UL, 2002223104UL,   {0}},
    { 1279U, 2861898056UL, 20,40,4294967294UL, 12, 18, 7, 15, 3150736768UL, 4015489024UL,   {0}},
    { 1279U, 2879674697UL, 20,40,4294967294UL, 12, 18, 7, 15, 1985375104UL, 4017455104UL,   {0}},
    { 1279U, 3081668938UL, 20,40,4294967294UL, 12, 18, 7, 15, 2640272512UL, 2010873856UL,   {0}},
    { 1279U, 2735827275UL, 20,40,4294967294UL, 12, 18, 7, 15, 2555672192UL, 3990192128UL,   {0}},
    { 1279U, 2987350348UL, 20,40,4294967294UL, 12, 18, 7, 15, 2494396288UL, 3874848768UL,   {0}},
    { 1279U, 3543533901UL, 20,40,4294967294UL, 12, 18, 7, 15, 3714938752UL, 4000808960UL,   {0}},
    { 1279U, 3576088910UL, 20,40,4294967294UL, 12, 18, 7, 15, 2252630400UL, 4023877632UL,   {0}},
    { 1279U, 3610917199UL, 20,40,4294967294UL, 12, 18, 7, 15, 3488897920UL, 2002157568UL,   {0}},
    { 1279U, 2291835216UL, 20,40,4294967294UL, 12, 18, 7, 15, 1322629760UL, 4157964288UL,   {0}},
    { 1279U, 3050791249UL, 20,40,4294967294UL, 12, 18, 7, 15, 1794471808UL, 4149706752UL,   {0}},
    { 1279U, 4089461074UL, 20,40,4294967294UL, 12, 18, 7, 15, 837647232UL, 3883237376UL,   {0}},
    { 1279U, 4146282835UL, 20,40,4294967294UL, 12, 18, 7, 15, 1716877184UL, 4015357952UL,   {0}},
    { 1279U, 3877990740UL, 20,40,4294967294UL, 12, 18, 7, 15, 1481963136UL, 3990192128UL,   {0}},
    { 1279U, 4184211797UL, 20,40,4294967294UL, 12, 18, 7, 15, 2935125632UL, 4158095360UL,   {0}},
    { 1279U, 2715679062UL, 20,40,4294967294UL, 12, 18, 7, 15, 3149192064UL, 4149575680UL,   {0}},
    { 1279U, 3128144215UL, 20,40,4294967294UL, 12, 18, 7, 15, 3983765120UL, 2077589504UL,   {0}},
    { 1279U, 3167996248UL, 20,40,4294967294UL, 12, 18, 7, 15, 2648468864UL, 4019552256UL,   {0}},
    { 1279U, 3896701273UL, 20,40,4294967294UL, 12, 18, 7, 15, 1666476928UL, 4015357952UL,   {0}},
    { 1279U, 2571313498UL, 20,40,4294967294UL, 12, 18, 7, 15, 2649191296UL, 1870364672UL,   {0}},
    { 1279U, 2389504347UL, 20,40,4294967294UL, 12, 18, 7, 15, 3050658688UL, 2069069824UL,   {0}},
    { 1279U, 3557161308UL, 20,40,4294967294UL, 12, 18, 7, 15, 1716877056UL, 4006903808UL,   {0}},
    { 1279U, 2609643869UL, 20,40,4294967294UL, 12, 18, 7, 15, 651621760UL, 4023746560UL,   {0}},
    { 1279U, 3132004702UL, 20,40,4294967294UL, 12, 18, 7, 15, 3109482112UL, 3721756672UL,   {0}},
    { 1279U, 3015424351UL, 20,40,4294967294UL, 12, 18, 7, 15, 701852544UL, 4015357952UL,   {0}},
    { 1279U, 2837348704UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557428096UL, 3981672448UL,   {0}},
    { 1279U, 3366904161UL, 20,40,4294967294UL, 12, 18, 7, 15, 2002024064UL, 4007100416UL,   {0}},
    { 1279U, 3097882978UL, 20,40,4294967294UL, 12, 18, 7, 15, 1840610688UL, 4158488576UL,   {0}},
    { 1279U, 2363861347UL, 20,40,4294967294UL, 12, 18, 7, 15, 3477830528UL, 3881140224UL,   {0}},
    { 1279U, 2975795556UL, 20,40,4294967294UL, 12, 18, 7, 15, 3135041408UL, 4014440448UL,   {0}},
    { 1279U, 2971105637UL, 20,40,4294967294UL, 12, 18, 7, 15, 1853193088UL, 3889528832UL,   {0}},
    { 1279U, 3390835046UL, 20,40,4294967294UL, 12, 18, 7, 15, 3739147136UL, 4153638912UL,   {0}},
    { 1279U, 2579159399UL, 20,40,4294967294UL, 12, 18, 7, 15, 1905686144UL, 3990192128UL,   {0}},
    { 1279U, 3401978216UL, 20,40,4294967294UL, 12, 18, 7, 15, 2778819968UL, 2077589504UL,   {0}},
    { 1279U, 3096172905UL, 20,40,4294967294UL, 12, 18, 7, 15, 861233024UL, 4126638080UL,   {0}},
    { 1279U, 2663741802UL, 20,40,4294967294UL, 12, 18, 7, 15, 1742042752UL, 4124409856UL,   {0}},
    { 1279U, 4025497963UL, 20,40,4294967294UL, 12, 18, 7, 15, 2545384320UL, 3873800192UL,   {0}},
    { 1279U, 4227596652UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983900672UL,   {0}},
    { 1279U, 3523185005UL, 20,40,4294967294UL, 12, 18, 7, 15, 3453070720UL, 2069200896UL,   {0}},
    { 1279U, 3344408942UL, 20,40,4294967294UL, 12, 18, 7, 15, 1187442560UL, 3981803520UL,   {0}},
    { 1279U, 3332184431UL, 20,40,4294967294UL, 12, 18, 7, 15, 2304146304UL, 4025188352UL,   {0}},
    { 1279U, 2687121776UL, 20,40,4294967294UL, 12, 18, 7, 15, 2910679808UL, 2010480640UL,   {0}},
    { 1279U, 3969026417UL, 20,40,4294967294UL, 12, 18, 7, 15, 2798974848UL, 3981803520UL,   {0}},
    { 1279U, 4155799922UL, 20,40,4294967294UL, 12, 18, 7, 15, 3447027584UL, 3999694848UL,   {0}},
    { 1279U, 4266461555UL, 20,40,4294967294UL, 12, 18, 7, 15, 1716877056UL, 4006903808UL,   {0}},
    { 1279U, 3967060340UL, 20,40,4294967294UL, 12, 18, 7, 15, 735768448UL, 3981541376UL,   {0}},
    { 1279U, 2274292085UL, 20,40,4294967294UL, 12, 18, 7, 15, 1423634304UL, 3981541376UL,   {0}},
    { 1279U, 4185172342UL, 20,40,4294967294UL, 12, 18, 7, 15, 1701804928UL, 3957686272UL,   {0}},
    { 1279U, 4220770679UL, 20,40,4294967294UL, 12, 18, 7, 15, 719288192UL, 4148920320UL,   {0}},
    { 1279U, 3295474040UL, 20,40,4294967294UL, 12, 18, 7, 15, 3556601216UL, 1867874304UL,   {0}},
    { 1279U, 3128754553UL, 20,40,4294967294UL, 12, 18, 7, 15, 1574369152UL, 4015357952UL,   {0}},
    { 1279U, 3107289466UL, 20,40,4294967294UL, 12, 18, 7, 15, 1179937664UL, 4014309376UL,   {0}},
    { 1279U, 2173585787UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151158144UL, 4149706752UL,   {0}},
    { 1279U, 4025504124UL, 20,40,4294967294UL, 12, 18, 7, 15, 1322579840UL, 3981803520UL,   {0}},
    { 1279U, 2178232701UL, 20,40,4294967294UL, 12, 18, 7, 15, 594376576UL, 3983900672UL,   {0}},
    { 1279U, 3087387006UL, 20,40,4294967294UL, 12, 18, 7, 15, 3612666752UL, 4023877632UL,   {0}},
    { 1279U, 3595139455UL, 20,40,4294967294UL, 12, 18, 7, 15, 2803168896UL, 3990192128UL,   {0}},
    { 1279U, 2407506304UL, 20,40,4294967294UL, 12, 18, 7, 15, 3453858432UL, 2010480640UL,   {0}},
    { 1279U, 4047374721UL, 20,40,4294967294UL, 12, 18, 7, 15, 1905555072UL, 3990585344UL,   {0}},
    { 1279U, 2825499010UL, 20,40,4294967294UL, 12, 18, 7, 15, 3950336896UL, 2002092032UL,   {0}},
    { 1279U, 4034650499UL, 20,40,4294967294UL, 12, 18, 7, 15, 651622272UL, 4015357952UL,   {0}},
    { 1279U, 4196671876UL, 20,40,4294967294UL, 12, 18, 7, 15, 1840741760UL, 4158488576UL,   {0}},
    { 1279U, 2997447045UL, 20,40,4294967294UL, 12, 18, 7, 15, 3488963456UL, 2002157568UL,   {0}},
    { 1279U, 2819842438UL, 20,40,4294967294UL, 12, 18, 7, 15, 3689706368UL, 2002092032UL,   {0}},
    { 1279U, 3242131847UL, 20,40,4294967294UL, 12, 18, 7, 15, 2646890752UL, 4158095360UL,   {0}},
    { 1279U, 2836431240UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470179200UL, 4153901056UL,   {0}},
    { 1279U, 4098544009UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641849472UL, 1876656128UL,   {0}},
    { 1279U, 3403841930UL, 20,40,4294967294UL, 12, 18, 7, 15, 3019142016UL, 4016537600UL,   {0}},
    { 1279U, 3587402123UL, 20,40,4294967294UL, 12, 18, 7, 15, 3166464896UL, 4011294720UL,   {0}},
    { 1279U, 3954534796UL, 20,40,4294967294UL, 12, 18, 7, 15, 3597986432UL, 4023681024UL,   {0}},
    { 1279U, 3086692749UL, 20,40,4294967294UL, 12, 18, 7, 15, 1666479744UL, 3990192128UL,   {0}},
    { 1279U, 4275972494UL, 20,40,4294967294UL, 12, 18, 7, 15, 2876562176UL, 4157964288UL,   {0}},
    { 1279U, 2813784463UL, 20,40,4294967294UL, 12, 18, 7, 15, 1901361024UL, 3981672448UL,   {0}},
    { 1279U, 2692866448UL, 20,40,4294967294UL, 12, 18, 7, 15, 2573163264UL, 2010349568UL,   {0}},
    { 1279U, 3476803985UL, 20,40,4294967294UL, 12, 18, 7, 15, 2390194048UL, 3982852096UL,   {0}},
    { 1279U, 3173374354UL, 20,40,4294967294UL, 12, 18, 7, 15, 2358996864UL, 4007624704UL,   {0}},
    { 1279U, 2617698707UL, 20,40,4294967294UL, 12, 18, 7, 15, 3469925248UL, 4149444608UL,   {0}},
    { 1279U, 2248698260UL, 20,40,4294967294UL, 12, 18, 7, 15, 3864325760UL, 3721756672UL,   {0}},
    { 1279U, 2852116885UL, 20,40,4294967294UL, 12, 18, 7, 15, 3451171712UL, 4149575680UL,   {0}},
    { 1279U, 3193155990UL, 20,40,4294967294UL, 12, 18, 7, 15, 3992280448UL, 2011004928UL,   {0}},
    { 1279U, 2858166679UL, 20,40,4294967294UL, 12, 18, 7, 15, 1289019264UL, 4116021248UL,   {0}},
    { 1279U, 3425198488UL, 20,40,4294967294UL, 12, 18, 7, 15, 1934915200UL, 4007100416UL,   {0}},
    { 1279U, 3940489625UL, 20,40,4294967294UL, 12, 18, 7, 15, 2643962752UL, 2068545536UL,   {0}},
    { 1279U, 3177943450UL, 20,40,4294967294UL, 12, 18, 7, 15, 2404742912UL, 3981803520UL,   {0}},
    { 1279U, 2708341147UL, 20,40,4294967294UL, 12, 18, 7, 15, 1721040512UL, 3537600512UL,   {0}},
    { 1279U, 3336479132UL, 20,40,4294967294UL, 12, 18, 7, 15, 2648468736UL, 4023746560UL,   {0}},
    { 1279U, 2894301597UL, 20,40,4294967294UL, 12, 18, 7, 15, 637367168UL, 4149575680UL,   {0}},
    { 1279U, 3755946398UL, 20,40,4294967294UL, 12, 18, 7, 15, 3430120320UL, 3881140224UL,   {0}},
    { 1279U, 3857551775UL, 20,40,4294967294UL, 12, 18, 7, 15, 1716877184UL, 4160716800UL,   {0}},
    { 1279U, 2305438112UL, 20,40,4294967294UL, 12, 18, 7, 15, 2918381440UL, 4149706752UL,   {0}},
    { 1279U, 2435436961UL, 20,40,4294967294UL, 12, 18, 7, 15, 2360702848UL, 4009066496UL,   {0}},
    { 1279U, 3215382946UL, 20,40,4294967294UL, 12, 18, 7, 15, 3646257024UL, 1851228160UL,   {0}},
    { 1279U, 3346540963UL, 20,40,4294967294UL, 12, 18, 7, 15, 3142802816UL, 2009956352UL,   {0}},
    { 1279U, 3444582820UL, 20,40,4294967294UL, 12, 18, 7, 15, 1289075328UL, 4157964288UL,   {0}},
    { 1279U, 4260606373UL, 20,40,4294967294UL, 12, 18, 7, 15, 3444889344UL, 4157833216UL,   {0}},
    { 1279U, 2964007334UL, 20,40,4294967294UL, 12, 18, 7, 15, 729640320UL, 4023746560UL,   {0}},
    { 1279U, 4290871719UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557460864UL, 3981803520UL,   {0}},
    { 1279U, 3858756008UL, 20,40,4294967294UL, 12, 18, 7, 15, 3486734208UL, 1991606272UL,   {0}},
    { 1279U, 2165225897UL, 20,40,4294967294UL, 12, 18, 7, 15, 3486997376UL, 2069200896UL,   {0}},
    { 1279U, 3292334506UL, 20,40,4294967294UL, 12, 18, 7, 15, 1987410816UL, 4016930816UL,   {0}},
    { 1279U, 2359263659UL, 20,40,4294967294UL, 12, 18, 7, 15, 899610496UL, 3990192128UL,   {0}},
    { 1279U, 3558189484UL, 20,40,4294967294UL, 12, 18, 7, 15, 3713496960UL, 4023877632UL,   {0}},
    { 1279U, 3766041005UL, 20,40,4294967294UL, 12, 18, 7, 15, 2649518720UL, 1878360064UL,   {0}},
    { 1279U, 3654160814UL, 20,40,4294967294UL, 12, 18, 7, 15, 2729374592UL, 4025843712UL,   {0}},
    { 1279U, 3075056047UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706025344UL, 2002092032UL,   {0}},
    { 1279U, 3748252080UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983900672UL,   {0}},
    { 1279U, 3756695985UL, 20,40,4294967294UL, 12, 18, 7, 15, 919959424UL, 4015357952UL,   {0}},
    { 1279U, 2775941554UL, 20,40,4294967294UL, 12, 18, 7, 15, 829873024UL, 4157964288UL,   {0}},
    { 1279U, 3222866355UL, 20,40,4294967294UL, 12, 18, 7, 15, 2572376960UL, 2010349568UL,   {0}},
    { 1279U, 2680226228UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641196928UL, 4000743424UL,   {0}},
    { 1279U, 3204276661UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641261440UL, 4026236928UL,   {0}},
    { 1279U, 2564553142UL, 20,40,4294967294UL, 12, 18, 7, 15, 1554708096UL, 3990192128UL,   {0}},
    { 1279U, 4266918327UL, 20,40,4294967294UL, 12, 18, 7, 15, 2648529536UL, 2077589504UL,   {0}},
    { 1279U, 3617315256UL, 20,40,4294967294UL, 12, 18, 7, 15, 3942478720UL, 2002092032UL,   {0}},
    { 1279U, 4057514425UL, 20,40,4294967294UL, 12, 18, 7, 15, 2371321728UL, 3881664512UL,   {0}},
    { 1279U, 4230937018UL, 20,40,4294967294UL, 12, 18, 7, 15, 615349120UL, 4017455104UL,   {0}},
    { 1279U, 3415509435UL, 20,40,4294967294UL, 12, 18, 7, 15, 3115637632UL, 4149313536UL,   {0}},
    { 1279U, 3238351292UL, 20,40,4294967294UL, 12, 18, 7, 15, 2645915520UL, 4009066496UL,   {0}},
    { 1279U, 2905027005UL, 20,40,4294967294UL, 12, 18, 7, 15, 3017469312UL, 4016013312UL,   {0}},
    { 1279U, 2470853054UL, 20,40,4294967294UL, 12, 18, 7, 15, 3067410304UL, 4015357952UL,   {0}},
    { 1279U, 3755004351UL, 20,40,4294967294UL, 12, 18, 7, 15, 859665280UL, 4016406528UL,   {0}},
    { 1279U, 2457399744UL, 20,40,4294967294UL, 12, 18, 7, 15, 2580903296UL, 1867874304UL,   {0}},
    { 1279U, 3643738561UL, 20,40,4294967294UL, 12, 18, 7, 15, 651622272UL, 4015357952UL,   {0}},
    { 1279U, 3604246978UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151813504UL, 4149313536UL,   {0}},
    { 1279U, 2461536707UL, 20,40,4294967294UL, 12, 18, 7, 15, 1553264256UL, 3990192128UL,   {0}},
    { 1279U, 2216909252UL, 20,40,4294967294UL, 12, 18, 7, 15, 3672037760UL, 4153638912UL,   {0}},
    { 1279U, 3425245637UL, 20,40,4294967294UL, 12, 18, 7, 15, 2398509952UL, 2001960960UL,   {0}},
    { 1279U, 4133145030UL, 20,40,4294967294UL, 12, 18, 7, 15, 2377480064UL, 4009066496UL,   {0}},
    { 1279U, 3986196935UL, 20,40,4294967294UL, 12, 18, 7, 15, 1481931648UL, 3948249088UL,   {0}},
    { 1279U, 3908428232UL, 20,40,4294967294UL, 12, 18, 7, 15, 4009063808UL, 2001829888UL,   {0}},
    { 1279U, 2943343049UL, 20,40,4294967294UL, 12, 18, 7, 15, 3463674752UL, 3949297664UL,   {0}},
    { 1279U, 3153031626UL, 20,40,4294967294UL, 12, 18, 7, 15, 3051255424UL, 3990192128UL,   {0}},
    { 1279U, 3591621067UL, 20,40,4294967294UL, 12, 18, 7, 15, 1666479744UL, 3990192128UL,   {0}},
    { 1279U, 3676783052UL, 20,40,4294967294UL, 12, 18, 7, 15, 1251931776UL, 3990192128UL,   {0}},
    { 1279U, 2934034893UL, 20,40,4294967294UL, 12, 18, 7, 15, 3713365888UL, 4006969344UL,   {0}},
    { 1279U, 3450804686UL, 20,40,4294967294UL, 12, 18, 7, 15, 3050633088UL, 3981803520UL,   {0}},
    { 1279U, 3744424399UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151868800UL, 2006286336UL,   {0}},
    { 1279U, 3161637328UL, 20,40,4294967294UL, 12, 18, 7, 15, 903800704UL, 4000677888UL,   {0}},
    { 1279U, 3050916305UL, 20,40,4294967294UL, 12, 18, 7, 15, 2375774080UL, 4007493632UL,   {0}},
    { 1279U, 3047913938UL, 20,40,4294967294UL, 12, 18, 7, 15, 2406972288UL, 3872751616UL,   {0}},
    { 1279U, 3628853715UL, 20,40,4294967294UL, 12, 18, 7, 15, 3135200640UL, 2001436672UL,   {0}},
    { 1279U, 4289577428UL, 20,40,4294967294UL, 12, 18, 7, 15, 3013440384UL, 1868005376UL,   {0}},
    { 1279U, 4238557653UL, 20,40,4294967294UL, 12, 18, 7, 15, 4084561024UL, 1877442560UL,   {0}},
    { 1279U, 3733428694UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641719168UL, 3999236096UL,   {0}},
    { 1279U, 2222668247UL, 20,40,4294967294UL, 12, 18, 7, 15, 3621055360UL, 4015357952UL,   {0}},
    { 1279U, 2738147800UL, 20,40,4294967294UL, 12, 18, 7, 15, 3118951296UL, 1867743232UL,   {0}},
    { 1279U, 3365949913UL, 20,40,4294967294UL, 12, 18, 7, 15, 1421536896UL, 3989929984UL,   {0}},
    { 1279U, 2187647450UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151289728UL, 4149706752UL,   {0}},
    { 1279U, 3193147867UL, 20,40,4294967294UL, 12, 18, 7, 15, 2616030080UL, 2002092032UL,   {0}},
    { 1279U, 4130851292UL, 20,40,4294967294UL, 12, 18, 7, 15, 2636609152UL, 2010480640UL,   {0}},
    { 1279U, 3491430877UL, 20,40,4294967294UL, 12, 18, 7, 15, 861232512UL, 4160585728UL,   {0}},
    { 1279U, 3954192862UL, 20,40,4294967294UL, 12, 18, 7, 15, 3556014976UL, 2002092032UL,   {0}},
    { 1279U, 3484914143UL, 20,40,4294967294UL, 12, 18, 7, 15, 2002090880UL, 3881140224UL,   {0}},
    { 1279U, 3451539936UL, 20,40,4294967294UL, 12, 18, 7, 15, 1458989952UL, 4015357952UL,   {0}},
    { 1279U, 3568050657UL, 20,40,4294967294UL, 12, 18, 7, 15, 2549443456UL, 2069200896UL,   {0}},
    { 1279U, 3482829282UL, 20,40,4294967294UL, 12, 18, 7, 15, 1709011840UL, 4015292416UL,   {0}},
    { 1279U, 2532444643UL, 20,40,4294967294UL, 12, 18, 7, 15, 3133992832UL, 4015489024UL,   {0}},
    { 1279U, 2900015588UL, 20,40,4294967294UL, 12, 18, 7, 15, 1716942464UL, 4006969344UL,   {0}},
    { 1279U, 3582833125UL, 20,40,4294967294UL, 12, 18, 7, 15, 3949288320UL, 2008514560UL,   {0}},
    { 1279U, 3928754662UL, 20,40,4294967294UL, 12, 18, 7, 15, 3019142528UL, 4016537600UL,   {0}},
    { 1279U, 2859792871UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557460864UL, 3981803520UL,   {0}},
    { 1279U, 3476369896UL, 20,40,4294967294UL, 12, 18, 7, 15, 3201724032UL, 3984818176UL,   {0}},
    { 1279U, 3116245481UL, 20,40,4294967294UL, 12, 18, 7, 15, 836169600UL, 3981803520UL,   {0}},
    { 1279U, 4232853994UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470220160UL, 2008252416UL,   {0}},
    { 1279U, 2917485035UL, 20,40,4294967294UL, 12, 18, 7, 15, 2506979200UL, 3866525696UL,   {0}},
    { 1279U, 3245724140UL, 20,40,4294967294UL, 12, 18, 7, 15, 3721715072UL, 4153769984UL,   {0}},
    { 1279U, 2894676461UL, 20,40,4294967294UL, 12, 18, 7, 15, 2359127936UL, 4006969344UL,   {0}},
    { 1279U, 2802674158UL, 20,40,4294967294UL, 12, 18, 7, 15, 3699698560UL, 4023877632UL,   {0}},
    { 1279U, 2149767663UL, 20,40,4294967294UL, 12, 18, 7, 15, 1490318976UL, 3985997824UL,   {0}},
    { 1279U, 3352146416UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117739904UL, 3713368064UL,   {0}},
    { 1279U, 2765965809UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641196928UL, 4000743424UL,   {0}},
    { 1279U, 2259042802UL, 20,40,4294967294UL, 12, 18, 7, 15, 3115608704UL, 4019552256UL,   {0}},
    { 1279U, 2846769651UL, 20,40,4294967294UL, 12, 18, 7, 15, 2372763520UL, 3866591232UL,   {0}},
    { 1279U, 3165393396UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641719168UL, 3999236096UL,   {0}},
    { 1279U, 4148388341UL, 20,40,4294967294UL, 12, 18, 7, 15, 4122832256UL, 1867874304UL,   {0}},
    { 1279U, 2258708982UL, 20,40,4294967294UL, 12, 18, 7, 15, 3712938880UL, 4026236928UL,   {0}},
    { 1279U, 3238674935UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480548992UL, 3991240704UL,   {0}},
    { 1279U, 2758230520UL, 20,40,4294967294UL, 12, 18, 7, 15, 2639748224UL, 2010873856UL,   {0}},
    { 1279U, 2929644025UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629138304UL, 4008017920UL,   {0}},
    { 1279U, 3640644090UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629593984UL, 4011556864UL,   {0}},
    { 1279U, 4093620731UL, 20,40,4294967294UL, 12, 18, 7, 15, 2359127936UL, 4006969344UL,   {0}},
    { 1279U, 3611501052UL, 20,40,4294967294UL, 12, 18, 7, 15, 3034346368UL, 4015357952UL,   {0}},
    { 1279U, 3697398269UL, 20,40,4294967294UL, 12, 18, 7, 15, 1234630528UL, 4006838272UL,   {0}},
    { 1279U, 3952667134UL, 20,40,4294967294UL, 12, 18, 7, 15, 2639688576UL, 4026236928UL,   {0}},
    { 1279U, 3617864191UL, 20,40,4294967294UL, 12, 18, 7, 15, 3000268416UL, 4023877632UL,   {0}},
    { 1279U, 3295887872UL, 20,40,4294967294UL, 12, 18, 7, 15, 1934912384UL, 4017586176UL,   {0}},
    { 1279U, 3907490305UL, 20,40,4294967294UL, 12, 18, 7, 15, 3704976256UL, 1868398592UL,   {0}},
    { 1279U, 3158233602UL, 20,40,4294967294UL, 12, 18, 7, 15, 3436493696UL, 4149510144UL,   {0}},
    { 1279U, 2677907971UL, 20,40,4294967294UL, 12, 18, 7, 15, 1322547072UL, 3981672448UL,   {0}},
    { 1279U, 4028807684UL, 20,40,4294967294UL, 12, 18, 7, 15, 3134413952UL, 2009825280UL,   {0}},
    { 1279U, 2293391877UL, 20,40,4294967294UL, 12, 18, 7, 15, 4076301696UL, 1868267520UL,   {0}},
    { 1279U, 2361678342UL, 20,40,4294967294UL, 12, 18, 7, 15, 2733536128UL, 4017848320UL,   {0}},
    { 1279U, 3966095879UL, 20,40,4294967294UL, 12, 18, 7, 15, 1314158464UL, 3981672448UL,   {0}},
    { 1279U, 2931816968UL, 20,40,4294967294UL, 12, 18, 7, 15, 4120802176UL, 1867153408UL,   {0}},
    { 1279U, 3050043913UL, 20,40,4294967294UL, 12, 18, 7, 15, 3008722816UL, 1851228160UL,   {0}},
    { 1279U, 3900670474UL, 20,40,4294967294UL, 12, 18, 7, 15, 594375552UL, 4017455104UL,   {0}},
    { 1279U, 3275276811UL, 20,40,4294967294UL, 12, 18, 7, 15, 2914499456UL, 2069594112UL,   {0}},
    { 1279U, 2779615756UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117837184UL, 4015226880UL,   {0}},
    { 1279U, 2828882445UL, 20,40,4294967294UL, 12, 18, 7, 15, 699854720UL, 3990192128UL,   {0}},
    { 1279U, 3154518542UL, 20,40,4294967294UL, 12, 18, 7, 15, 3713365888UL, 1851228160UL,   {0}},
    { 1279U, 2841629199UL, 20,40,4294967294UL, 12, 18, 7, 15, 1700755328UL, 3985997824UL,   {0}},
    { 1279U, 3019510288UL, 20,40,4294967294UL, 12, 18, 7, 15, 3050633088UL, 3981803520UL,   {0}},
    { 1279U, 3348077073UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470056320UL, 4149575680UL,   {0}},
    { 1279U, 3114447378UL, 20,40,4294967294UL, 12, 18, 7, 15, 3461659520UL, 2002026496UL,   {0}},
    { 1279U, 3737291283UL, 20,40,4294967294UL, 12, 18, 7, 15, 1985443712UL, 4015357952UL,   {0}},
    { 1279U, 3280771604UL, 20,40,4294967294UL, 12, 18, 7, 15, 3432299392UL, 4149575680UL,   {0}},
    { 1279U, 3758445077UL, 20,40,4294967294UL, 12, 18, 7, 15, 2642243456UL, 3998711808UL,   {0}},
    { 1279U, 2152034838UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470056320UL, 4149575680UL,   {0}},
    { 1279U, 4072815127UL, 20,40,4294967294UL, 12, 18, 7, 15, 3447027584UL, 3999760384UL,   {0}},
    { 1279U, 3930016280UL, 20,40,4294967294UL, 12, 18, 7, 15, 2606591104UL, 1876393984UL,   {0}},
    { 1279U, 3916151321UL, 20,40,4294967294UL, 12, 18, 7, 15, 1574369152UL, 4015357952UL,   {0}},
    { 1279U, 3221830170UL, 20,40,4294967294UL, 12, 18, 7, 15, 2373283712UL, 3998711808UL,   {0}},
    { 1279U, 2296500763UL, 20,40,4294967294UL, 12, 18, 7, 15, 1305769600UL, 4007100416UL,   {0}},
    { 1279U, 3970290204UL, 20,40,4294967294UL, 12, 18, 7, 15, 1550513792UL, 3990192128UL,   {0}},
    { 1279U, 3016155677UL, 20,40,4294967294UL, 12, 18, 7, 15, 651654272UL, 4023615488UL,   {0}},
    { 1279U, 3838409246UL, 20,40,4294967294UL, 12, 18, 7, 15, 3637868416UL, 3981803520UL,   {0}},
    { 1279U, 3730633247UL, 20,40,4294967294UL, 12, 18, 7, 15, 1934915200UL, 4007100416UL,   {0}},
    { 1279U, 3666702880UL, 20,40,4294967294UL, 12, 18, 7, 15, 1859484288UL, 3891625984UL,   {0}},
    { 1279U, 3373826593UL, 20,40,4294967294UL, 12, 18, 7, 15, 4076304000UL, 1877245952UL,   {0}},
    { 1279U, 4234639906UL, 20,40,4294967294UL, 12, 18, 7, 15, 3472317312UL, 2001960960UL,   {0}},
    { 1279U, 3548019235UL, 20,40,4294967294UL, 12, 18, 7, 15, 3681516416UL, 4140138496UL,   {0}},
    { 1279U, 2633906724UL, 20,40,4294967294UL, 12, 18, 7, 15, 1282072448UL, 4124147712UL,   {0}},
    { 1279U, 3132856869UL, 20,40,4294967294UL, 12, 18, 7, 15, 1718451072UL, 4017979392UL,   {0}},
    { 1279U, 2668239398UL, 20,40,4294967294UL, 12, 18, 7, 15, 3606342528UL, 1867874304UL,   {0}},
    { 1279U, 4201501223UL, 20,40,4294967294UL, 12, 18, 7, 15, 1322579840UL, 3981803520UL,   {0}},
    { 1279U, 4262609448UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706550144UL, 4000808960UL,   {0}},
    { 1279U, 4025152041UL, 20,40,4294967294UL, 12, 18, 7, 15, 3590122880UL, 4015357952UL,   {0}},
    { 1279U, 2217265706UL, 20,40,4294967294UL, 12, 18, 7, 15, 1558869632UL, 3990192128UL,   {0}},
    { 1279U, 2316628523UL, 20,40,4294967294UL, 12, 18, 7, 15, 2918562688UL, 2069200896UL,   {0}},
    { 1279U, 2652047916UL, 20,40,4294967294UL, 12, 18, 7, 15, 2312470400UL, 3849617408UL,   {0}},
    { 1279U, 2913350189UL, 20,40,4294967294UL, 12, 18, 7, 15, 2644405632UL, 4015751168UL,   {0}},
    { 1279U, 2332191278UL, 20,40,4294967294UL, 12, 18, 7, 15, 2816833152UL, 1976926208UL,   {0}},
    { 1279U, 3815184943UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480714112UL, 3949297664UL,   {0}},
    { 1279U, 2765556272UL, 20,40,4294967294UL, 12, 18, 7, 15, 3472325504UL, 3949297664UL,   {0}},
    { 1279U, 2221124145UL, 20,40,4294967294UL, 12, 18, 7, 15, 1733719680UL, 3990192128UL,   {0}},
    { 1279U, 2403684914UL, 20,40,4294967294UL, 12, 18, 7, 15, 3602180736UL, 4023681024UL,   {0}},
    { 1279U, 3742231091UL, 20,40,4294967294UL, 12, 18, 7, 15, 3437026176UL, 4149313536UL,   {0}},
    { 1279U, 4095627828UL, 20,40,4294967294UL, 12, 18, 7, 15, 1700623104UL, 4023746560UL,   {0}},
    { 1279U, 3733074485UL, 20,40,4294967294UL, 12, 18, 7, 15, 3571150208UL, 1867350016UL,   {0}},
    { 1279U, 3803832886UL, 20,40,4294967294UL, 12, 18, 7, 15, 1969190784UL, 3989536768UL,   {0}},
    { 1279U, 3193063991UL, 20,40,4294967294UL, 12, 18, 7, 15, 3116128896UL, 4157964288UL,   {0}},
    { 1279U, 3584518712UL, 20,40,4294967294UL, 12, 18, 7, 15, 3115506560UL, 4141318144UL,   {0}},
    { 1279U, 2304956985UL, 20,40,4294967294UL, 12, 18, 7, 15, 3142905728UL, 3713368064UL,   {0}},
    { 1279U, 2684375610UL, 20,40,4294967294UL, 12, 18, 7, 15, 3116788608UL, 4015226880UL,   {0}},
    { 1279U, 3161762363UL, 20,40,4294967294UL, 12, 18, 7, 15, 2643942272UL, 2069594112UL,   {0}},
    { 1279U, 2569151036UL, 20,40,4294967294UL, 12, 18, 7, 15, 3562765184UL, 3880878080UL,   {0}},
    { 1279U, 3051686461UL, 20,40,4294967294UL, 12, 18, 7, 15, 3655129984UL, 4149575680UL,   {0}},
    { 1279U, 2981855806UL, 20,40,4294967294UL, 12, 18, 7, 15, 3411336064UL, 4153901056UL,   {0}},
    { 1279U, 3417619007UL, 20,40,4294967294UL, 12, 18, 7, 15, 919959424UL, 3998580736UL,   {0}},
    { 1279U, 2945772096UL, 20,40,4294967294UL, 12, 18, 7, 15, 1982167936UL, 3882975232UL,   {0}},
    { 1279U, 3937507905UL, 20,40,4294967294UL, 12, 18, 7, 15, 1456922496UL, 4116021248UL,   {0}},
    { 1279U, 3358065218UL, 20,40,4294967294UL, 12, 18, 7, 15, 3147755392UL, 4006969344UL,   {0}},
    { 1279U, 3119944259UL, 20,40,4294967294UL, 12, 18, 7, 15, 3629610880UL, 3981803520UL,   {0}},
    { 1279U, 2291556932UL, 20,40,4294967294UL, 12, 18, 7, 15, 729117568UL, 4158095360UL,   {0}},
    { 1279U, 4129503813UL, 20,40,4294967294UL, 12, 18, 7, 15, 729640320UL, 4015357952UL,   {0}},
    { 1279U, 2838843974UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983900672UL,   {0}},
    { 1279U, 2838186567UL, 20,40,4294967294UL, 12, 18, 7, 15, 1972729728UL, 3981803520UL,   {0}},
    { 1279U, 2832659016UL, 20,40,4294967294UL, 12, 18, 7, 15, 2628545920UL, 4019552256UL,   {0}},
    { 1279U, 2209970761UL, 20,40,4294967294UL, 12, 18, 7, 15, 3116657280UL, 4023746560UL,   {0}},
    { 1279U, 3014791754UL, 20,40,4294967294UL, 12, 18, 7, 15, 1701673856UL, 3957686272UL,   {0}},
    { 1279U, 2366235211UL, 20,40,4294967294UL, 12, 18, 7, 15, 846559104UL, 4016537600UL,   {0}},
    { 1279U, 2153359948UL, 20,40,4294967294UL, 12, 18, 7, 15, 1574369152UL, 3998580736UL,   {0}},
    { 1279U, 4007752269UL, 20,40,4294967294UL, 12, 18, 7, 15, 2628614016UL, 3992289280UL,   {0}},
    { 1279U, 3593777742UL, 20,40,4294967294UL, 12, 18, 7, 15, 3436535168UL, 2008383488UL,   {0}},
    { 1279U, 4272679503UL, 20,40,4294967294UL, 12, 18, 7, 15, 1934982016UL, 4149575680UL,   {0}},
    { 1279U, 3576945232UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151297408UL, 4149575680UL,   {0}},
    { 1279U, 2726584913UL, 20,40,4294967294UL, 12, 18, 7, 15, 3109482112UL, 3721756672UL,   {0}},
    { 1279U, 2506721874UL, 20,40,4294967294UL, 12, 18, 7, 15, 1314158464UL, 3981672448UL,   {0}},
    { 1279U, 2459912787UL, 20,40,4294967294UL, 12, 18, 7, 15, 598406016UL, 4023746560UL,   {0}},
    { 1279U, 4232118868UL, 20,40,4294967294UL, 12, 18, 7, 15, 3946667392UL, 2010480640UL,   {0}},
    { 1279U, 2332400213UL, 20,40,4294967294UL, 12, 18, 7, 15, 3419724672UL, 4149575680UL,   {0}},
    { 1279U, 3954295382UL, 20,40,4294967294UL, 12, 18, 7, 15, 3699698560UL, 4023877632UL,   {0}},
    { 1279U, 3524610647UL, 20,40,4294967294UL, 12, 18, 7, 15, 3463935872UL, 3982852096UL,   {0}},
    { 1279U, 3669602904UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641719168UL, 3999236096UL,   {0}},
    { 1279U, 2176129625UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983900672UL,   {0}},
    { 1279U, 2156018266UL, 20,40,4294967294UL, 12, 18, 7, 15, 734719872UL, 3981541376UL,   {0}},
    { 1279U, 2784801371UL, 20,40,4294967294UL, 12, 18, 7, 15, 2918544000UL, 2010480640UL,   {0}},
    { 1279U, 3703091804UL, 20,40,4294967294UL, 12, 18, 7, 15, 651523968UL, 3998711808UL,   {0}},
    { 1279U, 4068567645UL, 20,40,4294967294UL, 12, 18, 7, 15, 754285440UL, 4149510144UL,   {0}},
    { 1279U, 3300278878UL, 20,40,4294967294UL, 12, 18, 7, 15, 867483520UL, 4124540928UL,   {0}},
    { 1279U, 3346825823UL, 20,40,4294967294UL, 12, 18, 7, 15, 1490319232UL, 3981672448UL,   {0}},
    { 1279U, 3403154016UL, 20,40,4294967294UL, 12, 18, 7, 15, 3950342784UL, 2010480640UL,   {0}},
    { 1279U, 3749956193UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627562368UL, 1876393984UL,   {0}},
    { 1279U, 2526536290UL, 20,40,4294967294UL, 12, 18, 7, 15, 2576639616UL, 4007100416UL,   {0}},
    { 1279U, 3259884131UL, 20,40,4294967294UL, 12, 18, 7, 15, 3688723328UL, 4015292416UL,   {0}},
    { 1279U, 3307379300UL, 20,40,4294967294UL, 12, 18, 7, 15, 3688684928UL, 4152721408UL,   {0}},
    { 1279U, 3883831909UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641196928UL, 4000808960UL,   {0}},
    { 1279U, 2792292966UL, 20,40,4294967294UL, 12, 18, 7, 15, 3872480128UL, 2069200896UL,   {0}},
    { 1279U, 3571257959UL, 20,40,4294967294UL, 12, 18, 7, 15, 2341762688UL, 3990192128UL,   {0}},
    { 1279U, 3643007592UL, 20,40,4294967294UL, 12, 18, 7, 15, 2643811200UL, 2069594112UL,   {0}},
    { 1279U, 2541793897UL, 20,40,4294967294UL, 12, 18, 7, 15, 1987410816UL, 4016930816UL,   {0}},
    { 1279U, 4289858154UL, 20,40,4294967294UL, 12, 18, 7, 15, 3428154240UL, 3891757056UL,   {0}},
    { 1279U, 4179563115UL, 20,40,4294967294UL, 12, 18, 7, 15, 865398400UL, 3721756672UL,   {0}},
    { 1279U, 2314877548UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557460864UL, 3981803520UL,   {0}},
    { 1279U, 2380450413UL, 20,40,4294967294UL, 12, 18, 7, 15, 3115637632UL, 4149575680UL,   {0}},
    { 1279U, 3517084270UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627033984UL, 2077720576UL,   {0}},
    { 1279U, 3394646639UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151785344UL, 4015489024UL,   {0}},
    { 1279U, 3153156720UL, 20,40,4294967294UL, 12, 18, 7, 15, 3019142016UL, 4017061888UL,   {0}},
    { 1279U, 3708193393UL, 20,40,4294967294UL, 12, 18, 7, 15, 1718451072UL, 4017192960UL,   {0}},
    { 1279U, 3976221298UL, 20,40,4294967294UL, 12, 18, 7, 15, 594376064UL, 4017586176UL,   {0}},
    { 1279U, 3571499635UL, 20,40,4294967294UL, 12, 18, 7, 15, 3950867200UL, 2010611712UL,   {0}},
    { 1279U, 3433769588UL, 20,40,4294967294UL, 12, 18, 7, 15, 4082985600UL, 1876262912UL,   {0}},
    { 1279U, 3660104309UL, 20,40,4294967294UL, 12, 18, 7, 15, 1969190784UL, 3989536768UL,   {0}},
    { 1279U, 2755846774UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557852032UL, 3980492800UL,   {0}},
    { 1279U, 2229609079UL, 20,40,4294967294UL, 12, 18, 7, 15, 1305769600UL, 4007100416UL,   {0}},
    { 1279U, 2751650424UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557460864UL, 3981803520UL,   {0}},
    { 1279U, 4144339577UL, 20,40,4294967294UL, 12, 18, 7, 15, 3721721728UL, 4017586176UL,   {0}},
    { 1279U, 4072807034UL, 20,40,4294967294UL, 12, 18, 7, 15, 2306310016UL, 3991764992UL,   {0}},
    { 1279U, 3593749115UL, 20,40,4294967294UL, 12, 18, 7, 15, 3000464256UL, 1870364672UL,   {0}},
    { 1279U, 3481604732UL, 20,40,4294967294UL, 12, 18, 7, 15, 1733719680UL, 3990192128UL,   {0}},
    { 1279U, 3263378045UL, 20,40,4294967294UL, 12, 18, 7, 15, 635270016UL, 4149575680UL,   {0}},
    { 1279U, 3206177406UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470449536UL, 4149444608UL,   {0}},
    { 1279U, 3912071807UL, 20,40,4294967294UL, 12, 18, 7, 15, 1987410816UL, 4016930816UL,   {0}},
    { 1279U, 2175855232UL, 20,40,4294967294UL, 12, 18, 7, 15, 2649584512UL, 2002092032UL,   {0}},
    { 1279U, 3338744449UL, 20,40,4294967294UL, 12, 18, 7, 15, 3570719616UL, 4153901056UL,   {0}},
    { 1279U, 3406209666UL, 20,40,4294967294UL, 12, 18, 7, 15, 3597986432UL, 4023746560UL,   {0}},
    { 1279U, 3341646467UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117705856UL, 4019552256UL,   {0}},
    { 1279U, 3688491652UL, 20,40,4294967294UL, 12, 18, 7, 15, 3461839744UL, 3891494912UL,   {0}},
    { 1279U, 3041219205UL, 20,40,4294967294UL, 12, 18, 7, 15, 651619200UL, 4015357952UL,   {0}},
    { 1279U, 2834944646UL, 20,40,4294967294UL, 12, 18, 7, 15, 4017208064UL, 2077720576UL,   {0}},
    { 1279U, 3004955271UL, 20,40,4294967294UL, 12, 18, 7, 15, 3489068928UL, 3982852096UL,   {0}},
    { 1279U, 3783594632UL, 20,40,4294967294UL, 12, 18, 7, 15, 577599360UL, 3983900672UL,   {0}},
    { 1279U, 2377132681UL, 20,40,4294967294UL, 12, 18, 7, 15, 1549039488UL, 3981672448UL,   {0}},
    { 1279U, 3468984970UL, 20,40,4294967294UL, 12, 18, 7, 15, 3944670848UL, 3721756672UL,   {0}},
    { 1279U, 2408792715UL, 20,40,4294967294UL, 12, 18, 7, 15, 1742043776UL, 3956637696UL,   {0}},
    { 1279U, 2471662220UL, 20,40,4294967294UL, 12, 18, 7, 15, 3461839744UL, 3881140224UL,   {0}},
    { 1279U, 3996007053UL, 20,40,4294967294UL, 12, 18, 7, 15, 3646257024UL, 4006969344UL,   {0}},
    { 1279U, 4230496910UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117767296UL, 2010218496UL,   {0}},
    { 1279U, 3251942031UL, 20,40,4294967294UL, 12, 18, 7, 15, 3163872896UL, 4124409856UL,   {0}},
    { 1279U, 4260534928UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557591936UL, 3981934592UL,   {0}},
    { 1279U, 3193000593UL, 20,40,4294967294UL, 12, 18, 7, 15, 3428146560UL, 2008842240UL,   {0}},
    { 1279U, 3399486098UL, 20,40,4294967294UL, 12, 18, 7, 15, 3472317312UL, 2001895424UL,   {0}},
    { 1279U, 3664792211UL, 20,40,4294967294UL, 12, 18, 7, 15, 3168464768UL, 3980492800UL,   {0}},
    { 1279U, 2655382164UL, 20,40,4294967294UL, 12, 18, 7, 15, 1524530048UL, 3948249088UL,   {0}},
    { 1279U, 3984767637UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117636480UL, 2001960960UL,   {0}},
    { 1279U, 3727362710UL, 20,40,4294967294UL, 12, 18, 7, 15, 3950867840UL, 2010480640UL,   {0}},
    { 1279U, 2460308119UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117701760UL, 4157702144UL,   {0}},
    { 1279U, 4193686168UL, 20,40,4294967294UL, 12, 18, 7, 15, 1029102976UL, 4157964288UL,   {0}},
    { 1279U, 3473547929UL, 20,40,4294967294UL, 12, 18, 7, 15, 2373285760UL, 3999760384UL,   {0}},
    { 1279U, 4212118170UL, 20,40,4294967294UL, 12, 18, 7, 15, 3142802304UL, 1993834496UL,   {0}},
    { 1279U, 3112831643UL, 20,40,4294967294UL, 12, 18, 7, 15, 2474082176UL, 4124278784UL,   {0}},
    { 1279U, 4245025436UL, 20,40,4294967294UL, 12, 18, 7, 15, 730525568UL, 4006969344UL,   {0}},
    { 1279U, 3908199069UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151322496UL, 2006286336UL,   {0}},
    { 1279U, 2850026142UL, 20,40,4294967294UL, 12, 18, 7, 15, 1733719680UL, 3990192128UL,   {0}},
    { 1279U, 2591152799UL, 20,40,4294967294UL, 12, 18, 7, 15, 2002024064UL, 4007100416UL,   {0}},
    { 1279U, 3463715488UL, 20,40,4294967294UL, 12, 18, 7, 15, 2851894912UL, 4158095360UL,   {0}},
    { 1279U, 2849999521UL, 20,40,4294967294UL, 12, 18, 7, 15, 3714938752UL, 4000808960UL,   {0}},
    { 1279U, 2421942946UL, 20,40,4294967294UL, 12, 18, 7, 15, 2646568320UL, 1868267520UL,   {0}},
    { 1279U, 2518434467UL, 20,40,4294967294UL, 12, 18, 7, 15, 2644340608UL, 4006969344UL,   {0}},
    { 1279U, 3812254372UL, 20,40,4294967294UL, 12, 18, 7, 15, 3721492352UL, 3981803520UL,   {0}},
    { 1279U, 4012753573UL, 20,40,4294967294UL, 12, 18, 7, 15, 3701840768UL, 2069200896UL,   {0}},
    { 1279U, 2612802214UL, 20,40,4294967294UL, 12, 18, 7, 15, 703953792UL, 3882188800UL,   {0}},
    { 1279U, 3830135463UL, 20,40,4294967294UL, 12, 18, 7, 15, 3114560128UL, 4019552256UL,   {0}},
    { 1279U, 2630429352UL, 20,40,4294967294UL, 12, 18, 7, 15, 2359587712UL, 4026499072UL,   {0}},
    { 1279U, 2745592489UL, 20,40,4294967294UL, 12, 18, 7, 15, 2390062976UL, 3982983168UL,   {0}},
    { 1279U, 2736982698UL, 20,40,4294967294UL, 12, 18, 7, 15, 2796222080UL, 4157964288UL,   {0}},
    { 1279U, 2907040427UL, 20,40,4294967294UL, 12, 18, 7, 15, 3738360704UL, 4149444608UL,   {0}},
    { 1279U, 3633797804UL, 20,40,4294967294UL, 12, 18, 7, 15, 3992810368UL, 2002092032UL,   {0}},
    { 1279U, 4184658605UL, 20,40,4294967294UL, 12, 18, 7, 15, 1987410816UL, 3882188800UL,   {0}},
    { 1279U, 3465908910UL, 20,40,4294967294UL, 12, 18, 7, 15, 3572855680UL, 2007924736UL,   {0}},
    { 1279U, 3544746671UL, 20,40,4294967294UL, 12, 18, 7, 15, 969240448UL, 3981803520UL,   {0}},
    { 1279U, 4054946480UL, 20,40,4294967294UL, 12, 18, 7, 15, 1701804928UL, 3957686272UL,   {0}},
    { 1279U, 2378767025UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627562368UL, 1868005376UL,   {0}},
    { 1279U, 2353183410UL, 20,40,4294967294UL, 12, 18, 7, 15, 3679771520UL, 4158095360UL,   {0}},
    { 1279U, 3836641971UL, 20,40,4294967294UL, 12, 18, 7, 15, 4082986112UL, 1876393984UL,   {0}},
    { 1279U, 3229727412UL, 20,40,4294967294UL, 12, 18, 7, 15, 1737913984UL, 3990323200UL,   {0}},
    { 1279U, 3724110517UL, 20,40,4294967294UL, 12, 18, 7, 15, 1718451072UL, 4017455104UL,   {0}},
    { 1279U, 3578407606UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151846784UL, 2002223104UL,   {0}},
    { 1279U, 2927209143UL, 20,40,4294967294UL, 12, 18, 7, 15, 2639486080UL, 2009825280UL,   {0}},
    { 1279U, 3675527864UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641196928UL, 3992289280UL,   {0}},
    { 1279U, 2211758777UL, 20,40,4294967294UL, 12, 18, 7, 15, 3484908416UL, 3949559808UL,   {0}},
    { 1279U, 3716135610UL, 20,40,4294967294UL, 12, 18, 7, 15, 4108153728UL, 1867874304UL,   {0}},
    { 1279U, 2349261499UL, 20,40,4294967294UL, 12, 18, 7, 15, 2868868736UL, 2010480640UL,   {0}},
    { 1279U, 3286938300UL, 20,40,4294967294UL, 12, 18, 7, 15, 1288992384UL, 4002906112UL,   {0}},
    { 1279U, 2687333053UL, 20,40,4294967294UL, 12, 18, 7, 15, 3969314432UL, 3721756672UL,   {0}},
    { 1279U, 3578231486UL, 20,40,4294967294UL, 12, 18, 7, 15, 1848474496UL, 3883237376UL,   {0}},
    { 1279U, 3655899839UL, 20,40,4294967294UL, 12, 18, 7, 15, 3115637632UL, 4149313536UL,   {0}},
    { 1279U, 3316824768UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706550144UL, 3983900672UL,   {0}},
    { 1279U, 4205877953UL, 20,40,4294967294UL, 12, 18, 7, 15, 729640320UL, 4023746560UL,   {0}},
    { 1279U, 3534058178UL, 20,40,4294967294UL, 12, 18, 7, 15, 2808572800UL, 2077720576UL,   {0}},
    { 1279U, 3484240579UL, 20,40,4294967294UL, 12, 18, 7, 15, 3655693696UL, 2001829888UL,   {0}},
    { 1279U, 4280967876UL, 20,40,4294967294UL, 12, 18, 7, 15, 3438638976UL, 3999760384UL,   {0}},
    { 1279U, 3661710021UL, 20,40,4294967294UL, 12, 18, 7, 15, 2610255488UL, 2111143936UL,   {0}},
    { 1279U, 2392687302UL, 20,40,4294967294UL, 12, 18, 7, 15, 3958726016UL, 2002092032UL,   {0}},
    { 1279U, 3219935943UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627039104UL, 3981803520UL,   {0}},
    { 1279U, 2472630984UL, 20,40,4294967294UL, 12, 18, 7, 15, 961867392UL, 3721756672UL,   {0}},
    { 1279U, 2929121993UL, 20,40,4294967294UL, 12, 18, 7, 15, 3438598784UL, 4157702144UL,   {0}},
    { 1279U, 3661845194UL, 20,40,4294967294UL, 12, 18, 7, 15, 2325116544UL, 3990192128UL,   {0}},
    { 1279U, 4164522699UL, 20,40,4294967294UL, 12, 18, 7, 15, 2539092864UL, 3874848768UL,   {0}},
    { 1279U, 2265504460UL, 20,40,4294967294UL, 12, 18, 7, 15, 1920298880UL, 4006969344UL,   {0}},
    { 1279U, 3531883213UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627563392UL, 3998711808UL,   {0}},
    { 1279U, 2615171790UL, 20,40,4294967294UL, 12, 18, 7, 15, 1801252480UL, 3671556096UL,   {0}},
    { 1279U, 2474904271UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706550144UL, 3983900672UL,   {0}},
    { 1279U, 3212493520UL, 20,40,4294967294UL, 12, 18, 7, 15, 3118095232UL, 4148396032UL,   {0}},
    { 1279U, 3955854033UL, 20,40,4294967294UL, 12, 18, 7, 15, 3118099200UL, 4014178304UL,   {0}},
    { 1279U, 2670572242UL, 20,40,4294967294UL, 12, 18, 7, 15, 1901360768UL, 3990192128UL,   {0}},
    { 1279U, 3008811731UL, 20,40,4294967294UL, 12, 18, 7, 15, 3973364608UL, 2002092032UL,   {0}},
    { 1279U, 4172040916UL, 20,40,4294967294UL, 12, 18, 7, 15, 3590118784UL, 4149575680UL,   {0}},
    { 1279U, 2421506773UL, 20,40,4294967294UL, 12, 18, 7, 15, 3455540608UL, 2002485248UL,   {0}},
    { 1279U, 3737309910UL, 20,40,4294967294UL, 12, 18, 7, 15, 1983217536UL, 3983310848UL,   {0}},
    { 1279U, 3758109399UL, 20,40,4294967294UL, 12, 18, 7, 15, 3468123008UL, 2006155264UL,   {0}},
    { 1279U, 3488660184UL, 20,40,4294967294UL, 12, 18, 7, 15, 594376576UL, 3983900672UL,   {0}},
    { 1279U, 3620911833UL, 20,40,4294967294UL, 12, 18, 7, 15, 1852668800UL, 3882975232UL,   {0}},
    { 1279U, 3094246106UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629069696UL, 4011294720UL,   {0}},
    { 1279U, 3523859163UL, 20,40,4294967294UL, 12, 18, 7, 15, 2372763520UL, 3866591232UL,   {0}},
    { 1279U, 3821941468UL, 20,40,4294967294UL, 12, 18, 7, 15, 1968469888UL, 3981672448UL,   {0}},
    { 1279U, 3586839261UL, 20,40,4294967294UL, 12, 18, 7, 15, 3135039360UL, 4017848320UL,   {0}},
    { 1279U, 2173049566UL, 20,40,4294967294UL, 12, 18, 7, 15, 3944670848UL, 3721691136UL,   {0}},
    { 1279U, 4177281759UL, 20,40,4294967294UL, 12, 18, 7, 15, 852948864UL, 4015357952UL,   {0}},
    { 1279U, 3720864480UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557821056UL, 3990192128UL,   {0}},
    { 1279U, 3755762401UL, 20,40,4294967294UL, 12, 18, 7, 15, 2749265536UL, 3990192128UL,   {0}},
    { 1279U, 2818267874UL, 20,40,4294967294UL, 12, 18, 7, 15, 2626972288UL, 4023746560UL,   {0}},
    { 1279U, 2914841315UL, 20,40,4294967294UL, 12, 18, 7, 15, 3573345408UL, 4023877632UL,   {0}},
    { 1279U, 2915381988UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117570944UL, 4149444608UL,   {0}},
    { 1279U, 3426222821UL, 20,40,4294967294UL, 12, 18, 7, 15, 4093472128UL, 1868005376UL,   {0}},
    { 1279U, 4232252134UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480548992UL, 3991240704UL,   {0}},
    { 1279U, 2271458023UL, 20,40,4294967294UL, 12, 18, 7, 15, 2360700800UL, 4006969344UL,   {0}},
    { 1279U, 2494720744UL, 20,40,4294967294UL, 12, 18, 7, 15, 979294080UL, 3712712704UL,   {0}},
    { 1279U, 3325774569UL, 20,40,4294967294UL, 12, 18, 7, 15, 1322677888UL, 3985997824UL,   {0}},
    { 1279U, 2499683050UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480713088UL, 3982852096UL,   {0}},
    { 1279U, 3140893419UL, 20,40,4294967294UL, 12, 18, 7, 15, 1968338560UL, 3990192128UL,   {0}},
    { 1279U, 3247553260UL, 20,40,4294967294UL, 12, 18, 7, 15, 704083840UL, 4116021248UL,   {0}},
    { 1279U, 3738426093UL, 20,40,4294967294UL, 12, 18, 7, 15, 3629479808UL, 3981803520UL,   {0}},
    { 1279U, 2819963630UL, 20,40,4294967294UL, 12, 18, 7, 15, 3461790592UL, 4157833216UL,   {0}},
    { 1279U, 2771837679UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629131136UL, 2006417408UL,   {0}},
    { 1279U, 2628870896UL, 20,40,4294967294UL, 12, 18, 7, 15, 2572580736UL, 1867874304UL,   {0}},
    { 1279U, 4166503153UL, 20,40,4294967294UL, 12, 18, 7, 15, 598406016UL, 4023746560UL,   {0}},
    { 1279U, 4093670130UL, 20,40,4294967294UL, 12, 18, 7, 15, 903313280UL, 3981803520UL,   {0}},
    { 1279U, 2825640691UL, 20,40,4294967294UL, 12, 18, 7, 15, 724922240UL, 3981803520UL,   {0}},
    { 1279U, 2324210420UL, 20,40,4294967294UL, 12, 18, 7, 15, 3604310912UL, 1866825728UL,   {0}},
    { 1279U, 3490669301UL, 20,40,4294967294UL, 12, 18, 7, 15, 601158528UL, 4015882240UL,   {0}},
    { 1279U, 4125074166UL, 20,40,4294967294UL, 12, 18, 7, 15, 659879552UL, 3990192128UL,   {0}},
    { 1279U, 3154215671UL, 20,40,4294967294UL, 12, 18, 7, 15, 2359061120UL, 4023746560UL,   {0}},
    { 1279U, 3380880120UL, 20,40,4294967294UL, 12, 18, 7, 15, 3463771776UL, 3991633920UL,   {0}},
    { 1279U, 2190641913UL, 20,40,4294967294UL, 12, 18, 7, 15, 1852668800UL, 3883237376UL,   {0}},
    { 1279U, 3097516794UL, 20,40,4294967294UL, 12, 18, 7, 15, 2572514944UL, 1876262912UL,   {0}},
    { 1279U, 4275985147UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641196928UL, 4000808960UL,   {0}},
    { 1279U, 2473698044UL, 20,40,4294967294UL, 12, 18, 7, 15, 3168033664UL, 4153901056UL,   {0}},
    { 1279U, 3658181373UL, 20,40,4294967294UL, 12, 18, 7, 15, 2628547968UL, 4025843712UL,   {0}},
    { 1279U, 4115372798UL, 20,40,4294967294UL, 12, 18, 7, 15, 3721715072UL, 4153769984UL,   {0}},
    { 1279U, 4077515519UL, 20,40,4294967294UL, 12, 18, 7, 15, 3453318912UL, 4006969344UL,   {0}},
    { 1279U, 4238842624UL, 20,40,4294967294UL, 12, 18, 7, 15, 2798975872UL, 4016930816UL,   {0}},
    { 1279U, 2939116289UL, 20,40,4294967294UL, 12, 18, 7, 15, 3436533120UL, 2136309760UL,   {0}},
    { 1279U, 2862643970UL, 20,40,4294967294UL, 12, 18, 7, 15, 3445419264UL, 4023746560UL,   {0}},
    { 1279U, 2702674691UL, 20,40,4294967294UL, 12, 18, 7, 15, 3704937344UL, 4149313536UL,   {0}},
    { 1279U, 3523373828UL, 20,40,4294967294UL, 12, 18, 7, 15, 2359127936UL, 3998711808UL,   {0}},
    { 1279U, 2979240709UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627496832UL, 4015489024UL,   {0}},
    { 1279U, 3292048134UL, 20,40,4294967294UL, 12, 18, 7, 15, 3063346816UL, 4023877632UL,   {0}},
    { 1279U, 2994338567UL, 20,40,4294967294UL, 12, 18, 7, 15, 1769305984UL, 4124409856UL,   {0}},
    { 1279U, 2709318408UL, 20,40,4294967294UL, 12, 18, 7, 15, 1786606464UL, 4157964288UL,   {0}},
    { 1279U, 2855340809UL, 20,40,4294967294UL, 12, 18, 7, 15, 2337568384UL, 3990192128UL,   {0}},
    { 1279U, 4232592138UL, 20,40,4294967294UL, 12, 18, 7, 15, 2646045568UL, 1870364672UL,   {0}},
    { 1279U, 3807681291UL, 20,40,4294967294UL, 12, 18, 7, 15, 783645568UL, 4158095360UL,   {0}},
    { 1279U, 4286876428UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629135232UL, 1872199680UL,   {0}},
    { 1279U, 2324724493UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983835136UL,   {0}},
    { 1279U, 4176493326UL, 20,40,4294967294UL, 12, 18, 7, 15, 1821736832UL, 4116021248UL,   {0}},
    { 1279U, 3992853263UL, 20,40,4294967294UL, 12, 18, 7, 15, 2296084352UL, 3874979840UL,   {0}},
    { 1279U, 3899194128UL, 20,40,4294967294UL, 12, 18, 7, 15, 4085084800UL, 1877311488UL,   {0}},
    { 1279U, 3280702225UL, 20,40,4294967294UL, 12, 18, 7, 15, 3486825344UL, 4149510144UL,   {0}},
    { 1279U, 2702195474UL, 20,40,4294967294UL, 12, 18, 7, 15, 3109401984UL, 2002092032UL,   {0}},
    { 1279U, 3696243475UL, 20,40,4294967294UL, 12, 18, 7, 15, 850753408UL, 4016406528UL,   {0}},
    { 1279U, 4143403796UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983835136UL,   {0}},
    { 1279U, 2505646869UL, 20,40,4294967294UL, 12, 18, 7, 15, 1901360768UL, 3990192128UL,   {0}},
    { 1279U, 4239250198UL, 20,40,4294967294UL, 12, 18, 7, 15, 3613096832UL, 3881140224UL,   {0}},
    { 1279U, 3196705559UL, 20,40,4294967294UL, 12, 18, 7, 15, 3554470784UL, 4016406528UL,   {0}},
    { 1279U, 3529173784UL, 20,40,4294967294UL, 12, 18, 7, 15, 3555552128UL, 1870102528UL,   {0}},
    { 1279U, 4042863385UL, 20,40,4294967294UL, 12, 18, 7, 15, 3590122880UL, 4015357952UL,   {0}},
    { 1279U, 2996552474UL, 20,40,4294967294UL, 12, 18, 7, 15, 3114592896UL, 4023746560UL,   {0}},
    { 1279U, 2299730715UL, 20,40,4294967294UL, 12, 18, 7, 15, 2778819968UL, 2077589504UL,   {0}},
    { 1279U, 2260456220UL, 20,40,4294967294UL, 12, 18, 7, 15, 3677192064UL, 3983900672UL,   {0}},
    { 1279U, 3710139165UL, 20,40,4294967294UL, 12, 18, 7, 15, 3581340800UL, 4023615488UL,   {0}},
    { 1279U, 3704732446UL, 20,40,4294967294UL, 12, 18, 7, 15, 2918643584UL, 4149444608UL,   {0}},
    { 1279U, 2498220831UL, 20,40,4294967294UL, 12, 18, 7, 15, 3602180736UL, 4023746560UL,   {0}},
    { 1279U, 3125150496UL, 20,40,4294967294UL, 12, 18, 7, 15, 3543460480UL, 4023681024UL,   {0}},
    { 1279U, 2329670433UL, 20,40,4294967294UL, 12, 18, 7, 15, 3445446528UL, 2004058112UL,   {0}},
    { 1279U, 2287479586UL, 20,40,4294967294UL, 12, 18, 7, 15, 2364828544UL, 4015423488UL,   {0}},
    { 1279U, 2318748451UL, 20,40,4294967294UL, 12, 18, 7, 15, 3941817472UL, 2011922432UL,   {0}},
    { 1279U, 3808627492UL, 20,40,4294967294UL, 12, 18, 7, 15, 4087180160UL, 1868136448UL,   {0}},
    { 1279U, 3610182437UL, 20,40,4294967294UL, 12, 18, 7, 15, 4080364160UL, 1876197376UL,   {0}},
    { 1279U, 3789941542UL, 20,40,4294967294UL, 12, 18, 7, 15, 3432312192UL, 4024270848UL,   {0}},
    { 1279U, 2643905319UL, 20,40,4294967294UL, 12, 18, 7, 15, 970283904UL, 4149575680UL,   {0}},
    { 1279U, 3681884968UL, 20,40,4294967294UL, 12, 18, 7, 15, 859665280UL, 4016406528UL,   {0}},
    { 1279U, 2282810153UL, 20,40,4294967294UL, 12, 18, 7, 15, 1701673856UL, 3957686272UL,   {0}},
    { 1279U, 2903876394UL, 20,40,4294967294UL, 12, 18, 7, 15, 3881234048UL, 3721691136UL,   {0}},
    { 1279U, 2469165867UL, 20,40,4294967294UL, 12, 18, 7, 15, 2606726016UL, 4009066496UL,   {0}},
    { 1279U, 2756086572UL, 20,40,4294967294UL, 12, 18, 7, 15, 3717560192UL, 4006969344UL,   {0}},
    { 1279U, 2697868077UL, 20,40,4294967294UL, 12, 18, 7, 15, 2864150144UL, 2010480640UL,   {0}},
    { 1279U, 2817137454UL, 20,40,4294967294UL, 12, 18, 7, 15, 1305933696UL, 3883237376UL,   {0}},
    { 1279U, 4094851887UL, 20,40,4294967294UL, 12, 18, 7, 15, 3434462080UL, 2078244864UL,   {0}},
    { 1279U, 4089600816UL, 20,40,4294967294UL, 12, 18, 7, 15, 3677192064UL, 3983900672UL,   {0}},
    { 1279U, 2185184049UL, 20,40,4294967294UL, 12, 18, 7, 15, 2580837760UL, 1867874304UL,   {0}},
    { 1279U, 3352060722UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629138304UL, 4009066496UL,   {0}},
    { 1279U, 3586405171UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557591936UL, 3981803520UL,   {0}},
    { 1279U, 3990188852UL, 20,40,4294967294UL, 12, 18, 7, 15, 844593536UL, 3891625984UL,   {0}},
    { 1279U, 2171724597UL, 20,40,4294967294UL, 12, 18, 7, 15, 903280512UL, 3981803520UL,   {0}},
    { 1279U, 2312756022UL, 20,40,4294967294UL, 12, 18, 7, 15, 3588192128UL, 3881140224UL,   {0}},
    { 1279U, 2274229047UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629071744UL, 4026499072UL,   {0}},
    { 1279U, 2704755512UL, 20,40,4294967294UL, 12, 18, 7, 15, 2626972544UL, 4015489024UL,   {0}},
    { 1279U, 4229565241UL, 20,40,4294967294UL, 12, 18, 7, 15, 2572908160UL, 1993834496UL,   {0}},
    { 1279U, 3508486970UL, 20,40,4294967294UL, 12, 18, 7, 15, 1288992384UL, 4002906112UL,   {0}},
    { 1279U, 2499719995UL, 20,40,4294967294UL, 12, 18, 7, 15, 1836547456UL, 4158357504UL,   {0}},
    { 1279U, 2312211260UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151289216UL, 4149575680UL,   {0}},
    { 1279U, 3342342973UL, 20,40,4294967294UL, 12, 18, 7, 15, 3067410304UL, 4015489024UL,   {0}},
    { 1279U, 3130010430UL, 20,40,4294967294UL, 12, 18, 7, 15, 3715951744UL, 4023746560UL,   {0}},
    { 1279U, 2811675455UL, 20,40,4294967294UL, 12, 18, 7, 15, 3113642880UL, 4014178304UL,   {0}},
    { 1279U, 3153615680UL, 20,40,4294967294UL, 12, 18, 7, 15, 2342286208UL, 4015489024UL,   {0}},
    { 1279U, 2988000065UL, 20,40,4294967294UL, 12, 18, 7, 15, 1524530048UL, 3948249088UL,   {0}},
    { 1279U, 3671515970UL, 20,40,4294967294UL, 12, 18, 7, 15, 2373283712UL, 3998711808UL,   {0}},
    { 1279U, 3311579971UL, 20,40,4294967294UL, 12, 18, 7, 15, 1169092480UL, 4005920768UL,   {0}},
    { 1279U, 2987641668UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480713088UL, 3982852096UL,   {0}},
    { 1279U, 2333483845UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470056320UL, 4149575680UL,   {0}},
    { 1279U, 3970865990UL, 20,40,4294967294UL, 12, 18, 7, 15, 2799072640UL, 4015357952UL,   {0}},
    { 1279U, 3162913607UL, 20,40,4294967294UL, 12, 18, 7, 15, 3606342528UL, 1867874304UL,   {0}},
    { 1279U, 2802350920UL, 20,40,4294967294UL, 12, 18, 7, 15, 3715299200UL, 4158095360UL,   {0}},
    { 1279U, 3395132233UL, 20,40,4294967294UL, 12, 18, 7, 15, 2627034240UL, 2011136000UL,   {0}},
    { 1279U, 3137192778UL, 20,40,4294967294UL, 12, 18, 7, 15, 3590253696UL, 4025188352UL,   {0}},
    { 1279U, 3299873611UL, 20,40,4294967294UL, 12, 18, 7, 15, 3451761280UL, 2010480640UL,   {0}},
    { 1279U, 2802903884UL, 20,40,4294967294UL, 12, 18, 7, 15, 584513152UL, 4023746560UL,   {0}},
    { 1279U, 3239318349UL, 20,40,4294967294UL, 12, 18, 7, 15, 3134700416UL, 4149575680UL,   {0}},
    { 1279U, 4097094478UL, 20,40,4294967294UL, 12, 18, 7, 15, 634845056UL, 4015357952UL,   {0}},
    { 1279U, 3328580431UL, 20,40,4294967294UL, 12, 18, 7, 15, 2373283712UL, 3998711808UL,   {0}},
    { 1279U, 2949536592UL, 20,40,4294967294UL, 12, 18, 7, 15, 2642112384UL, 3999236096UL,   {0}},
    { 1279U, 4162073425UL, 20,40,4294967294UL, 12, 18, 7, 15, 4000806528UL, 2010480640UL,   {0}},
    { 1279U, 3966677842UL, 20,40,4294967294UL, 12, 18, 7, 15, 4002737792UL, 3721756672UL,   {0}},
    { 1279U, 2281622355UL, 20,40,4294967294UL, 12, 18, 7, 15, 3000464256UL, 1870364672UL,   {0}},
    { 1279U, 3951967060UL, 20,40,4294967294UL, 12, 18, 7, 15, 3486890880UL, 2002092032UL,   {0}},
    { 1279U, 2677267285UL, 20,40,4294967294UL, 12, 18, 7, 15, 3604704128UL, 1866563584UL,   {0}},
    { 1279U, 3794139990UL, 20,40,4294967294UL, 12, 18, 7, 15, 4070403456UL, 1867874304UL,   {0}},
    { 1279U, 2766404439UL, 20,40,4294967294UL, 12, 18, 7, 15, 1305981824UL, 4149968896UL,   {0}},
    { 1279U, 3580531544UL, 20,40,4294967294UL, 12, 18, 7, 15, 3151297408UL, 4149575680UL,   {0}},
    { 1279U, 2243079001UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557821056UL, 3990716416UL,   {0}},
    { 1279U, 3975920474UL, 20,40,4294967294UL, 12, 18, 7, 15, 863335296UL, 4016930816UL,   {0}},
    { 1279U, 3111517019UL, 20,40,4294967294UL, 12, 18, 7, 15, 1968469632UL, 3990192128UL,   {0}},
    { 1279U, 4050965340UL, 20,40,4294967294UL, 12, 18, 7, 15, 3116784512UL, 4149444608UL,   {0}},
    { 1279U, 2954515293UL, 20,40,4294967294UL, 12, 18, 7, 15, 3663557248UL, 2008383488UL,   {0}},
    { 1279U, 2209297246UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557428096UL, 3981672448UL,   {0}},
    { 1279U, 3828136799UL, 20,40,4294967294UL, 12, 18, 7, 15, 3590155648UL, 1867874304UL,   {0}},
    { 1279U, 3532880736UL, 20,40,4294967294UL, 12, 18, 7, 15, 3008814336UL, 4126507008UL,   {0}},
    { 1279U, 2998063969UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117902592UL, 1867743232UL,   {0}},
    { 1279U, 2579503970UL, 20,40,4294967294UL, 12, 18, 7, 15, 4006918784UL, 2010480640UL,   {0}},
    { 1279U, 2515712867UL, 20,40,4294967294UL, 12, 18, 7, 15, 3114592896UL, 4023746560UL,   {0}},
    { 1279U, 4142992228UL, 20,40,4294967294UL, 12, 18, 7, 15, 2337567616UL, 4023877632UL,   {0}},
    { 1279U, 3057052517UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557460352UL, 4015489024UL,   {0}},
    { 1279U, 4211602278UL, 20,40,4294967294UL, 12, 18, 7, 15, 4076301696UL, 1868267520UL,   {0}},
    { 1279U, 3408575335UL, 20,40,4294967294UL, 12, 18, 7, 15, 3438638976UL, 3999760384UL,   {0}},
    { 1279U, 3328801640UL, 20,40,4294967294UL, 12, 18, 7, 15, 3958725504UL, 2002092032UL,   {0}},
    { 1279U, 3915232105UL, 20,40,4294967294UL, 12, 18, 7, 15, 3706550144UL, 4000808960UL,   {0}},
    { 1279U, 3040162666UL, 20,40,4294967294UL, 12, 18, 7, 15, 889027456UL, 4016668672UL,   {0}},
    { 1279U, 2719884139UL, 20,40,4294967294UL, 12, 18, 7, 15, 1666477440UL, 3990192128UL,   {0}},
    { 1279U, 2498192236UL, 20,40,4294967294UL, 12, 18, 7, 15, 727379584UL, 3989929984UL,   {0}},
    { 1279U, 3678804845UL, 20,40,4294967294UL, 12, 18, 7, 15, 3472029568UL, 3982852096UL,   {0}},
    { 1279U, 4192762734UL, 20,40,4294967294UL, 12, 18, 7, 15, 3116128896UL, 4157964288UL,   {0}},
    { 1279U, 2544016239UL, 20,40,4294967294UL, 12, 18, 7, 15, 3721719168UL, 4015357952UL,   {0}},
    { 1279U, 3211645808UL, 20,40,4294967294UL, 12, 18, 7, 15, 1987410816UL, 4016930816UL,   {0}},
    { 1279U, 2980305777UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641719168UL, 3999236096UL,   {0}},
    { 1279U, 4169827186UL, 20,40,4294967294UL, 12, 18, 7, 15, 2373285760UL, 3999694848UL,   {0}},
    { 1279U, 3316382579UL, 20,40,4294967294UL, 12, 18, 7, 15, 729119616UL, 3882188800UL,   {0}},
    { 1279U, 3207166836UL, 20,40,4294967294UL, 12, 18, 7, 15, 3470227328UL, 3986128896UL,   {0}},
    { 1279U, 2790364021UL, 20,40,4294967294UL, 12, 18, 7, 15, 2358603648UL, 3999236096UL,   {0}},
    { 1279U, 4033825654UL, 20,40,4294967294UL, 12, 18, 7, 15, 3606408064UL, 1867874304UL,   {0}},
    { 1279U, 2193392503UL, 20,40,4294967294UL, 12, 18, 7, 15, 3956651392UL, 2002092032UL,   {0}},
    { 1279U, 4103383928UL, 20,40,4294967294UL, 12, 18, 7, 15, 1574333824UL, 4020076544UL,   {0}},
    { 1279U, 3965754233UL, 20,40,4294967294UL, 12, 18, 7, 15, 3959250304UL, 2002092032UL,   {0}},
    { 1279U, 2241041274UL, 20,40,4294967294UL, 12, 18, 7, 15, 1970239360UL, 3883106304UL,   {0}},
    { 1279U, 2505028475UL, 20,40,4294967294UL, 12, 18, 7, 15, 2643942784UL, 2001436672UL,   {0}},
    { 1279U, 2410183548UL, 20,40,4294967294UL, 12, 18, 7, 15, 2628614016UL, 3992289280UL,   {0}},
    { 1279U, 4229274493UL, 20,40,4294967294UL, 12, 18, 7, 15, 1743091584UL, 4115234816UL,   {0}},
    { 1279U, 3596333950UL, 20,40,4294967294UL, 12, 18, 7, 15, 2778624896UL, 4014702592UL,   {0}},
    { 1279U, 3441804159UL, 20,40,4294967294UL, 12, 18, 7, 15, 1934982016UL, 4149575680UL,   {0}},
    { 1279U, 2574896000UL, 20,40,4294967294UL, 12, 18, 7, 15, 1305933696UL, 4015357952UL,   {0}},
    { 1279U, 2965584769UL, 20,40,4294967294UL, 12, 18, 7, 15, 3150802304UL, 1868005376UL,   {0}},
    { 1279U, 4256199554UL, 20,40,4294967294UL, 12, 18, 7, 15, 3950336640UL, 2010480640UL,   {0}},
    { 1279U, 2201617283UL, 20,40,4294967294UL, 12, 18, 7, 15, 1973384832UL, 3891625984UL,   {0}},
    { 1279U, 2156991364UL, 20,40,4294967294UL, 12, 18, 7, 15, 1803383552UL, 4157964288UL,   {0}},
    { 1279U, 3700067205UL, 20,40,4294967294UL, 12, 18, 7, 15, 3598019456UL, 1867874304UL,   {0}},
    { 1279U, 3446809478UL, 20,40,4294967294UL, 12, 18, 7, 15, 1737782912UL, 3990192128UL,   {0}},
    { 1279U, 2205639559UL, 20,40,4294967294UL, 12, 18, 7, 15, 729640320UL, 4023746560UL,   {0}},
    { 1279U, 2675739528UL, 20,40,4294967294UL, 12, 18, 7, 15, 1554708096UL, 3990192128UL,   {0}},
    { 1279U, 2809981833UL, 20,40,4294967294UL, 12, 18, 7, 15, 1989638016UL, 3998449664UL,   {0}},
    { 1279U, 2887166858UL, 20,40,4294967294UL, 12, 18, 7, 15, 577598336UL, 4017455104UL,   {0}},
    { 1279U, 3168596875UL, 20,40,4294967294UL, 12, 18, 7, 15, 2555869056UL, 3981803520UL,   {0}},
    { 1279U, 2709156748UL, 20,40,4294967294UL, 12, 18, 7, 15, 735768448UL, 3981541376UL,   {0}},
    { 1279U, 2713459597UL, 20,40,4294967294UL, 12, 18, 7, 15, 3572952960UL, 3981803520UL,   {0}},
    { 1279U, 2569157518UL, 20,40,4294967294UL, 12, 18, 7, 15, 3572985216UL, 2074705920UL,   {0}},
    { 1279U, 3392056207UL, 20,40,4294967294UL, 12, 18, 7, 15, 1557821056UL, 3990192128UL,   {0}},
    { 1279U, 2397916048UL, 20,40,4294967294UL, 12, 18, 7, 15, 1247737472UL, 3990192128UL,   {0}},
    { 1279U, 2791598993UL, 20,40,4294967294UL, 12, 18, 7, 15, 861233024UL, 4126638080UL,   {0}},
    { 1279U, 2450699154UL, 20,40,4294967294UL, 12, 18, 7, 15, 2610785664UL, 1868005376UL,   {0}},
    { 1279U, 4288504723UL, 20,40,4294967294UL, 12, 18, 7, 15, 836040576UL, 3981803520UL,   {0}},
    { 1279U, 3508183956UL, 20,40,4294967294UL, 12, 18, 7, 15, 3015994240UL, 4015489024UL,   {0}},
    { 1279U, 2612898709UL, 20,40,4294967294UL, 12, 18, 7, 15, 2724130688UL, 4006969344UL,   {0}},
    { 1279U, 3442267030UL, 20,40,4294967294UL, 12, 18, 7, 15, 1991736192UL, 4025319424UL,   {0}},
    { 1279U, 3972103063UL, 20,40,4294967294UL, 12, 18, 7, 15, 834072448UL, 3990192128UL,   {0}},
    { 1279U, 2233455512UL, 20,40,4294967294UL, 12, 18, 7, 15, 3142802816UL, 2009956352UL,   {0}},
    { 1279U, 2832982937UL, 20,40,4294967294UL, 12, 18, 7, 15, 1973252736UL, 4023746560UL,   {0}},
    { 1279U, 2322576282UL, 20,40,4294967294UL, 12, 18, 7, 15, 1725396864UL, 3998449664UL,   {0}},
    { 1279U, 3991434139UL, 20,40,4294967294UL, 12, 18, 7, 15, 3598085504UL, 1834319872UL,   {0}},
    { 1279U, 2211224476UL, 20,40,4294967294UL, 12, 18, 7, 15, 1985855104UL, 4090855424UL,   {0}},
    { 1279U, 3141049245UL, 20,40,4294967294UL, 12, 18, 7, 15, 3597986432UL, 4023681024UL,   {0}},
    { 1279U, 2996128670UL, 20,40,4294967294UL, 12, 18, 7, 15, 3137170816UL, 1867874304UL,   {0}},
    { 1279U, 3558130591UL, 20,40,4294967294UL, 12, 18, 7, 15, 3472324480UL, 3982852096UL,   {0}},
    { 1279U, 3911160736UL, 20,40,4294967294UL, 12, 18, 7, 15, 3434396288UL, 4157964288UL,   {0}},
    { 1279U, 3510520737UL, 20,40,4294967294UL, 12, 18, 7, 15, 4087180160UL, 1868136448UL,   {0}},
    { 1279U, 2238698402UL, 20,40,4294967294UL, 12, 18, 7, 15, 1490450048UL, 3986128896UL,   {0}},
    { 1279U, 2576257955UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629065600UL, 4145512448UL,   {0}},
    { 1279U, 3868314532UL, 20,40,4294967294UL, 12, 18, 7, 15, 3486825344UL, 4149510144UL,   {0}},
    { 1279U, 2971403173UL, 20,40,4294967294UL, 12, 18, 7, 15, 651523968UL, 3998580736UL,   {0}},
    { 1279U, 3353076646UL, 20,40,4294967294UL, 12, 18, 7, 15, 831975040UL, 3721756672UL,   {0}},
    { 1279U, 2965353383UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480582016UL, 3982852096UL,   {0}},
    { 1279U, 2894279592UL, 20,40,4294967294UL, 12, 18, 7, 15, 3117734784UL, 4149313536UL,   {0}},
    { 1279U, 3375879081UL, 20,40,4294967294UL, 12, 18, 7, 15, 2371253120UL, 4025188352UL,   {0}},
    { 1279U, 4289885098UL, 20,40,4294967294UL, 12, 18, 7, 15, 1701673856UL, 3957686272UL,   {0}},
    { 1279U, 3412040619UL, 20,40,4294967294UL, 12, 18, 7, 15, 1742043008UL, 4015357952UL,   {0}},
    { 1279U, 3386098604UL, 20,40,4294967294UL, 12, 18, 7, 15, 1987410816UL, 3882188800UL,   {0}},
    { 1279U, 3103957933UL, 20,40,4294967294UL, 12, 18, 7, 15, 2364828544UL, 4015489024UL,   {0}},
    { 1279U, 3386004398UL, 20,40,4294967294UL, 12, 18, 7, 15, 1956476800UL, 3866591232UL,   {0}},
    { 1279U, 4055305135UL, 20,40,4294967294UL, 12, 18, 7, 15, 3453793152UL, 4149575680UL,   {0}},
    { 1279U, 2981721008UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480548992UL, 3991240704UL,   {0}},
    { 1279U, 3986445233UL, 20,40,4294967294UL, 12, 18, 7, 15, 1844804992UL, 4150231040UL,   {0}},
    { 1279U, 3724747698UL, 20,40,4294967294UL, 12, 18, 7, 15, 1289075584UL, 4153769984UL,   {0}},
    { 1279U, 2415260595UL, 20,40,4294967294UL, 12, 18, 7, 15, 3143429504UL, 4022697984UL,   {0}},
    { 1279U, 2555511732UL, 20,40,4294967294UL, 12, 18, 7, 15, 1289024896UL, 4015489024UL,   {0}},
    { 1279U, 2614840245UL, 20,40,4294967294UL, 12, 18, 7, 15, 594375552UL, 4017455104UL,   {0}},
    { 1279U, 2249073590UL, 20,40,4294967294UL, 12, 18, 7, 15, 634745728UL, 4015357952UL,   {0}},
    { 1279U, 3871196087UL, 20,40,4294967294UL, 12, 18, 7, 15, 1722513024UL, 4158095360UL,   {0}},
    { 1279U, 4256994232UL, 20,40,4294967294UL, 12, 18, 7, 15, 743759744UL, 4123754496UL,   {0}},
    { 1279U, 3295347641UL, 20,40,4294967294UL, 12, 18, 7, 15, 1901491840UL, 3990192128UL,   {0}},
    { 1279U, 3679196090UL, 20,40,4294967294UL, 12, 18, 7, 15, 700803968UL, 4015357952UL,   {0}},
    { 1279U, 2796614587UL, 20,40,4294967294UL, 12, 18, 7, 15, 836066176UL, 4149313536UL,   {0}},
    { 1279U, 2580581308UL, 20,40,4294967294UL, 12, 18, 7, 15, 4076301696UL, 1868201984UL,   {0}},
    { 1279U, 3327103933UL, 20,40,4294967294UL, 12, 18, 7, 15, 3721754368UL, 3981803520UL,   {0}},
    { 1279U, 2834508734UL, 20,40,4294967294UL, 12, 18, 7, 15, 1701674880UL, 3924131840UL,   {0}},
    { 1279U, 2510267327UL, 20,40,4294967294UL, 12, 18, 7, 15, 1934712704UL, 4116021248UL,   {0}},
    { 1279U, 2656345024UL, 20,40,4294967294UL, 12, 18, 7, 15, 3590125440UL, 4149575680UL,   {0}},
    { 1279U, 2967839681UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629000064UL, 2006417408UL,   {0}},
    { 1279U, 3349947330UL, 20,40,4294967294UL, 12, 18, 7, 15, 3714938752UL, 4000808960UL,   {0}},
    { 1279U, 3896253379UL, 20,40,4294967294UL, 12, 18, 7, 15, 3000987008UL, 1868267520UL,   {0}},
    { 1279U, 2588828612UL, 20,40,4294967294UL, 12, 18, 7, 15, 3593792128UL, 4023746560UL,   {0}},
    { 1279U, 2630388677UL, 20,40,4294967294UL, 12, 18, 7, 15, 3453268864UL, 4149575680UL,   {0}},
    { 1279U, 4000062406UL, 20,40,4294967294UL, 12, 18, 7, 15, 729116544UL, 3981737984UL,   {0}},
    { 1279U, 3275037639UL, 20,40,4294967294UL, 12, 18, 7, 15, 1314158464UL, 3981672448UL,   {0}},
    { 1279U, 2921243592UL, 20,40,4294967294UL, 12, 18, 7, 15, 3180787328UL, 4023746560UL,   {0}},
    { 1279U, 2458094537UL, 20,40,4294967294UL, 12, 18, 7, 15, 3332828032UL, 4022566912UL,   {0}},
    { 1279U, 3903026122UL, 20,40,4294967294UL, 12, 18, 7, 15, 1701804928UL, 3958079488UL,   {0}},
    { 1279U, 2431370187UL, 20,40,4294967294UL, 12, 18, 7, 15, 3573345408UL, 4023877632UL,   {0}},
    { 1279U, 3479565260UL, 20,40,4294967294UL, 12, 18, 7, 15, 1733719680UL, 3990323200UL,   {0}},
    { 1279U, 3493985229UL, 20,40,4294967294UL, 12, 18, 7, 15, 3137170816UL, 1867874304UL,   {0}},
    { 1279U, 2483471310UL, 20,40,4294967294UL, 12, 18, 7, 15, 3019142016UL, 4016537600UL,   {0}},
    { 1279U, 3357125583UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641719168UL, 3999236096UL,   {0}},
    { 1279U, 2547256272UL, 20,40,4294967294UL, 12, 18, 7, 15, 3449091712UL, 4025974784UL,   {0}},
    { 1279U, 3655539665UL, 20,40,4294967294UL, 12, 18, 7, 15, 1795078016UL, 3981803520UL,   {0}},
    { 1279U, 3491345362UL, 20,40,4294967294UL, 12, 18, 7, 15, 2628547456UL, 4025974784UL,   {0}},
    { 1279U, 2800606163UL, 20,40,4294967294UL, 12, 18, 7, 15, 2626973056UL, 4016013312UL,   {0}},
    { 1279U, 2311431124UL, 20,40,4294967294UL, 12, 18, 7, 15, 895188864UL, 3881271296UL,   {0}},
    { 1279U, 3301678037UL, 20,40,4294967294UL, 12, 18, 7, 15, 3480582016UL, 3982852096UL,   {0}},
    { 1279U, 3468037078UL, 20,40,4294967294UL, 12, 18, 7, 15, 1977513600UL, 3990192128UL,   {0}},
    { 1279U, 3588318167UL, 20,40,4294967294UL, 12, 18, 7, 15, 586119040UL, 4017455104UL,   {0}},
    { 1279U, 3842755544UL, 20,40,4294967294UL, 12, 18, 7, 15, 846559104UL, 4016537600UL,   {0}},
    { 1279U, 2886628313UL, 20,40,4294967294UL, 12, 18, 7, 15, 729117568UL, 4158095360UL,   {0}},
    { 1279U, 3075017690UL, 20,40,4294967294UL, 12, 18, 7, 15, 3723327360UL, 3983900672UL,   {0}},
    { 1279U, 2318697435UL, 20,40,4294967294UL, 12, 18, 7, 15, 2863822464UL, 4158095360UL,   {0}},
    { 1279U, 2980230108UL, 20,40,4294967294UL, 12, 18, 7, 15, 3447027584UL, 3999760384UL,   {0}},
    { 1279U, 3939259357UL, 20,40,4294967294UL, 12, 18, 7, 15, 3488963456UL, 2002223104UL,   {0}},
    { 1279U, 3621970910UL, 20,40,4294967294UL, 12, 18, 7, 15, 664598400UL, 3989536768UL,   {0}},
    { 1279U, 2238637023UL, 20,40,4294967294UL, 12, 18, 7, 15, 3067541376UL, 4015357952UL,   {0}},
    { 1279U, 3011904480UL, 20,40,4294967294UL, 12, 18, 7, 15, 664598400UL, 3989536768UL,   {0}},
    { 1279U, 3110503393UL, 20,40,4294967294UL, 12, 18, 7, 15, 2341762688UL, 3990192128UL,   {0}},
    { 1279U, 3405038562UL, 20,40,4294967294UL, 12, 18, 7, 15, 1553657728UL, 4006969344UL,   {0}},
    { 1279U, 3423353827UL, 20,40,4294967294UL, 12, 18, 7, 15, 3403511424UL, 3990192128UL,   {0}},
    { 1279U, 2603090916UL, 20,40,4294967294UL, 12, 18, 7, 15, 903182208UL, 3981803520UL,   {0}},
    { 1279U, 3815875557UL, 20,40,4294967294UL, 12, 18, 7, 15, 3700747136UL, 4023877632UL,   {0}},
    { 1279U, 2856786918UL, 20,40,4294967294UL, 12, 18, 7, 15, 2606592640UL, 2010480640UL,   {0}},
    { 1279U, 3677991911UL, 20,40,4294967294UL, 12, 18, 7, 15, 3646257024UL, 1851228160UL,   {0}},
    { 1279U, 4282129384UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629071744UL, 4026499072UL,   {0}},
    { 1279U, 2807935977UL, 20,40,4294967294UL, 12, 18, 7, 15, 3949288320UL, 2008252416UL,   {0}},
    { 1279U, 3080627178UL, 20,40,4294967294UL, 12, 18, 7, 15, 592770944UL, 3990061056UL,   {0}},
    { 1279U, 3607217131UL, 20,40,4294967294UL, 12, 18, 7, 15, 1844804992UL, 4150231040UL,   {0}},
    { 1279U, 3688532972UL, 20,40,4294967294UL, 12, 18, 7, 15, 3973364352UL, 2010480640UL,   {0}},
    { 1279U, 2184420333UL, 20,40,4294967294UL, 12, 18, 7, 15, 2473426816UL, 3849682944UL,   {0}},
    { 1279U, 4134869998UL, 20,40,4294967294UL, 12, 18, 7, 15, 2641196928UL, 3992289280UL,   {0}},
    { 1279U, 2187002863UL, 20,40,4294967294UL, 12, 18, 7, 15, 3008683264UL, 4126638080UL,   {0}},
    { 1279U, 2291960816UL, 20,40,4294967294UL, 12, 18, 7, 15, 650570624UL, 4015357952UL,   {0}},
    { 1279U, 4138154993UL, 20,40,4294967294UL, 12, 18, 7, 15, 729117568UL, 4158095360UL,   {0}},
    { 1279U, 3391953906UL, 20,40,4294967294UL, 12, 18, 7, 15, 3958725504UL, 2002092032UL,   {0}},
    { 1279U, 2978941939UL, 20,40,4294967294UL, 12, 18, 7, 15, 3597986432UL, 4023746560UL,   {0}},
    { 1279U, 2743442420UL, 20,40,4294967294UL, 12, 18, 7, 15, 2629131136UL, 2006417408UL,   {0}},
    { 1279U, 3449863157UL, 20,40,4294967294UL, 12, 18, 7, 15, 3185012096UL, 1868267520UL,   {0}},
    { 1279U, 3318608886UL, 20,40,4294967294UL, 12, 18, 7, 15, 3394564736UL, 4023746560UL,   {0}},
    { 1279U, 2771913719UL, 20,40,4294967294UL, 12, 18, 7, 15, 903149440UL, 3981803520UL,   {0}},
    { 1279U, 3583144952UL, 20,40,4294967294UL, 12, 18, 7, 15, 836169600UL, 3980754944UL,   {0}},
    { 1279U, 4148317177UL, 20,40,4294967294UL, 12, 18, 7, 15, 3696946816UL, 3990454272UL,   {0}},
    { 1279U, 2852127738UL, 20,40,4294967294UL, 12, 18, 7, 15, 1700690816UL, 3948249088UL,   {0}},
    { 1279U, 2988467195UL, 20,40,4294967294UL, 12, 18, 7, 15, 2800417664UL, 4017455104UL,   {0}},
    { 1279U, 3699010556UL, 20,40,4294967294UL, 12, 18, 7, 15, 3685512064UL, 2002092032UL,   {0}},
    { 1279U, 2543115261UL, 20,40,4294967294UL, 12, 18, 7, 15, 3656710016UL, 4149444608UL,   {0}},
    { 1279U, 3417146366UL, 20,40,4294967294UL, 12, 18, 7, 15, 3688594304UL, 4149313536UL,   {0}},
    { 1279U, 2569280511UL, 20,40,4294967294UL, 12, 18, 7, 15, 1737913984UL, 3990323200UL,   {0}},
    { 2281U, 3197292544UL, 36,72,4286578688UL, 12, 18, 7, 15, 3981143296UL, 3755311104UL,   {0}},
    { 2281U, 4230268929UL, 36,72,4286578688UL, 12, 18, 7, 15, 3974457984UL, 3755311104UL,   {0}},
    { 2281U, 3380213762UL, 36,72,4286578688UL, 12, 18, 7, 15, 2919067392UL, 3738664960UL,  {0}},
    { 2281U, 3342260227UL, 36,72,4286578688UL, 12, 18, 7, 15, 2901752704UL, 4150755328UL,  {0}},
    { 2281U, 3315630084UL, 36,72,4286578688UL, 12, 18, 7, 15, 1987360640UL, 4292149248UL,  {0}},
    { 2281U, 3609526277UL, 36,72,4286578688UL, 12, 18, 7, 15, 771046016UL, 4157964288UL,  {0}},
    { 2281U, 3291236358UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931112704UL, 4157931520UL,  {0}},
    { 2281U, 2526124039UL, 36,72,4286578688UL, 12, 18, 7, 15, 4017535616UL, 4157964288UL,  {0}},
    { 2281U, 3432202248UL, 36,72,4286578688UL, 12, 18, 7, 15, 3974411648UL, 4289036288UL,  {0}},
    { 2281U, 2872752137UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140402048UL, 4160061440UL,  {0}},
    { 2281U, 3635300362UL, 36,72,4286578688UL, 12, 18, 7, 15, 3971263104UL, 4157964288UL,  {0}},
    { 2281U, 3701164043UL, 36,72,4286578688UL, 12, 18, 7, 15, 4082464128UL, 4025810944UL,  {0}},
    { 2281U, 2153709580UL, 36,72,4286578688UL, 12, 18, 7, 15, 3986517760UL, 3738664960UL,  {0}},
    { 2281U, 2753030157UL, 36,72,4286578688UL, 12, 18, 7, 15, 3136646784UL, 3757408256UL,  {0}},
    { 2281U, 3276969998UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149216384UL, 4160028672UL,  {0}},
    { 2281U, 2830499855UL, 36,72,4286578688UL, 12, 18, 7, 15, 2041363328UL, 4160061440UL,  {0}},
    { 2281U, 3898863632UL, 36,72,4286578688UL, 12, 18, 7, 15, 3061112192UL, 4225073152UL,  {0}},
    { 2281U, 2214467601UL, 36,72,4286578688UL, 12, 18, 7, 15, 3146608256UL, 3722936320UL,  {0}},
    { 2281U, 2495420434UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931768192UL, 4150624256UL,  {0}},
    { 2281U, 2841929747UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149314688UL, 4159012864UL,  {0}},
    { 2281U, 3664506900UL, 36,72,4286578688UL, 12, 18, 7, 15, 1857862528UL, 4150624256UL,  {0}},
    { 2281U, 3137388565UL, 36,72,4286578688UL, 12, 18, 7, 15, 3874844416UL, 3720708096UL,  {0}},
    { 2281U, 3292813334UL, 36,72,4286578688UL, 12, 18, 7, 15, 2948152192UL, 4159930368UL,  {0}},
    { 2281U, 3120025623UL, 36,72,4286578688UL, 12, 18, 7, 15, 984951680UL, 4151771136UL,  {0}},
    { 2281U, 3588304920UL, 36,72,4286578688UL, 12, 18, 7, 15, 2067230464UL, 3739582464UL,  {0}},
    { 2281U, 2674020377UL, 36,72,4286578688UL, 12, 18, 7, 15, 3148135296UL, 4160061440UL,  {0}},
    { 2281U, 3951237146UL, 36,72,4286578688UL, 12, 18, 7, 15, 4008521472UL, 3721756672UL,  {0}},
    { 2281U, 3919724571UL, 36,72,4286578688UL, 12, 18, 7, 15, 3874844288UL, 3721723904UL,  {0}},
    { 2281U, 2961156124UL, 36,72,4286578688UL, 12, 18, 7, 15, 901569920UL, 4225073152UL,  {0}},
    { 2281U, 3866888221UL, 36,72,4286578688UL, 12, 18, 7, 15, 1839689600UL, 4285890560UL,  {0}},
    { 2281U, 3425775646UL, 36,72,4286578688UL, 12, 18, 7, 15, 2762136960UL, 4294115328UL,  {0}},
    { 2281U, 3219666975UL, 36,72,4286578688UL, 12, 18, 7, 15, 3134499712UL, 4155867136UL,  {0}},
    { 2281U, 3323494432UL, 36,72,4286578688UL, 12, 18, 7, 15, 3134012160UL, 4159275008UL,  {0}},
    { 2281U, 3014842401UL, 36,72,4286578688UL, 12, 18, 7, 15, 3988188416UL, 3755311104UL,  {0}},
    { 2281U, 3082670114UL, 36,72,4286578688UL, 12, 18, 7, 15, 3148659328UL, 4158980096UL,  {0}},
    { 2281U, 2693306403UL, 36,72,4286578688UL, 12, 18, 7, 15, 4223102720UL, 3737452544UL,  {0}},
    { 2281U, 4014817316UL, 36,72,4286578688UL, 12, 18, 7, 15, 2004147584UL, 4225073152UL,  {0}},
    { 2281U, 3324942373UL, 36,72,4286578688UL, 12, 18, 7, 15, 3077889408UL, 4227170304UL,  {0}},
    { 2281U, 3138132006UL, 36,72,4286578688UL, 12, 18, 7, 15, 3971263104UL, 4158095360UL,  {0}},
    { 2281U, 2682286119UL, 36,72,4286578688UL, 12, 18, 7, 15, 2793201024UL, 4223991808UL,  {0}},
    { 2281U, 2559911976UL, 36,72,4286578688UL, 12, 18, 7, 15, 995441408UL, 4157964288UL,  {0}},
    { 2281U, 3372875817UL, 36,72,4286578688UL, 12, 18, 7, 15, 1534835328UL, 3086417920UL,  {0}},
    { 2281U, 3108821034UL, 36,72,4286578688UL, 12, 18, 7, 15, 848656256UL, 4017455104UL,  {0}},
    { 2281U, 2449870891UL, 36,72,4286578688UL, 12, 18, 7, 15, 1945941888UL, 4275535872UL,  {0}},
    { 2281U, 3290703916UL, 36,72,4286578688UL, 12, 18, 7, 15, 896720000UL, 4224942080UL,  {0}},
    { 2281U, 2882957357UL, 36,72,4286578688UL, 12, 18, 7, 15, 3135585152UL, 4149575680UL,  {0}},
    { 2281U, 2432485422UL, 36,72,4286578688UL, 12, 18, 7, 15, 4025839232UL, 3721756672UL,  {0}},
    { 2281U, 3082786863UL, 36,72,4286578688UL, 12, 18, 7, 15, 3980226432UL, 3755442176UL,  {0}},
    { 2281U, 4194838576UL, 36,72,4286578688UL, 12, 18, 7, 15, 3988221696UL, 3738533888UL,  {0}},
    { 2281U, 3393421361UL, 36,72,4286578688UL, 12, 18, 7, 15, 3086278016UL, 4225073152UL,  {0}},
    { 2281U, 2437615666UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931768192UL, 4159143936UL,  {0}},
    { 2281U, 3552008243UL, 36,72,4286578688UL, 12, 18, 7, 15, 766326144UL, 4291133440UL,  {0}},
    { 2281U, 2438338612UL, 36,72,4286578688UL, 12, 18, 7, 15, 2069707520UL, 4159143936UL,  {0}},
    { 2281U, 2310604853UL, 36,72,4286578688UL, 12, 18, 7, 15, 1996447360UL, 4225073152UL,  {0}},
    { 2281U, 3759093814UL, 36,72,4286578688UL, 12, 18, 7, 15, 921230080UL, 4292182016UL,  {0}},
    { 2281U, 2739241015UL, 36,72,4286578688UL, 12, 18, 7, 15, 2775375232UL, 4225040384UL,  {0}},
    { 2281U, 4006101048UL, 36,72,4286578688UL, 12, 18, 7, 15, 2037693312UL, 4160061440UL,  {0}},
    { 2281U, 3296077881UL, 36,72,4286578688UL, 12, 18, 7, 15, 4000673408UL, 3721756672UL,  {0}},
    { 2281U, 2616162362UL, 36,72,4286578688UL, 12, 18, 7, 15, 2930208384UL, 3721756672UL,  {0}},
    { 2281U, 3199391803UL, 36,72,4286578688UL, 12, 18, 7, 15, 917854848UL, 4294246400UL,  {0}},
    { 2281U, 4171657276UL, 36,72,4286578688UL, 12, 18, 7, 15, 3981274496UL, 3755442176UL,  {0}},
    { 2281U, 3266820157UL, 36,72,4286578688UL, 12, 18, 7, 15, 971324032UL, 4157964288UL,  {0}},
    { 2281U, 3654830142UL, 36,72,4286578688UL, 12, 18, 7, 15, 3967117952UL, 3755311104UL,  {0}},
    { 2281U, 2822803519UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995792256UL, 4225597440UL,  {0}},
    { 2281U, 2312849472UL, 36,72,4286578688UL, 12, 18, 7, 15, 1840606592UL, 4294279168UL,  {0}},
    { 2281U, 3969617985UL, 36,72,4286578688UL, 12, 18, 7, 15, 786250496UL, 4157046784UL,  {0}},
    { 2281U, 2227925058UL, 36,72,4286578688UL, 12, 18, 7, 15, 754281344UL, 3756326912UL,  {0}},
    { 2281U, 2230913091UL, 36,72,4286578688UL, 12, 18, 7, 15, 3136745088UL, 3757408256UL,  {0}},
    { 2281U, 3351347268UL, 36,72,4286578688UL, 12, 18, 7, 15, 1931308800UL, 3738664960UL,  {0}},
    { 2281U, 2513012805UL, 36,72,4286578688UL, 12, 18, 7, 15, 2801458304UL, 4225204224UL,  {0}},
    { 2281U, 3615109190UL, 36,72,4286578688UL, 12, 18, 7, 15, 933541760UL, 4277567488UL,  {0}},
    { 2281U, 3166525511UL, 36,72,4286578688UL, 12, 18, 7, 15, 3937891968UL, 3754229760UL,  {0}},
    { 2281U, 4076109896UL, 36,72,4286578688UL, 12, 18, 7, 15, 888462720UL, 4225073152UL,  {0}},
    { 2281U, 2160492617UL, 36,72,4286578688UL, 12, 18, 7, 15, 2037824384UL, 4160585728UL,  {0}},
    { 2281U, 3490938954UL, 36,72,4286578688UL, 12, 18, 7, 15, 4018106240UL, 3721887744UL,  {0}},
    { 2281U, 3242473547UL, 36,72,4286578688UL, 12, 18, 7, 15, 917822080UL, 4292182016UL,  {0}},
    { 2281U, 4171966540UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140972288UL, 3737452544UL,  {0}},
    { 2281U, 3856078925UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991587456UL, 4293230592UL,  {0}},
    { 2281U, 3186722894UL, 36,72,4286578688UL, 12, 18, 7, 15, 3736434304UL, 4024795136UL,  {0}},
    { 2281U, 2597525583UL, 36,72,4286578688UL, 12, 18, 7, 15, 2007326080UL, 4224024576UL,  {0}},
    { 2281U, 3347316816UL, 36,72,4286578688UL, 12, 18, 7, 15, 1975336832UL, 4227268608UL,  {0}},
    { 2281U, 4023722065UL, 36,72,4286578688UL, 12, 18, 7, 15, 1840606592UL, 4294279168UL,  {0}},
    { 2281U, 3417389138UL, 36,72,4286578688UL, 12, 18, 7, 15, 771570560UL, 4157702144UL,  {0}},
    { 2281U, 2817589331UL, 36,72,4286578688UL, 12, 18, 7, 15, 783629184UL, 4159012864UL,  {0}},
    { 2281U, 2654353492UL, 36,72,4286578688UL, 12, 18, 7, 15, 1943353088UL, 4274290688UL,  {0}},
    { 2281U, 3285184597UL, 36,72,4286578688UL, 12, 18, 7, 15, 3076863872UL, 4277633024UL,  {0}},
    { 2281U, 3320445014UL, 36,72,4286578688UL, 12, 18, 7, 15, 3145547648UL, 4143284224UL,  {0}},
    { 2281U, 2580410455UL, 36,72,4286578688UL, 12, 18, 7, 15, 963996416UL, 3754262528UL,  {0}},
    { 2281U, 2626510936UL, 36,72,4286578688UL, 12, 18, 7, 15, 3065329280UL, 4294279168UL,  {0}},
    { 2281U, 3824969817UL, 36,72,4286578688UL, 12, 18, 7, 15, 2075966336UL, 4160061440UL,  {0}},
    { 2281U, 2980610138UL, 36,72,4286578688UL, 12, 18, 7, 15, 3118906240UL, 4155736064UL,  {0}},
    { 2281U, 3028052059UL, 36,72,4286578688UL, 12, 18, 7, 15, 978758528UL, 4156882944UL,  {0}},
    { 2281U, 3502825564UL, 36,72,4286578688UL, 12, 18, 7, 15, 2908712576UL, 3739582464UL,  {0}},
    { 2281U, 4070064221UL, 36,72,4286578688UL, 12, 18, 7, 15, 754767104UL, 4291133440UL,  {0}},
    { 2281U, 3743291486UL, 36,72,4286578688UL, 12, 18, 7, 15, 4016257920UL, 4155736064UL,  {0}},
    { 2281U, 3497160799UL, 36,72,4286578688UL, 12, 18, 7, 15, 3076840832UL, 4223991808UL,  {0}},
    { 2281U, 3701811296UL, 36,72,4286578688UL, 12, 18, 7, 15, 1994217088UL, 4024762368UL,  {0}},
    { 2281U, 2507855969UL, 36,72,4286578688UL, 12, 18, 7, 15, 3207936768UL, 4160061440UL,  {0}},
    { 2281U, 3936295010UL, 36,72,4286578688UL, 12, 18, 7, 15, 4214714112UL, 3723853824UL,  {0}},
    { 2281U, 3934738531UL, 36,72,4286578688UL, 12, 18, 7, 15, 4023742080UL, 3720708096UL,  {0}},
    { 2281U, 3073632356UL, 36,72,4286578688UL, 12, 18, 7, 15, 4213665408UL, 3723853824UL,  {0}},
    { 2281U, 4145686629UL, 36,72,4286578688UL, 12, 18, 7, 15, 2758860160UL, 4225597440UL,  {0}},
    { 2281U, 3198402662UL, 36,72,4286578688UL, 12, 18, 7, 15, 880074112UL, 4224024576UL,  {0}},
    { 2281U, 2980251751UL, 36,72,4286578688UL, 12, 18, 7, 15, 1861447552UL, 4257579008UL,  {0}},
    { 2281U, 2989068392UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153424000UL, 3721756672UL,  {0}},
    { 2281U, 4094154857UL, 36,72,4286578688UL, 12, 18, 7, 15, 1874161280UL, 4258627584UL,  {0}},
    { 2281U, 3555688554UL, 36,72,4286578688UL, 12, 18, 7, 15, 2908712320UL, 3755311104UL,  {0}},
    { 2281U, 4122855531UL, 36,72,4286578688UL, 12, 18, 7, 15, 985493376UL, 3747971072UL,  {0}},
    { 2281U, 2617086060UL, 36,72,4286578688UL, 12, 18, 7, 15, 2998220416UL, 4292182016UL,  {0}},
    { 2281U, 3602489453UL, 36,72,4286578688UL, 12, 18, 7, 15, 2792281984UL, 4293230592UL,  {0}},
    { 2281U, 3990671470UL, 36,72,4286578688UL, 12, 18, 7, 15, 3686087552UL, 4160028672UL,  {0}},
    { 2281U, 2689296495UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008505728UL, 4225073152UL,  {0}},
    { 2281U, 4195254384UL, 36,72,4286578688UL, 12, 18, 7, 15, 769095296UL, 3756326912UL,  {0}},
    { 2281U, 2476064881UL, 36,72,4286578688UL, 12, 18, 7, 15, 3134499712UL, 4155867136UL,  {0}},
    { 2281U, 4118456434UL, 36,72,4286578688UL, 12, 18, 7, 15, 995572480UL, 4157931520UL,  {0}},
    { 2281U, 2390610035UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149229824UL, 3737485312UL,  {0}},
    { 2281U, 3419168884UL, 36,72,4286578688UL, 12, 18, 7, 15, 2807486336UL, 4272259072UL,  {0}},
    { 2281U, 3216072821UL, 36,72,4286578688UL, 12, 18, 7, 15, 4197789312UL, 3723853824UL,  {0}},
    { 2281U, 2201319542UL, 36,72,4286578688UL, 12, 18, 7, 15, 3134667648UL, 4149575680UL,  {0}},
    { 2281U, 2841524343UL, 36,72,4286578688UL, 12, 18, 7, 15, 926374528UL, 4291133440UL,  {0}},
    { 2281U, 3791081592UL, 36,72,4286578688UL, 12, 18, 7, 15, 2934389376UL, 4160192512UL,  {0}},
    { 2281U, 3457261689UL, 36,72,4286578688UL, 12, 18, 7, 15, 3061112192UL, 4224024576UL,  {0}},
    { 2281U, 3976241274UL, 36,72,4286578688UL, 12, 18, 7, 15, 1705078144UL, 3754393600UL,  {0}},
    { 2281U, 2973935739UL, 36,72,4286578688UL, 12, 18, 7, 15, 4155856640UL, 4008148992UL,  {0}},
    { 2281U, 2947799164UL, 36,72,4286578688UL, 12, 18, 7, 15, 649944960UL, 4224024576UL,  {0}},
    { 2281U, 2801866877UL, 36,72,4286578688UL, 12, 18, 7, 15, 3925178112UL, 3738501120UL,  {0}},
    { 2281U, 3398574206UL, 36,72,4286578688UL, 12, 18, 7, 15, 2796871040UL, 4225073152UL,  {0}},
    { 2281U, 2491660415UL, 36,72,4286578688UL, 12, 18, 7, 15, 767374976UL, 4294279168UL,  {0}},
    { 2281U, 3530487936UL, 36,72,4286578688UL, 12, 18, 7, 15, 3985468800UL, 3755311104UL,  {0}},
    { 2281U, 4020887681UL, 36,72,4286578688UL, 12, 18, 7, 15, 2906615680UL, 3737452544UL,  {0}},
    { 2281U, 2805186690UL, 36,72,4286578688UL, 12, 18, 7, 15, 2905960320UL, 3738533888UL,  {0}},
    { 2281U, 2759899267UL, 36,72,4286578688UL, 12, 18, 7, 15, 2074570624UL, 3714416640UL,  {0}},
    { 2281U, 2605428868UL, 36,72,4286578688UL, 12, 18, 7, 15, 4214714112UL, 3740631040UL,  {0}},
    { 2281U, 3575406725UL, 36,72,4286578688UL, 12, 18, 7, 15, 995572480UL, 4157964288UL,  {0}},
    { 2281U, 2916016262UL, 36,72,4286578688UL, 12, 18, 7, 15, 1990024064UL, 4291133440UL,  {0}},
    { 2281U, 2196553863UL, 36,72,4286578688UL, 12, 18, 7, 15, 2914348928UL, 3738501120UL,  {0}},
    { 2281U, 4111636616UL, 36,72,4286578688UL, 12, 18, 7, 15, 978500352UL, 4159012864UL,  {0}},
    { 2281U, 2362361993UL, 36,72,4286578688UL, 12, 18, 7, 15, 3100949376UL, 4155867136UL,  {0}},
    { 2281U, 3976300682UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132452480UL, 3756326912UL,  {0}},
    { 2281U, 2868865163UL, 36,72,4286578688UL, 12, 18, 7, 15, 2868722304UL, 4159012864UL,  {0}},
    { 2281U, 3582978188UL, 36,72,4286578688UL, 12, 18, 7, 15, 2897538432UL, 4292313088UL,  {0}},
    { 2281U, 3720773773UL, 36,72,4286578688UL, 12, 18, 7, 15, 3031752064UL, 4225073152UL,  {0}},
    { 2281U, 3355881614UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995660160UL, 4292050944UL,  {0}},
    { 2281U, 3738310799UL, 36,72,4286578688UL, 12, 18, 7, 15, 909958528UL, 4225073152UL,  {0}},
    { 2281U, 3378913424UL, 36,72,4286578688UL, 12, 18, 7, 15, 1966423936UL, 4226220032UL,  {0}},
    { 2281U, 4214569105UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149183616UL, 4160061440UL,  {0}},
    { 2281U, 4045406354UL, 36,72,4286578688UL, 12, 18, 7, 15, 1840953216UL, 4284841984UL,  {0}},
    { 2281U, 3246780563UL, 36,72,4286578688UL, 12, 18, 7, 15, 3139615616UL, 4160192512UL,  {0}},
    { 2281U, 4043645076UL, 36,72,4286578688UL, 12, 18, 7, 15, 3216325504UL, 4150624256UL,  {0}},
    { 2281U, 3647420565UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931633024UL, 4158750720UL,  {0}},
    { 2281U, 3598821526UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008898944UL, 4227170304UL,  {0}},
    { 2281U, 3387580567UL, 36,72,4286578688UL, 12, 18, 7, 15, 1857337984UL, 4159012864UL,  {0}},
    { 2281U, 4153198744UL, 36,72,4286578688UL, 12, 18, 7, 15, 928953728UL, 4291133440UL,  {0}},
    { 2281U, 4138688665UL, 36,72,4286578688UL, 12, 18, 7, 15, 3143462144UL, 3755278336UL,  {0}},
    { 2281U, 2182750362UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931636864UL, 4158980096UL,  {0}},
    { 2281U, 2524291227UL, 36,72,4286578688UL, 12, 18, 7, 15, 2065002368UL, 3737583616UL,  {0}},
    { 2281U, 2178467996UL, 36,72,4286578688UL, 12, 18, 7, 15, 992263040UL, 4159930368UL,  {0}},
    { 2281U, 2770235549UL, 36,72,4286578688UL, 12, 18, 7, 15, 1986836096UL, 4292182016UL,  {0}},
    { 2281U, 2319958174UL, 36,72,4286578688UL, 12, 18, 7, 15, 4006964992UL, 3721723904UL,  {0}},
    { 2281U, 3550447775UL, 36,72,4286578688UL, 12, 18, 7, 15, 754363008UL, 4157964288UL,  {0}},
    { 2281U, 2283360416UL, 36,72,4286578688UL, 12, 18, 7, 15, 763314048UL, 4158980096UL,  {0}},
    { 2281U, 2712248481UL, 36,72,4286578688UL, 12, 18, 7, 15, 995978624UL, 3755278336UL,  {0}},
    { 2281U, 3667425442UL, 36,72,4286578688UL, 12, 18, 7, 15, 1996437120UL, 4294246400UL,  {0}},
    { 2281U, 3832563875UL, 36,72,4286578688UL, 12, 18, 7, 15, 1014807168UL, 4158095360UL,  {0}},
    { 2281U, 2917484708UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991597952UL, 4216684544UL,  {0}},
    { 2281U, 2788018341UL, 36,72,4286578688UL, 12, 18, 7, 15, 2905567104UL, 3738533888UL,  {0}},
    { 2281U, 3034368166UL, 36,72,4286578688UL, 12, 18, 7, 15, 1819589504UL, 4158980096UL,  {0}},
    { 2281U, 3502401703UL, 36,72,4286578688UL, 12, 18, 7, 15, 1937075968UL, 3738501120UL,  {0}},
    { 2281U, 3316832424UL, 36,72,4286578688UL, 12, 18, 7, 15, 1916057216UL, 4294279168UL,  {0}},
    { 2281U, 2267498665UL, 36,72,4286578688UL, 12, 18, 7, 15, 1962728064UL, 4292182016UL,  {0}},
    { 2281U, 3805165738UL, 36,72,4286578688UL, 12, 18, 7, 15, 653579904UL, 4293361664UL,  {0}},
    { 2281U, 3860828331UL, 36,72,4286578688UL, 12, 18, 7, 15, 4076173056UL, 3757670400UL,  {0}},
    { 2281U, 2530183340UL, 36,72,4286578688UL, 12, 18, 7, 15, 3879168768UL, 3754262528UL,  {0}},
    { 2281U, 3802323117UL, 36,72,4286578688UL, 12, 18, 7, 15, 2905960064UL, 3738533888UL,  {0}},
    { 2281U, 3707119790UL, 36,72,4286578688UL, 12, 18, 7, 15, 1990686336UL, 4025843712UL,  {0}},
    { 2281U, 3774105775UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991597952UL, 4258627584UL,  {0}},
    { 2281U, 3954735280UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132964480UL, 4160061440UL,  {0}},
    { 2281U, 2970661041UL, 36,72,4286578688UL, 12, 18, 7, 15, 1975336832UL, 4227301376UL,  {0}},
    { 2281U, 4155367602UL, 36,72,4286578688UL, 12, 18, 7, 15, 3874844288UL, 3721723904UL,  {0}},
    { 2281U, 3457829043UL, 36,72,4286578688UL, 12, 18, 7, 15, 1002224512UL, 4152197120UL,  {0}},
    { 2281U, 3648645300UL, 36,72,4286578688UL, 12, 18, 7, 15, 4139087488UL, 3739058176UL,  {0}},
    { 2281U, 2392230069UL, 36,72,4286578688UL, 12, 18, 7, 15, 913628544UL, 4225073152UL,  {0}},
    { 2281U, 2523947190UL, 36,72,4286578688UL, 12, 18, 7, 15, 2908171648UL, 3754328064UL,  {0}},
    { 2281U, 2354028727UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008899200UL, 4258594816UL,  {0}},
    { 2281U, 2340124856UL, 36,72,4286578688UL, 12, 18, 7, 15, 995441408UL, 4159012864UL,  {0}},
    { 2281U, 3448406201UL, 36,72,4286578688UL, 12, 18, 7, 15, 1844231040UL, 4160061440UL,  {0}},
    { 2281U, 2521934010UL, 36,72,4286578688UL, 12, 18, 7, 15, 3979704064UL, 3738533888UL,  {0}},
    { 2281U, 3097104571UL, 36,72,4286578688UL, 12, 18, 7, 15, 2901621632UL, 4151640064UL,  {0}},
    { 2281U, 2225719484UL, 36,72,4286578688UL, 12, 18, 7, 15, 1534405888UL, 4294180864UL,  {0}},
    { 2281U, 2426886333UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009048704UL, 4157964288UL,  {0}},
    { 2281U, 2545273022UL, 36,72,4286578688UL, 12, 18, 7, 15, 1983306368UL, 4292182016UL,  {0}},
    { 2281U, 3210301631UL, 36,72,4286578688UL, 12, 18, 7, 15, 783104896UL, 4160192512UL,  {0}},
    { 2281U, 4213192896UL, 36,72,4286578688UL, 12, 18, 7, 15, 3199282048UL, 4151672832UL,  {0}},
    { 2281U, 2761605313UL, 36,72,4286578688UL, 12, 18, 7, 15, 2930064256UL, 4159930368UL,  {0}},
    { 2281U, 3166785730UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008856448UL, 4275404800UL,  {0}},
    { 2281U, 2599002307UL, 36,72,4286578688UL, 12, 18, 7, 15, 2078620288UL, 4160061440UL,  {0}},
    { 2281U, 3400689860UL, 36,72,4286578688UL, 12, 18, 7, 15, 2897689216UL, 4159012864UL,  {0}},
    { 2281U, 3055007941UL, 36,72,4286578688UL, 12, 18, 7, 15, 2918657280UL, 3754262528UL,  {0}},
    { 2281U, 2235248838UL, 36,72,4286578688UL, 12, 18, 7, 15, 3971431040UL, 4157964288UL,  {0}},
    { 2281U, 3143293127UL, 36,72,4286578688UL, 12, 18, 7, 15, 3974969984UL, 4160061440UL,  {0}},
    { 2281U, 3773634760UL, 36,72,4286578688UL, 12, 18, 7, 15, 3052723584UL, 4225007616UL,  {0}},
    { 2281U, 2741027017UL, 36,72,4286578688UL, 12, 18, 7, 15, 766850432UL, 4294279168UL,  {0}},
    { 2281U, 2154748106UL, 36,72,4286578688UL, 12, 18, 7, 15, 1307916928UL, 4157964288UL,  {0}},
    { 2281U, 3162609867UL, 36,72,4286578688UL, 12, 18, 7, 15, 3134536320UL, 4160061440UL,  {0}},
    { 2281U, 3121346764UL, 36,72,4286578688UL, 12, 18, 7, 15, 922017152UL, 4225040384UL,  {0}},
    { 2281U, 4085743821UL, 36,72,4286578688UL, 12, 18, 7, 15, 1001746048UL, 3721723904UL,  {0}},
    { 2281U, 3224178894UL, 36,72,4286578688UL, 12, 18, 7, 15, 2800037504UL, 4258594816UL,  {0}},
    { 2281U, 2859485391UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149314688UL, 4160028672UL,  {0}},
    { 2281U, 3555371216UL, 36,72,4286578688UL, 12, 18, 7, 15, 1706876288UL, 4225040384UL,  {0}},
    { 2281U, 3674628305UL, 36,72,4286578688UL, 12, 18, 7, 15, 3134537600UL, 4151640064UL,  {0}},
    { 2281U, 4171282642UL, 36,72,4286578688UL, 12, 18, 7, 15, 963066624UL, 4160061440UL,  {0}},
    { 2281U, 3659792595UL, 36,72,4286578688UL, 12, 18, 7, 15, 3204242560UL, 4225204224UL,  {0}},
    { 2281U, 4219287764UL, 36,72,4286578688UL, 12, 18, 7, 15, 1836412288UL, 4292182016UL,  {0}},
    { 2281U, 3105571029UL, 36,72,4286578688UL, 12, 18, 7, 15, 2918542592UL, 3754393600UL,  {0}},
    { 2281U, 2958739670UL, 36,72,4286578688UL, 12, 18, 7, 15, 2934258560UL, 4151771136UL,  {0}},
    { 2281U, 3036715223UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149213312UL, 3757408256UL,  {0}},
    { 2281U, 3061657816UL, 36,72,4286578688UL, 12, 18, 7, 15, 3133455232UL, 4155867136UL,  {0}},
    { 2281U, 4134033625UL, 36,72,4286578688UL, 12, 18, 7, 15, 1975344768UL, 4292182016UL,  {0}},
    { 2281U, 4276523226UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009048704UL, 4157964288UL,  {0}},
    { 2281U, 3884296411UL, 36,72,4286578688UL, 12, 18, 7, 15, 3866455808UL, 3720708096UL,  {0}},
    { 2281U, 2499911900UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009048960UL, 4149575680UL,  {0}},
    { 2281U, 2428899549UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931650176UL, 3721756672UL,  {0}},
    { 2281U, 3854641374UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995922304UL, 4290084864UL,  {0}},
    { 2281U, 2905956575UL, 36,72,4286578688UL, 12, 18, 7, 15, 2817842560UL, 4225040384UL,  {0}},
    { 2281U, 3010445536UL, 36,72,4286578688UL, 12, 18, 7, 15, 2933730048UL, 4159143936UL,  {0}},
    { 2281U, 4023980257UL, 36,72,4286578688UL, 12, 18, 7, 15, 2880782208UL, 4142202880UL,  {0}},
    { 2281U, 2691289314UL, 36,72,4286578688UL, 12, 18, 7, 15, 880074112UL, 4225073152UL,  {0}},
    { 2281U, 3103822051UL, 36,72,4286578688UL, 12, 18, 7, 15, 4218907904UL, 3754262528UL,  {0}},
    { 2281U, 4250808548UL, 36,72,4286578688UL, 12, 18, 7, 15, 3135716224UL, 4160061440UL,  {0}},
    { 2281U, 3444455653UL, 36,72,4286578688UL, 12, 18, 7, 15, 4092950272UL, 3739582464UL,  {0}},
    { 2281U, 2210148582UL, 36,72,4286578688UL, 12, 18, 7, 15, 4148000640UL, 3740762112UL,  {0}},
    { 2281U, 3343665383UL, 36,72,4286578688UL, 12, 18, 7, 15, 3967117952UL, 3754262528UL,  {0}},
    { 2281U, 3549286632UL, 36,72,4286578688UL, 12, 18, 7, 15, 611114368UL, 4226121728UL,  {0}},
    { 2281U, 2310822121UL, 36,72,4286578688UL, 12, 18, 7, 15, 934600576UL, 4261216256UL,  {0}},
    { 2281U, 3989115114UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149183872UL, 4159012864UL,  {0}},
    { 2281U, 3487385835UL, 36,72,4286578688UL, 12, 18, 7, 15, 3151444864UL, 4152164352UL,  {0}},
    { 2281U, 3211043052UL, 36,72,4286578688UL, 12, 18, 7, 15, 3077889408UL, 4225073152UL,  {0}},
    { 2281U, 3193057517UL, 36,72,4286578688UL, 12, 18, 7, 15, 2809453952UL, 4225040384UL,  {0}},
    { 2281U, 3820931310UL, 36,72,4286578688UL, 12, 18, 7, 15, 857140864UL, 3721756672UL,  {0}},
    { 2281U, 4265980143UL, 36,72,4286578688UL, 12, 18, 7, 15, 1823305088UL, 4293230592UL,  {0}},
    { 2281U, 3072735472UL, 36,72,4286578688UL, 12, 18, 7, 15, 787836672UL, 3721756672UL,  {0}},
    { 2281U, 2595352817UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149707904UL, 4160061440UL,  {0}},
    { 2281U, 3297515762UL, 36,72,4286578688UL, 12, 18, 7, 15, 1861578624UL, 4258103296UL,  {0}},
    { 2281U, 3567034611UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008759680UL, 4227137536UL,  {0}},
    { 2281U, 3341488372UL, 36,72,4286578688UL, 12, 18, 7, 15, 3200199552UL, 4151640064UL,  {0}},
    { 2281U, 3775217909UL, 36,72,4286578688UL, 12, 18, 7, 15, 3182784256UL, 3738664960UL,  {0}},
    { 2281U, 3967758582UL, 36,72,4286578688UL, 12, 18, 7, 15, 3139746688UL, 4160192512UL,  {0}},
    { 2281U, 2811580663UL, 36,72,4286578688UL, 12, 18, 7, 15, 3986386688UL, 3738009600UL,  {0}},
    { 2281U, 2611355896UL, 36,72,4286578688UL, 12, 18, 7, 15, 1840082560UL, 4294246400UL,  {0}},
    { 2281U, 2148129017UL, 36,72,4286578688UL, 12, 18, 7, 15, 1967079296UL, 4227137536UL,  {0}},
    { 2281U, 2534947066UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995659904UL, 4294279168UL,  {0}},
    { 2281U, 2836105467UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140448128UL, 3737976832UL,  {0}},
    { 2281U, 2640869628UL, 36,72,4286578688UL, 12, 18, 7, 15, 2918529664UL, 4159012864UL,  {0}},
    { 2281U, 2893351165UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115137664UL, 4160028672UL,  {0}},
    { 2281U, 2313490686UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132570496UL, 4160061440UL,  {0}},
    { 2281U, 3791646975UL, 36,72,4286578688UL, 12, 18, 7, 15, 754399872UL, 4159012864UL,  {0}},
    { 2281U, 2338951424UL, 36,72,4286578688UL, 12, 18, 7, 15, 3086278016UL, 4225007616UL,  {0}},
    { 2281U, 2231992577UL, 36,72,4286578688UL, 12, 18, 7, 15, 2933734144UL, 4160061440UL,  {0}},
    { 2281U, 3242744066UL, 36,72,4286578688UL, 12, 18, 7, 15, 1970724224UL, 4225204224UL,  {0}},
    { 2281U, 3588217091UL, 36,72,4286578688UL, 12, 18, 7, 15, 2947378816UL, 3720675328UL,  {0}},
    { 2281U, 3984693508UL, 36,72,4286578688UL, 12, 18, 7, 15, 2914480000UL, 3738533888UL,  {0}},
    { 2281U, 4125311237UL, 36,72,4286578688UL, 12, 18, 7, 15, 1324169984UL, 4160061440UL,  {0}},
    { 2281U, 2351943942UL, 36,72,4286578688UL, 12, 18, 7, 15, 3002390144UL, 4292149248UL,  {0}},
    { 2281U, 2623713543UL, 36,72,4286578688UL, 12, 18, 7, 15, 787822208UL, 4294279168UL,  {0}},
    { 2281U, 3882842376UL, 36,72,4286578688UL, 12, 18, 7, 15, 913628544UL, 4225073152UL,  {0}},
    { 2281U, 3590801673UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132439424UL, 4151803904UL,  {0}},
    { 2281U, 2510567690UL, 36,72,4286578688UL, 12, 18, 7, 15, 787822208UL, 4294279168UL,  {0}},
    { 2281U, 2797306123UL, 36,72,4286578688UL, 12, 18, 7, 15, 3981798784UL, 3754229760UL,  {0}},
    { 2281U, 3810361612UL, 36,72,4286578688UL, 12, 18, 7, 15, 971455360UL, 4159897600UL,  {0}},
    { 2281U, 4154611981UL, 36,72,4286578688UL, 12, 18, 7, 15, 3145035648UL, 3738009600UL,  {0}},
    { 2281U, 2432223502UL, 36,72,4286578688UL, 12, 18, 7, 15, 4210372224UL, 3722772480UL,  {0}},
    { 2281U, 2764212495UL, 36,72,4286578688UL, 12, 18, 7, 15, 1828108928UL, 4158095360UL,  {0}},
    { 2281U, 3921099024UL, 36,72,4286578688UL, 12, 18, 7, 15, 993357696UL, 3738664960UL,  {0}},
    { 2281U, 2885239057UL, 36,72,4286578688UL, 12, 18, 7, 15, 788085632UL, 4155834368UL,  {0}},
    { 2281U, 2991669522UL, 36,72,4286578688UL, 12, 18, 7, 15, 3976018816UL, 4150558720UL,  {0}},
    { 2281U, 2653573395UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991204480UL, 4225073152UL,  {0}},
    { 2281U, 2632237332UL, 36,72,4286578688UL, 12, 18, 7, 15, 1001732736UL, 4160061440UL,  {0}},
    { 2281U, 4194933013UL, 36,72,4286578688UL, 12, 18, 7, 15, 995437440UL, 4155867136UL,  {0}},
    { 2281U, 2278447382UL, 36,72,4286578688UL, 12, 18, 7, 15, 787823488UL, 4150624256UL,  {0}},
    { 2281U, 3919825175UL, 36,72,4286578688UL, 12, 18, 7, 15, 3065870208UL, 4017422336UL,  {0}},
    { 2281U, 4293835032UL, 36,72,4286578688UL, 12, 18, 7, 15, 2935434112UL, 4149313536UL,  {0}},
    { 2281U, 3061231897UL, 36,72,4286578688UL, 12, 18, 7, 15, 1819589504UL, 4160061440UL,  {0}},
    { 2281U, 2765089050UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008472960UL, 4225073152UL,  {0}},
    { 2281U, 3984257307UL, 36,72,4286578688UL, 12, 18, 7, 15, 3014995584UL, 4258594816UL,  {0}},
    { 2281U, 3094241564UL, 36,72,4286578688UL, 12, 18, 7, 15, 1975467904UL, 4225040384UL,  {0}},
    { 2281U, 2236465437UL, 36,72,4286578688UL, 12, 18, 7, 15, 3098852224UL, 4160028672UL,  {0}},
    { 2281U, 3529167134UL, 36,72,4286578688UL, 12, 18, 7, 15, 3870649088UL, 3754262528UL,  {0}},
    { 2281U, 2437626143UL, 36,72,4286578688UL, 12, 18, 7, 15, 3982323072UL, 3755311104UL,  {0}},
    { 2281U, 2499516704UL, 36,72,4286578688UL, 12, 18, 7, 15, 3111730048UL, 4160028672UL,  {0}},
    { 2281U, 3014934817UL, 36,72,4286578688UL, 12, 18, 7, 15, 3971263104UL, 4157964288UL,  {0}},
    { 2281U, 3824480546UL, 36,72,4286578688UL, 12, 18, 7, 15, 922541440UL, 4225073152UL,  {0}},
    { 2281U, 3320897827UL, 36,72,4286578688UL, 12, 18, 7, 15, 799618944UL, 4276551680UL,  {0}},
    { 2281U, 4159344932UL, 36,72,4286578688UL, 12, 18, 7, 15, 3048529280UL, 4292313088UL,  {0}},
    { 2281U, 3830247717UL, 36,72,4286578688UL, 12, 18, 7, 15, 1722604928UL, 4225073152UL,  {0}},
    { 2281U, 3115868454UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991596672UL, 4292149248UL,  {0}},
    { 2281U, 3220863271UL, 36,72,4286578688UL, 12, 18, 7, 15, 1709534592UL, 4292182016UL,  {0}},
    { 2281U, 3221479720UL, 36,72,4286578688UL, 12, 18, 7, 15, 2851420800UL, 4160159744UL,  {0}},
    { 2281U, 3835468073UL, 36,72,4286578688UL, 12, 18, 7, 15, 1869003648UL, 4155867136UL,  {0}},
    { 2281U, 2522712362UL, 36,72,4286578688UL, 12, 18, 7, 15, 3216292736UL, 4151803904UL,  {0}},
    { 2281U, 3962247467UL, 36,72,4286578688UL, 12, 18, 7, 15, 934600064UL, 4225073152UL,  {0}},
    { 2281U, 4030220588UL, 36,72,4286578688UL, 12, 18, 7, 15, 3107928960UL, 4159799296UL,  {0}},
    { 2281U, 2369190189UL, 36,72,4286578688UL, 12, 18, 7, 15, 1735712128UL, 4225597440UL,  {0}},
    { 2281U, 3667114286UL, 36,72,4286578688UL, 12, 18, 7, 15, 1002224512UL, 4160061440UL,  {0}},
    { 2281U, 3169464623UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153410688UL, 4160061440UL,  {0}},
    { 2281U, 2732550448UL, 36,72,4286578688UL, 12, 18, 7, 15, 3677564544UL, 3184984064UL,  {0}},
    { 2281U, 3358961969UL, 36,72,4286578688UL, 12, 18, 7, 15, 2001041280UL, 4024762368UL,  {0}},
    { 2281U, 2606209330UL, 36,72,4286578688UL, 12, 18, 7, 15, 3148693376UL, 4142235648UL,  {0}},
    { 2281U, 3312046387UL, 36,72,4286578688UL, 12, 18, 7, 15, 3076863872UL, 4275404800UL,  {0}},
    { 2281U, 3606772020UL, 36,72,4286578688UL, 12, 18, 7, 15, 3120347776UL, 4158095360UL,  {0}},
    { 2281U, 2434398517UL, 36,72,4286578688UL, 12, 18, 7, 15, 783629184UL, 4158980096UL,  {0}},
    { 2281U, 3250161974UL, 36,72,4286578688UL, 12, 18, 7, 15, 1836889984UL, 4277501952UL,  {0}},
    { 2281U, 3774038327UL, 36,72,4286578688UL, 12, 18, 7, 15, 989674240UL, 4157931520UL,  {0}},
    { 2281U, 3795933496UL, 36,72,4286578688UL, 12, 18, 7, 15, 2069183232UL, 4160061440UL,  {0}},
    { 2281U, 2983412025UL, 36,72,4286578688UL, 12, 18, 7, 15, 1935095552UL, 4275404800UL,  {0}},
    { 2281U, 2934288698UL, 36,72,4286578688UL, 12, 18, 7, 15, 2918529920UL, 4150624256UL,  {0}},
    { 2281U, 3775576379UL, 36,72,4286578688UL, 12, 18, 7, 15, 767245696UL, 4227104768UL,  {0}},
    { 2281U, 4181956924UL, 36,72,4286578688UL, 12, 18, 7, 15, 753351552UL, 4151803904UL,  {0}},
    { 2281U, 3544404285UL, 36,72,4286578688UL, 12, 18, 7, 15, 3007114624UL, 3754262528UL,  {0}},
    { 2281U, 2299662654UL, 36,72,4286578688UL, 12, 18, 7, 15, 3107273472UL, 4160061440UL,  {0}},
    { 2281U, 3282983231UL, 36,72,4286578688UL, 12, 18, 7, 15, 3143416704UL, 4155867136UL,  {0}},
    { 2281U, 3756321088UL, 36,72,4286578688UL, 12, 18, 7, 15, 4079579008UL, 3738664960UL,  {0}},
    { 2281U, 3610501441UL, 36,72,4286578688UL, 12, 18, 7, 15, 2792151936UL, 4292149248UL,  {0}},
    { 2281U, 4116556098UL, 36,72,4286578688UL, 12, 18, 7, 15, 1996283520UL, 4258627584UL,  {0}},
    { 2281U, 3810752835UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009193344UL, 3720708096UL,  {0}},
    { 2281U, 2254641476UL, 36,72,4286578688UL, 12, 18, 7, 15, 2523182464UL, 4293230592UL,  {0}},
    { 2281U, 4217250117UL, 36,72,4286578688UL, 12, 18, 7, 15, 3137957632UL, 3738140672UL,  {0}},
    { 2281U, 3764486470UL, 36,72,4286578688UL, 12, 18, 7, 15, 3065305984UL, 4292182016UL,  {0}},
    { 2281U, 3843014983UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149885184UL, 3738533888UL,  {0}},
    { 2281U, 2956663112UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149834880UL, 4160192512UL,  {0}},
    { 2281U, 2949718345UL, 36,72,4286578688UL, 12, 18, 7, 15, 796208000UL, 4155867136UL,  {0}},
    { 2281U, 3400626506UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115662208UL, 4151672832UL,  {0}},
    { 2281U, 2373734731UL, 36,72,4286578688UL, 12, 18, 7, 15, 2000502656UL, 4209475584UL,  {0}},
    { 2281U, 2213998924UL, 36,72,4286578688UL, 12, 18, 7, 15, 4006964992UL, 3721723904UL,  {0}},
    { 2281U, 3035619661UL, 36,72,4286578688UL, 12, 18, 7, 15, 3643063168UL, 4157964288UL,  {0}},
    { 2281U, 3228768590UL, 36,72,4286578688UL, 12, 18, 7, 15, 4006964992UL, 3721723904UL,  {0}},
    { 2281U, 4243069263UL, 36,72,4286578688UL, 12, 18, 7, 15, 3974838912UL, 4160585728UL,  {0}},
    { 2281U, 2516547920UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149310848UL, 4151672832UL,  {0}},
    { 2281U, 3262703953UL, 36,72,4286578688UL, 12, 18, 7, 15, 4088753792UL, 3721756672UL,  {0}},
    { 2281U, 3084677458UL, 36,72,4286578688UL, 12, 18, 7, 15, 3614881664UL, 4275404800UL,  {0}},
    { 2281U, 2956443987UL, 36,72,4286578688UL, 12, 18, 7, 15, 1000651648UL, 4160192512UL,  {0}},
    { 2281U, 4276754772UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140795264UL, 4159766528UL,  {0}},
    { 2281U, 2275522901UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140795264UL, 4160061440UL,  {0}},
    { 2281U, 2659637590UL, 36,72,4286578688UL, 12, 18, 7, 15, 3065830272UL, 4292149248UL,  {0}},
    { 2281U, 3815276887UL, 36,72,4286578688UL, 12, 18, 7, 15, 998027136UL, 3741220864UL,  {0}},
    { 2281U, 2287630680UL, 36,72,4286578688UL, 12, 18, 7, 15, 2911465216UL, 3738140672UL,  {0}},
    { 2281U, 3755768153UL, 36,72,4286578688UL, 12, 18, 7, 15, 3925129856UL, 4294279168UL,  {0}},
    { 2281U, 4091357530UL, 36,72,4286578688UL, 12, 18, 7, 15, 1853189760UL, 4259643392UL,  {0}},
    { 2281U, 3384877403UL, 36,72,4286578688UL, 12, 18, 7, 15, 2946841472UL, 4160028672UL,  {0}},
    { 2281U, 3696478556UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153407616UL, 3721756672UL,  {0}},
    { 2281U, 3969900893UL, 36,72,4286578688UL, 12, 18, 7, 15, 3134143232UL, 4159537152UL,  {0}},
    { 2281U, 4240634206UL, 36,72,4286578688UL, 12, 18, 7, 15, 3556554112UL, 4290084864UL,  {0}},
    { 2281U, 2220038495UL, 36,72,4286578688UL, 12, 18, 7, 15, 1932881664UL, 3737485312UL,  {0}},
    { 2281U, 3022895456UL, 36,72,4286578688UL, 12, 18, 7, 15, 2916838784UL, 3755409408UL,  {0}},
    { 2281U, 3856585057UL, 36,72,4286578688UL, 12, 18, 7, 15, 2037824384UL, 4160028672UL,  {0}},
    { 2281U, 3026372962UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140402048UL, 4160159744UL,  {0}},
    { 2281U, 2772447587UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008366464UL, 4226121728UL,  {0}},
    { 2281U, 4141166948UL, 36,72,4286578688UL, 12, 18, 7, 15, 1975334528UL, 4294279168UL,  {0}},
    { 2281U, 2606870885UL, 36,72,4286578688UL, 12, 18, 7, 15, 3981929856UL, 3755278336UL,  {0}},
    { 2281U, 2880356710UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115105152UL, 4151672832UL,  {0}},
    { 2281U, 2976180583UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132439296UL, 4160192512UL,  {0}},
    { 2281U, 4099293544UL, 36,72,4286578688UL, 12, 18, 7, 15, 901045632UL, 4225073152UL,  {0}},
    { 2281U, 2189283689UL, 36,72,4286578688UL, 12, 18, 7, 15, 4017404544UL, 4157964288UL,  {0}},
    { 2281U, 3998890346UL, 36,72,4286578688UL, 12, 18, 7, 15, 2939501440UL, 4158980096UL,  {0}},
    { 2281U, 2209106283UL, 36,72,4286578688UL, 12, 18, 7, 15, 4000673408UL, 3720708096UL,  {0}},
    { 2281U, 4197972332UL, 36,72,4286578688UL, 12, 18, 7, 15, 4214697728UL, 3723853824UL,  {0}},
    { 2281U, 3229563245UL, 36,72,4286578688UL, 12, 18, 7, 15, 4139087488UL, 3755311104UL,  {0}},
    { 2281U, 2727692654UL, 36,72,4286578688UL, 12, 18, 7, 15, 3139251968UL, 3737616384UL,  {0}},
    { 2281U, 2321058159UL, 36,72,4286578688UL, 12, 18, 7, 15, 854912256UL, 3755278336UL,  {0}},
    { 2281U, 3773290864UL, 36,72,4286578688UL, 12, 18, 7, 15, 3018929792UL, 4294279168UL,  {0}},
    { 2281U, 3338111345UL, 36,72,4286578688UL, 12, 18, 7, 15, 997539712UL, 4142235648UL,  {0}},
    { 2281U, 4154820978UL, 36,72,4286578688UL, 12, 18, 7, 15, 1689611392UL, 3754229760UL,  {0}},
    { 2281U, 2426245491UL, 36,72,4286578688UL, 12, 18, 7, 15, 909564544UL, 4292182016UL,  {0}},
    { 2281U, 2452048244UL, 36,72,4286578688UL, 12, 18, 7, 15, 3150789504UL, 4149542912UL,  {0}},
    { 2281U, 3991540085UL, 36,72,4286578688UL, 12, 18, 7, 15, 3002414720UL, 4293230592UL,  {0}},
    { 2281U, 3314362742UL, 36,72,4286578688UL, 12, 18, 7, 15, 3044334976UL, 4225040384UL,  {0}},
    { 2281U, 4068972919UL, 36,72,4286578688UL, 12, 18, 7, 15, 1786080640UL, 4292706304UL,  {0}},
    { 2281U, 4262379896UL, 36,72,4286578688UL, 12, 18, 7, 15, 2037738240UL, 3754262528UL,  {0}},
    { 2281U, 3254503801UL, 36,72,4286578688UL, 12, 18, 7, 15, 2006278016UL, 4208394240UL,  {0}},
    { 2281U, 3276200314UL, 36,72,4286578688UL, 12, 18, 7, 15, 4006964992UL, 3721723904UL,  {0}},
    { 2281U, 2509666683UL, 36,72,4286578688UL, 12, 18, 7, 15, 3987173248UL, 3747971072UL,  {0}},
    { 2281U, 2626447740UL, 36,72,4286578688UL, 12, 18, 7, 15, 3141348224UL, 4160028672UL,  {0}},
    { 2281U, 2889232765UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009586304UL, 3721756672UL,  {0}},
    { 2281U, 3105307006UL, 36,72,4286578688UL, 12, 18, 7, 15, 921132672UL, 4258627584UL,  {0}},
    { 2281U, 3943127423UL, 36,72,4286578688UL, 12, 18, 7, 15, 2933616384UL, 3720708096UL,  {0}},
    { 2281U, 3282635136UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931112576UL, 4158947328UL,  {0}},
    { 2281U, 2285017473UL, 36,72,4286578688UL, 12, 18, 7, 15, 3086802304UL, 4225073152UL,  {0}},
    { 2281U, 3112040834UL, 36,72,4286578688UL, 12, 18, 7, 15, 2813646464UL, 4275339264UL,  {0}},
    { 2281U, 2175324547UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009442176UL, 4155867136UL,  {0}},
    { 2281U, 3076759940UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149310592UL, 4160061440UL,  {0}},
    { 2281U, 2642680197UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132963712UL, 4151640064UL,  {0}},
    { 2281U, 2491890054UL, 36,72,4286578688UL, 12, 18, 7, 15, 2948410240UL, 4150624256UL,  {0}},
    { 2281U, 2623670663UL, 36,72,4286578688UL, 12, 18, 7, 15, 4004867712UL, 3721756672UL,  {0}},
    { 2281U, 2434013576UL, 36,72,4286578688UL, 12, 18, 7, 15, 2006409088UL, 4208427008UL,  {0}},
    { 2281U, 4008440201UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008374656UL, 4225073152UL,  {0}},
    { 2281U, 4271022474UL, 36,72,4286578688UL, 12, 18, 7, 15, 4216811264UL, 3737485312UL,  {0}},
    { 2281U, 3284275595UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008505728UL, 4225040384UL,  {0}},
    { 2281U, 3903476108UL, 36,72,4286578688UL, 12, 18, 7, 15, 3924604800UL, 4272226304UL,  {0}},
    { 2281U, 4154147213UL, 36,72,4286578688UL, 12, 18, 7, 15, 785857280UL, 4157964288UL,  {0}},
    { 2281U, 4031222158UL, 36,72,4286578688UL, 12, 18, 7, 15, 938824960UL, 4025843712UL,  {0}},
    { 2281U, 3055841679UL, 36,72,4286578688UL, 12, 18, 7, 15, 1928687360UL, 3721723904UL,  {0}},
    { 2281U, 3073382800UL, 36,72,4286578688UL, 12, 18, 7, 15, 2914348928UL, 3738533888UL,  {0}},
    { 2281U, 3639245201UL, 36,72,4286578688UL, 12, 18, 7, 15, 2792151936UL, 4293754880UL,  {0}},
    { 2281U, 4265838994UL, 36,72,4286578688UL, 12, 18, 7, 15, 4017404544UL, 4157964288UL,  {0}},
    { 2281U, 3368634771UL, 36,72,4286578688UL, 12, 18, 7, 15, 4223627136UL, 3747938304UL,  {0}},
    { 2281U, 3206582676UL, 36,72,4286578688UL, 12, 18, 7, 15, 3975506560UL, 3754229760UL,  {0}},
    { 2281U, 2561171861UL, 36,72,4286578688UL, 12, 18, 7, 15, 766850944UL, 4285890560UL,  {0}},
    { 2281U, 2564506006UL, 36,72,4286578688UL, 12, 18, 7, 15, 2792414592UL, 4225597440UL,  {0}},
    { 2281U, 3858174359UL, 36,72,4286578688UL, 12, 18, 7, 15, 2069314304UL, 4157964288UL,  {0}},
    { 2281U, 3270246808UL, 36,72,4286578688UL, 12, 18, 7, 15, 2906091392UL, 3738533888UL,  {0}},
    { 2281U, 2939752857UL, 36,72,4286578688UL, 12, 18, 7, 15, 981282048UL, 3755016192UL,  {0}},
    { 2281U, 3274623386UL, 36,72,4286578688UL, 12, 18, 7, 15, 2908171648UL, 3754786816UL,  {0}},
    { 2281U, 3358812571UL, 36,72,4286578688UL, 12, 18, 7, 15, 3151276928UL, 4155867136UL,  {0}},
    { 2281U, 3179403676UL, 36,72,4286578688UL, 12, 18, 7, 15, 938794240UL, 4225073152UL,  {0}},
    { 2281U, 4240269725UL, 36,72,4286578688UL, 12, 18, 7, 15, 2058693248UL, 4158980096UL,  {0}},
    { 2281U, 3370871198UL, 36,72,4286578688UL, 12, 18, 7, 15, 4007489280UL, 3721756672UL,  {0}},
    { 2281U, 2544845215UL, 36,72,4286578688UL, 12, 18, 7, 15, 3988043392UL, 4294246400UL,  {0}},
    { 2281U, 3502692768UL, 36,72,4286578688UL, 12, 18, 7, 15, 1932881792UL, 3737452544UL,  {0}},
    { 2281U, 3090633121UL, 36,72,4286578688UL, 12, 18, 7, 15, 3202707328UL, 3723821056UL,  {0}},
    { 2281U, 3309425058UL, 36,72,4286578688UL, 12, 18, 7, 15, 922148224UL, 4225073152UL,  {0}},
    { 2281U, 3516178851UL, 36,72,4286578688UL, 12, 18, 7, 15, 2935303040UL, 4159799296UL,  {0}},
    { 2281U, 2676550052UL, 36,72,4286578688UL, 12, 18, 7, 15, 1857337984UL, 4159012864UL,  {0}},
    { 2281U, 3724851621UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991597952UL, 4216684544UL,  {0}},
    { 2281U, 3563735462UL, 36,72,4286578688UL, 12, 18, 7, 15, 783494016UL, 4159897600UL,  {0}},
    { 2281U, 2178675111UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009062144UL, 3720708096UL,  {0}},
    { 2281U, 3423263144UL, 36,72,4286578688UL, 12, 18, 7, 15, 966179712UL, 4159799296UL,  {0}},
    { 2281U, 3461112233UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153410688UL, 4160028672UL,  {0}},
    { 2281U, 2419247530UL, 36,72,4286578688UL, 12, 18, 7, 15, 984955776UL, 4156915712UL,  {0}},
    { 2281U, 2248579499UL, 36,72,4286578688UL, 12, 18, 7, 15, 910079616UL, 4294803456UL,  {0}},
    { 2281U, 2563074476UL, 36,72,4286578688UL, 12, 18, 7, 15, 2901883776UL, 4151410688UL,  {0}},
    { 2281U, 4209482157UL, 36,72,4286578688UL, 12, 18, 7, 15, 1844754304UL, 4277501952UL,  {0}},
    { 2281U, 3086803374UL, 36,72,4286578688UL, 12, 18, 7, 15, 2000074368UL, 4257579008UL,  {0}},
    { 2281U, 3068856751UL, 36,72,4286578688UL, 12, 18, 7, 15, 1973247872UL, 4275404800UL,  {0}},
    { 2281U, 2577684912UL, 36,72,4286578688UL, 12, 18, 7, 15, 1002224512UL, 4160061440UL,  {0}},
    { 2281U, 3623354801UL, 36,72,4286578688UL, 12, 18, 7, 15, 985086848UL, 4151640064UL,  {0}},
    { 2281U, 2951258546UL, 36,72,4286578688UL, 12, 18, 7, 15, 2935307136UL, 4151803904UL,  {0}},
    { 2281U, 3241697715UL, 36,72,4286578688UL, 12, 18, 7, 15, 1836412288UL, 4292182016UL,  {0}},
    { 2281U, 3568279988UL, 36,72,4286578688UL, 12, 18, 7, 15, 3724369280UL, 4225040384UL,  {0}},
    { 2281U, 2894676405UL, 36,72,4286578688UL, 12, 18, 7, 15, 2069183232UL, 4160061440UL,  {0}},
    { 2281U, 3630764470UL, 36,72,4286578688UL, 12, 18, 7, 15, 1987403392UL, 4225073152UL,  {0}},
    { 2281U, 2283678135UL, 36,72,4286578688UL, 12, 18, 7, 15, 3064807296UL, 4227301376UL,  {0}},
    { 2281U, 4190695864UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115661952UL, 4159012864UL,  {0}},
    { 2281U, 2917566905UL, 36,72,4286578688UL, 12, 18, 7, 15, 3069500032UL, 4292182016UL,  {0}},
    { 2281U, 4287269306UL, 36,72,4286578688UL, 12, 18, 7, 15, 4017978112UL, 3622141952UL,  {0}},
    { 2281U, 2675120571UL, 36,72,4286578688UL, 12, 18, 7, 15, 2933734144UL, 4159143936UL,  {0}},
    { 2281U, 2267384252UL, 36,72,4286578688UL, 12, 18, 7, 15, 3141483392UL, 4160192512UL,  {0}},
    { 2281U, 3014760893UL, 36,72,4286578688UL, 12, 18, 7, 15, 4084509952UL, 3756359680UL,  {0}},
    { 2281U, 2717297086UL, 36,72,4286578688UL, 12, 18, 7, 15, 2759253376UL, 4225040384UL,  {0}},
    { 2281U, 2675311039UL, 36,72,4286578688UL, 12, 18, 7, 15, 926211456UL, 4225073152UL,  {0}},
    { 2281U, 4091070912UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115367040UL, 4160585728UL,  {0}},
    { 2281U, 4051392961UL, 36,72,4286578688UL, 12, 18, 7, 15, 754662016UL, 4160192512UL,  {0}},
    { 2281U, 3543919042UL, 36,72,4286578688UL, 12, 18, 7, 15, 640998016UL, 4292280320UL,  {0}},
    { 2281U, 2466738627UL, 36,72,4286578688UL, 12, 18, 7, 15, 1958524288UL, 4294279168UL,  {0}},
    { 2281U, 3100709316UL, 36,72,4286578688UL, 12, 18, 7, 15, 854898304UL, 4293230592UL,  {0}},
    { 2281U, 3546266053UL, 36,72,4286578688UL, 12, 18, 7, 15, 1970068864UL, 4227170304UL,  {0}},
    { 2281U, 4088334790UL, 36,72,4286578688UL, 12, 18, 7, 15, 865955456UL, 3721756672UL,  {0}},
    { 2281U, 2600769991UL, 36,72,4286578688UL, 12, 18, 7, 15, 787836800UL, 4251287552UL,  {0}},
    { 2281U, 3420617160UL, 36,72,4286578688UL, 12, 18, 7, 15, 1870052224UL, 4155867136UL,  {0}},
    { 2281U, 2963175881UL, 36,72,4286578688UL, 12, 18, 7, 15, 3967610240UL, 3755311104UL,  {0}},
    { 2281U, 4176597450UL, 36,72,4286578688UL, 12, 18, 7, 15, 3975461504UL, 4160061440UL,  {0}},
    { 2281U, 3220249035UL, 36,72,4286578688UL, 12, 18, 7, 15, 2900834944UL, 4160061440UL,  {0}},
    { 2281U, 2472688076UL, 36,72,4286578688UL, 12, 18, 7, 15, 4080365184UL, 3721723904UL,  {0}},
    { 2281U, 3817812429UL, 36,72,4286578688UL, 12, 18, 7, 15, 3145559936UL, 3738533888UL,  {0}},
    { 2281U, 2384259534UL, 36,72,4286578688UL, 12, 18, 7, 15, 1987894656UL, 4227104768UL,  {0}},
    { 2281U, 4111690191UL, 36,72,4286578688UL, 12, 18, 7, 15, 737491584UL, 4159012864UL,  {0}},
    { 2281U, 2194782672UL, 36,72,4286578688UL, 12, 18, 7, 15, 3114744704UL, 4151672832UL,  {0}},
    { 2281U, 4073370065UL, 36,72,4286578688UL, 12, 18, 7, 15, 909434240UL, 4225073152UL,  {0}},
    { 2281U, 3311040978UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008472960UL, 4224286720UL,  {0}},
    { 2281U, 3534739923UL, 36,72,4286578688UL, 12, 18, 7, 15, 4213010176UL, 3720970240UL,  {0}},
    { 2281U, 2372245972UL, 36,72,4286578688UL, 12, 18, 7, 15, 3971444608UL, 3738501120UL,  {0}},
    { 2281U, 2291751381UL, 36,72,4286578688UL, 12, 18, 7, 15, 3107535616UL, 4160585728UL,  {0}},
    { 2281U, 3362572758UL, 36,72,4286578688UL, 12, 18, 7, 15, 786263808UL, 3721756672UL,  {0}},
    { 2281U, 2809696727UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153410688UL, 4160028672UL,  {0}},
    { 2281U, 2585276888UL, 36,72,4286578688UL, 12, 18, 7, 15, 2927573888UL, 4155867136UL,  {0}},
    { 2281U, 3832275417UL, 36,72,4286578688UL, 12, 18, 7, 15, 2800540288UL, 4291100672UL,  {0}},
    { 2281U, 2903175642UL, 36,72,4286578688UL, 12, 18, 7, 15, 3148689024UL, 3721723904UL,  {0}},
    { 2281U, 3550736859UL, 36,72,4286578688UL, 12, 18, 7, 15, 2935569152UL, 4159897600UL,  {0}},
    { 2281U, 2942114268UL, 36,72,4286578688UL, 12, 18, 7, 15, 989280896UL, 4160061440UL,  {0}},
    { 2281U, 2155110877UL, 36,72,4286578688UL, 12, 18, 7, 15, 3870650112UL, 3721756672UL,  {0}},
    { 2281U, 3815391710UL, 36,72,4286578688UL, 12, 18, 7, 15, 3975494272UL, 4158980096UL,  {0}},
    { 2281U, 4281952735UL, 36,72,4286578688UL, 12, 18, 7, 15, 2912365952UL, 3755311104UL,  {0}},
    { 2281U, 4035385824UL, 36,72,4286578688UL, 12, 18, 7, 15, 1975344512UL, 4292182016UL,  {0}},
    { 2281U, 3781239265UL, 36,72,4286578688UL, 12, 18, 7, 15, 916944768UL, 4017422336UL,  {0}},
    { 2281U, 2494235106UL, 36,72,4286578688UL, 12, 18, 7, 15, 1823829888UL, 4293230592UL,  {0}},
    { 2281U, 3147698659UL, 36,72,4286578688UL, 12, 18, 7, 15, 972995456UL, 4155867136UL,  {0}},
    { 2281U, 3675546084UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931112832UL, 4159012864UL,  {0}},
    { 2281U, 3214225893UL, 36,72,4286578688UL, 12, 18, 7, 15, 753743616UL, 4277469184UL,  {0}},
    { 2281U, 2301643238UL, 36,72,4286578688UL, 12, 18, 7, 15, 1970616192UL, 4277501952UL,  {0}},
    { 2281U, 2656940519UL, 36,72,4286578688UL, 12, 18, 7, 15, 765802368UL, 4277469184UL,  {0}},
    { 2281U, 3029619176UL, 36,72,4286578688UL, 12, 18, 7, 15, 3872713344UL, 3755278336UL,  {0}},
    { 2281U, 2391890409UL, 36,72,4286578688UL, 12, 18, 7, 15, 1840606848UL, 4293197824UL,  {0}},
    { 2281U, 3950604778UL, 36,72,4286578688UL, 12, 18, 7, 15, 2947889792UL, 4158947328UL,  {0}},
    { 2281U, 3491682795UL, 36,72,4286578688UL, 12, 18, 7, 15, 2935437952UL, 4160061440UL,  {0}},
    { 2281U, 3780434412UL, 36,72,4286578688UL, 12, 18, 7, 15, 2071817984UL, 3740631040UL,  {0}},
    { 2281U, 2764843501UL, 36,72,4286578688UL, 12, 18, 7, 15, 2762923392UL, 4224024576UL,  {0}},
    { 2281U, 2265223662UL, 36,72,4286578688UL, 12, 18, 7, 15, 762788608UL, 4157931520UL,  {0}},
    { 2281U, 2457772527UL, 36,72,4286578688UL, 12, 18, 7, 15, 4017452416UL, 3757408256UL,  {0}},
    { 2281U, 3418739184UL, 36,72,4286578688UL, 12, 18, 7, 15, 4223102592UL, 3723821056UL,  {0}},
    { 2281U, 3530762737UL, 36,72,4286578688UL, 12, 18, 7, 15, 4216679808UL, 3756326912UL,  {0}},
    { 2281U, 3885664754UL, 36,72,4286578688UL, 12, 18, 7, 15, 712851328UL, 4157964288UL,  {0}},
    { 2281U, 2656135667UL, 36,72,4286578688UL, 12, 18, 7, 15, 2906091392UL, 3755278336UL,  {0}},
    { 2281U, 3709600244UL, 36,72,4286578688UL, 12, 18, 7, 15, 4065817984UL, 4025810944UL,  {0}},
    { 2281U, 3160033781UL, 36,72,4286578688UL, 12, 18, 7, 15, 3052723584UL, 4225040384UL,  {0}},
    { 2281U, 2942343670UL, 36,72,4286578688UL, 12, 18, 7, 15, 764886912UL, 4143775744UL,  {0}},
    { 2281U, 2424363511UL, 36,72,4286578688UL, 12, 18, 7, 15, 3139746688UL, 4160061440UL,  {0}},
    { 2281U, 2223907320UL, 36,72,4286578688UL, 12, 18, 7, 15, 1979539072UL, 4292182016UL,  {0}},
    { 2281U, 3720966649UL, 36,72,4286578688UL, 12, 18, 7, 15, 4222971648UL, 3737485312UL,  {0}},
    { 2281U, 2721853946UL, 36,72,4286578688UL, 12, 18, 7, 15, 786774656UL, 4160061440UL,  {0}},
    { 2281U, 2799675899UL, 36,72,4286578688UL, 12, 18, 7, 15, 750073472UL, 4294279168UL,  {0}},
    { 2281U, 3570670076UL, 36,72,4286578688UL, 12, 18, 7, 15, 4013256448UL, 3721723904UL,  {0}},
    { 2281U, 3269241341UL, 36,72,4286578688UL, 12, 18, 7, 15, 2779569536UL, 4294279168UL,  {0}},
    { 2281U, 2813270526UL, 36,72,4286578688UL, 12, 18, 7, 15, 964258560UL, 3754000384UL,  {0}},
    { 2281U, 2969260543UL, 36,72,4286578688UL, 12, 18, 7, 15, 4006951552UL, 4157964288UL,  {0}},
    { 2281U, 3101600256UL, 36,72,4286578688UL, 12, 18, 7, 15, 3111435136UL, 4160061440UL,  {0}},
    { 2281U, 3191521793UL, 36,72,4286578688UL, 12, 18, 7, 15, 917855104UL, 4294279168UL,  {0}},
    { 2281U, 3284003330UL, 36,72,4286578688UL, 12, 18, 7, 15, 1848031872UL, 4160061440UL,  {0}},
    { 2281U, 3877896707UL, 36,72,4286578688UL, 12, 18, 7, 15, 4021644928UL, 3721723904UL,  {0}},
    { 2281U, 3601549828UL, 36,72,4286578688UL, 12, 18, 7, 15, 3057442176UL, 4224516096UL,  {0}},
    { 2281U, 3040328197UL, 36,72,4286578688UL, 12, 18, 7, 15, 786263808UL, 3721756672UL,  {0}},
    { 2281U, 3018752518UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995790976UL, 4294803456UL,  {0}},
    { 2281U, 4161024519UL, 36,72,4286578688UL, 12, 18, 7, 15, 2918543232UL, 3738664960UL,  {0}},
    { 2281U, 3439548936UL, 36,72,4286578688UL, 12, 18, 7, 15, 1798663552UL, 4292182016UL,  {0}},
    { 2281U, 3379696137UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008866176UL, 4225073152UL,  {0}},
    { 2281U, 2558048778UL, 36,72,4286578688UL, 12, 18, 7, 15, 984969088UL, 3748986880UL,  {0}},
    { 2281U, 2494515723UL, 36,72,4286578688UL, 12, 18, 7, 15, 3992237696UL, 4291133440UL,  {0}},
    { 2281U, 3382790668UL, 36,72,4286578688UL, 12, 18, 7, 15, 3078020480UL, 4225073152UL,  {0}},
    { 2281U, 3402019341UL, 36,72,4286578688UL, 12, 18, 7, 15, 1999462272UL, 4210524160UL,  {0}},
    { 2281U, 2406861326UL, 36,72,4286578688UL, 12, 18, 7, 15, 766981504UL, 4294279168UL,  {0}},
    { 2281U, 3479278095UL, 36,72,4286578688UL, 12, 18, 7, 15, 3134536576UL, 4149575680UL,  {0}},
    { 2281U, 3820460560UL, 36,72,4286578688UL, 12, 18, 7, 15, 792030848UL, 3723821056UL,  {0}},
    { 2281U, 2454059537UL, 36,72,4286578688UL, 12, 18, 7, 15, 1978490752UL, 4277501952UL,  {0}},
    { 2281U, 3982342674UL, 36,72,4286578688UL, 12, 18, 7, 15, 1936275200UL, 4277010432UL,  {0}},
    { 2281U, 4207649299UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008899200UL, 4227137536UL,  {0}},
    { 2281U, 3159679508UL, 36,72,4286578688UL, 12, 18, 7, 15, 1000389504UL, 4160061440UL,  {0}},
    { 2281U, 4177250837UL, 36,72,4286578688UL, 12, 18, 7, 15, 2004303744UL, 4209344512UL,  {0}},
    { 2281U, 4150342166UL, 36,72,4286578688UL, 12, 18, 7, 15, 1840166784UL, 4277501952UL,  {0}},
    { 2281U, 3726090775UL, 36,72,4286578688UL, 12, 18, 7, 15, 2817842560UL, 4225040384UL,  {0}},
    { 2281U, 3832810008UL, 36,72,4286578688UL, 12, 18, 7, 15, 786774912UL, 4151672832UL,  {0}},
    { 2281U, 3560821273UL, 36,72,4286578688UL, 12, 18, 7, 15, 2612706176UL, 4158717952UL,  {0}},
    { 2281U, 3482073626UL, 36,72,4286578688UL, 12, 18, 7, 15, 4013210496UL, 4155736064UL,  {0}},
    { 2281U, 3123690011UL, 36,72,4286578688UL, 12, 18, 7, 15, 4217203968UL, 3755311104UL,  {0}},
    { 2281U, 2500477468UL, 36,72,4286578688UL, 12, 18, 7, 15, 1835363712UL, 4292149248UL,  {0}},
    { 2281U, 4138549789UL, 36,72,4286578688UL, 12, 18, 7, 15, 779448064UL, 3721756672UL,  {0}},
    { 2281U, 2197195294UL, 36,72,4286578688UL, 12, 18, 7, 15, 2067606144UL, 4159012864UL,  {0}},
    { 2281U, 3738059295UL, 36,72,4286578688UL, 12, 18, 7, 15, 4015877888UL, 3721756672UL,  {0}},
    { 2281U, 2598314528UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132439424UL, 4151672832UL,  {0}},
    { 2281U, 2805490209UL, 36,72,4286578688UL, 12, 18, 7, 15, 1945464576UL, 3737452544UL,  {0}},
    { 2281U, 3680221730UL, 36,72,4286578688UL, 12, 18, 7, 15, 3119331968UL, 4158980096UL,  {0}},
    { 2281U, 2826936867UL, 36,72,4286578688UL, 12, 18, 7, 15, 896448384UL, 4276944896UL,  {0}},
    { 2281U, 2826799652UL, 36,72,4286578688UL, 12, 18, 7, 15, 922049280UL, 4292149248UL,  {0}},
    { 2281U, 2220411429UL, 36,72,4286578688UL, 12, 18, 7, 15, 2935438208UL, 4154818560UL,  {0}},
    { 2281U, 2811304486UL, 36,72,4286578688UL, 12, 18, 7, 15, 2897571456UL, 3755278336UL,  {0}},
    { 2281U, 3093813799UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009012096UL, 4155867136UL,  {0}},
    { 2281U, 2704175656UL, 36,72,4286578688UL, 12, 18, 7, 15, 4090852992UL, 4025810944UL,  {0}},
    { 2281U, 3930274345UL, 36,72,4286578688UL, 12, 18, 7, 15, 2933209728UL, 4158980096UL,  {0}},
    { 2281U, 2357121578UL, 36,72,4286578688UL, 12, 18, 7, 15, 4210388608UL, 3757408256UL,  {0}},
    { 2281U, 3223859755UL, 36,72,4286578688UL, 12, 18, 7, 15, 2901748480UL, 4159143936UL,  {0}},
    { 2281U, 3616131628UL, 36,72,4286578688UL, 12, 18, 7, 15, 917337728UL, 4025843712UL,  {0}},
    { 2281U, 2898743853UL, 36,72,4286578688UL, 12, 18, 7, 15, 964082560UL, 4155867136UL,  {0}},
    { 2281U, 3659026990UL, 36,72,4286578688UL, 12, 18, 7, 15, 2903469824UL, 3737812992UL,  {0}},
    { 2281U, 4145697327UL, 36,72,4286578688UL, 12, 18, 7, 15, 3106880384UL, 4160028672UL,  {0}},
    { 2281U, 3849321008UL, 36,72,4286578688UL, 12, 18, 7, 15, 649944960UL, 4258627584UL,  {0}},
    { 2281U, 3204690481UL, 36,72,4286578688UL, 12, 18, 7, 15, 3136646912UL, 3721756672UL,  {0}},
    { 2281U, 3256605234UL, 36,72,4286578688UL, 12, 18, 7, 15, 995965696UL, 4157964288UL,  {0}},
    { 2281U, 2392459827UL, 36,72,4286578688UL, 12, 18, 7, 15, 972372864UL, 4159012864UL,  {0}},
    { 2281U, 2388398644UL, 36,72,4286578688UL, 12, 18, 7, 15, 3874844288UL, 3721723904UL,  {0}},
    { 2281U, 2891653685UL, 36,72,4286578688UL, 12, 18, 7, 15, 758988672UL, 4159537152UL,  {0}},
    { 2281U, 3821511222UL, 36,72,4286578688UL, 12, 18, 7, 15, 2787958144UL, 4224778240UL,  {0}},
    { 2281U, 2625960503UL, 36,72,4286578688UL, 12, 18, 7, 15, 860189952UL, 4024795136UL,  {0}},
    { 2281U, 3175168568UL, 36,72,4286578688UL, 12, 18, 7, 15, 783642496UL, 4258627584UL,  {0}},
    { 2281U, 3217562169UL, 36,72,4286578688UL, 12, 18, 7, 15, 1988059008UL, 4208295936UL,  {0}},
    { 2281U, 2407279162UL, 36,72,4286578688UL, 12, 18, 7, 15, 3143068928UL, 3755278336UL,  {0}},
    { 2281U, 3004699195UL, 36,72,4286578688UL, 12, 18, 7, 15, 2918936448UL, 3738370048UL,  {0}},
    { 2281U, 4158794300UL, 36,72,4286578688UL, 12, 18, 7, 15, 1856859776UL, 4260691968UL,  {0}},
    { 2281U, 2427550269UL, 36,72,4286578688UL, 12, 18, 7, 15, 2524231040UL, 4292182016UL,  {0}},
    { 2281U, 3453168190UL, 36,72,4286578688UL, 12, 18, 7, 15, 4014305024UL, 3721756672UL,  {0}},
    { 2281U, 2901041727UL, 36,72,4286578688UL, 12, 18, 7, 15, 2893101952UL, 4159012864UL,  {0}},
    { 2281U, 3737885248UL, 36,72,4286578688UL, 12, 18, 7, 15, 926332800UL, 4277370880UL,  {0}},
    { 2281U, 3028111937UL, 36,72,4286578688UL, 12, 18, 7, 15, 1987501952UL, 4261249024UL,  {0}},
    { 2281U, 2150890050UL, 36,72,4286578688UL, 12, 18, 7, 15, 750074496UL, 4159012864UL,  {0}},
    { 2281U, 3326198339UL, 36,72,4286578688UL, 12, 18, 7, 15, 3136764672UL, 4159012864UL,  {0}},
    { 2281U, 3727161924UL, 36,72,4286578688UL, 12, 18, 7, 15, 2523182464UL, 4293230592UL,  {0}},
    { 2281U, 3727114821UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149328000UL, 3756818432UL,  {0}},
    { 2281U, 3870138950UL, 36,72,4286578688UL, 12, 18, 7, 15, 1709010304UL, 3755311104UL,  {0}},
    { 2281U, 2515352135UL, 36,72,4286578688UL, 12, 18, 7, 15, 2779700608UL, 4226088960UL,  {0}},
    { 2281U, 2319489608UL, 36,72,4286578688UL, 12, 18, 7, 15, 4076171008UL, 3721756672UL,  {0}},
    { 2281U, 2228904521UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115661952UL, 4160061440UL,  {0}},
    { 2281U, 3997418058UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140972416UL, 3738533888UL,  {0}},
    { 2281U, 3363988043UL, 36,72,4286578688UL, 12, 18, 7, 15, 3077889408UL, 4225204224UL,  {0}},
    { 2281U, 3122125388UL, 36,72,4286578688UL, 12, 18, 7, 15, 4021644928UL, 3722805248UL,  {0}},
    { 2281U, 2305993293UL, 36,72,4286578688UL, 12, 18, 7, 15, 787823488UL, 4154818560UL,  {0}},
    { 2281U, 3332606542UL, 36,72,4286578688UL, 12, 18, 7, 15, 933575296UL, 4294377472UL,  {0}},
    { 2281U, 2538785359UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153410688UL, 4157931520UL,  {0}},
    { 2281U, 3478245968UL, 36,72,4286578688UL, 12, 18, 7, 15, 3979833216UL, 3738501120UL,  {0}},
    { 2281U, 4254655057UL, 36,72,4286578688UL, 12, 18, 7, 15, 3144465280UL, 4155867136UL,  {0}},
    { 2281U, 2629530194UL, 36,72,4286578688UL, 12, 18, 7, 15, 3061112192UL, 4225073152UL,  {0}},
    { 2281U, 2383735379UL, 36,72,4286578688UL, 12, 18, 7, 15, 939318656UL, 4225007616UL,  {0}},
    { 2281U, 3329743444UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991587712UL, 4293361664UL,  {0}},
    { 2281U, 2809567829UL, 36,72,4286578688UL, 12, 18, 7, 15, 2922720000UL, 4158980096UL,  {0}},
    { 2281U, 3153513046UL, 36,72,4286578688UL, 12, 18, 7, 15, 3010541312UL, 4277469184UL,  {0}},
    { 2281U, 2275410519UL, 36,72,4286578688UL, 12, 18, 7, 15, 1861578624UL, 4258627584UL,  {0}},
    { 2281U, 2323268184UL, 36,72,4286578688UL, 12, 18, 7, 15, 3878513408UL, 3754229760UL,  {0}},
    { 2281U, 3638753881UL, 36,72,4286578688UL, 12, 18, 7, 15, 1836412288UL, 4292182016UL,  {0}},
    { 2281U, 2932916826UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995792000UL, 4225073152UL,  {0}},
    { 2281U, 3561902683UL, 36,72,4286578688UL, 12, 18, 7, 15, 3141352192UL, 4160061440UL,  {0}},
    { 2281U, 2658054748UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995798144UL, 3755311104UL,  {0}},
    { 2281U, 3747510877UL, 36,72,4286578688UL, 12, 18, 7, 15, 2947758976UL, 4150591488UL,  {0}},
    { 2281U, 3573873246UL, 36,72,4286578688UL, 12, 18, 7, 15, 3615340416UL, 3203760128UL,  {0}},
    { 2281U, 2467107423UL, 36,72,4286578688UL, 12, 18, 7, 15, 2645390976UL, 4024762368UL,  {0}},
    { 2281U, 2686734944UL, 36,72,4286578688UL, 12, 18, 7, 15, 3131390848UL, 4151672832UL,  {0}},
    { 2281U, 2485992033UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132439424UL, 4158980096UL,  {0}},
    { 2281U, 3348224610UL, 36,72,4286578688UL, 12, 18, 7, 15, 3056917888UL, 4225073152UL,  {0}},
    { 2281U, 2560275043UL, 36,72,4286578688UL, 12, 18, 7, 15, 3031751296UL, 4292182016UL,  {0}},
    { 2281U, 2380085860UL, 36,72,4286578688UL, 12, 18, 7, 15, 889118080UL, 4225335296UL,  {0}},
    { 2281U, 2159479397UL, 36,72,4286578688UL, 12, 18, 7, 15, 1975498112UL, 3220537344UL,  {0}},
    { 2281U, 2774303334UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115793024UL, 4159963136UL,  {0}},
    { 2281U, 3255161447UL, 36,72,4286578688UL, 12, 18, 7, 15, 2758860160UL, 4225597440UL,  {0}},
    { 2281U, 2939368040UL, 36,72,4286578688UL, 12, 18, 7, 15, 2797001344UL, 4291133440UL,  {0}},
    { 2281U, 3529200233UL, 36,72,4286578688UL, 12, 18, 7, 15, 666722176UL, 4216651776UL,  {0}},
    { 2281U, 3315876458UL, 36,72,4286578688UL, 12, 18, 7, 15, 3070050176UL, 4227268608UL,  {0}},
    { 2281U, 4289479275UL, 36,72,4286578688UL, 12, 18, 7, 15, 4151408384UL, 3740762112UL,  {0}},
    { 2281U, 2898608748UL, 36,72,4286578688UL, 12, 18, 7, 15, 783642496UL, 3721756672UL,  {0}},
    { 2281U, 3154440813UL, 36,72,4286578688UL, 12, 18, 7, 15, 3147869056UL, 4151640064UL,  {0}},
    { 2281U, 3524110958UL, 36,72,4286578688UL, 12, 18, 7, 15, 2998196096UL, 4283793408UL,  {0}},
    { 2281U, 2849108591UL, 36,72,4286578688UL, 12, 18, 7, 15, 649420672UL, 4258627584UL,  {0}},
    { 2281U, 3702174320UL, 36,72,4286578688UL, 12, 18, 7, 15, 3975985792UL, 4160061440UL,  {0}},
    { 2281U, 2521350769UL, 36,72,4286578688UL, 12, 18, 7, 15, 993357568UL, 3721756672UL,  {0}},
    { 2281U, 3410119282UL, 36,72,4286578688UL, 12, 18, 7, 15, 3874844288UL, 3721756672UL,  {0}},
    { 2281U, 4256823923UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153410688UL, 4157931520UL,  {0}},
    { 2281U, 2226338420UL, 36,72,4286578688UL, 12, 18, 7, 15, 3118774912UL, 4160061440UL,  {0}},
    { 2281U, 3978766965UL, 36,72,4286578688UL, 12, 18, 7, 15, 783755904UL, 3754262528UL,  {0}},
    { 2281U, 2338239094UL, 36,72,4286578688UL, 12, 18, 7, 15, 1996306176UL, 4294377472UL,  {0}},
    { 2281U, 3899183735UL, 36,72,4286578688UL, 12, 18, 7, 15, 3032276352UL, 4292182016UL,  {0}},
    { 2281U, 2158856824UL, 36,72,4286578688UL, 12, 18, 7, 15, 1005940352UL, 3721756672UL,  {0}},
    { 2281U, 3379933817UL, 36,72,4286578688UL, 12, 18, 7, 15, 4158093184UL, 4009066496UL,  {0}},
    { 2281U, 3713702522UL, 36,72,4286578688UL, 12, 18, 7, 15, 3056917888UL, 4225073152UL,  {0}},
    { 2281U, 4025031291UL, 36,72,4286578688UL, 12, 18, 7, 15, 3114580608UL, 4160061440UL,  {0}},
    { 2281U, 2992792188UL, 36,72,4286578688UL, 12, 18, 7, 15, 3970349696UL, 4160028672UL,  {0}},
    { 2281U, 2468209277UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991597952UL, 4258627584UL,  {0}},
    { 2281U, 2174077566UL, 36,72,4286578688UL, 12, 18, 7, 15, 1851698048UL, 4155867136UL,  {0}},
    { 2281U, 2444589695UL, 36,72,4286578688UL, 12, 18, 7, 15, 1992253312UL, 4225073152UL,  {0}},
    { 2281U, 2765105792UL, 36,72,4286578688UL, 12, 18, 7, 15, 3134667520UL, 4160061440UL,  {0}},
    { 2281U, 3519863425UL, 36,72,4286578688UL, 12, 18, 7, 15, 2913824512UL, 3737485312UL,  {0}},
    { 2281U, 2867391106UL, 36,72,4286578688UL, 12, 18, 7, 15, 3142926208UL, 4143382528UL,  {0}},
    { 2281U, 2763793027UL, 36,72,4286578688UL, 12, 18, 7, 15, 3077519232UL, 4275929088UL,  {0}},
    { 2281U, 3156570756UL, 36,72,4286578688UL, 12, 18, 7, 15, 3874844416UL, 3721756672UL,  {0}},
    { 2281U, 3080536709UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149314688UL, 4160061440UL,  {0}},
    { 2281U, 2762173062UL, 36,72,4286578688UL, 12, 18, 7, 15, 2910142336UL, 4158980096UL,  {0}},
    { 2281U, 2445101703UL, 36,72,4286578688UL, 12, 18, 7, 15, 783105920UL, 4227170304UL,  {0}},
    { 2281U, 4185897608UL, 36,72,4286578688UL, 12, 18, 7, 15, 3925177984UL, 3757408256UL,  {0}},
    { 2281U, 2273555081UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115629440UL, 4151672832UL,  {0}},
    { 2281U, 2516093578UL, 36,72,4286578688UL, 12, 18, 7, 15, 3181735680UL, 3738533888UL,  {0}},
    { 2281U, 4139627147UL, 36,72,4286578688UL, 12, 18, 7, 15, 1005927040UL, 4160061440UL,  {0}},
    { 2281U, 3012612748UL, 36,72,4286578688UL, 12, 18, 7, 15, 4022300288UL, 3723821056UL,  {0}},
    { 2281U, 2223792781UL, 36,72,4286578688UL, 12, 18, 7, 15, 2809585024UL, 4227039232UL,  {0}},
    { 2281U, 4100346510UL, 36,72,4286578688UL, 12, 18, 7, 15, 1303721600UL, 4294279168UL,  {0}},
    { 2281U, 2696802959UL, 36,72,4286578688UL, 12, 18, 7, 15, 3018274688UL, 4285628416UL,  {0}},
    { 2281U, 3192162960UL, 36,72,4286578688UL, 12, 18, 7, 15, 754268800UL, 4159012864UL,  {0}},
    { 2281U, 4011145873UL, 36,72,4286578688UL, 12, 18, 7, 15, 2813910400UL, 4224155648UL,  {0}},
    { 2281U, 2999061138UL, 36,72,4286578688UL, 12, 18, 7, 15, 4150621952UL, 4009197568UL,  {0}},
    { 2281U, 3181904531UL, 36,72,4286578688UL, 12, 18, 7, 15, 783642240UL, 3721756672UL,  {0}},
    { 2281U, 3412228756UL, 36,72,4286578688UL, 12, 18, 7, 15, 2474030976UL, 4275404800UL,  {0}},
    { 2281U, 3928072853UL, 36,72,4286578688UL, 12, 18, 7, 15, 4004867712UL, 3721756672UL,  {0}},
    { 2281U, 3123329686UL, 36,72,4286578688UL, 12, 18, 7, 15, 2914348928UL, 3740631040UL,  {0}},
    { 2281U, 3951829655UL, 36,72,4286578688UL, 12, 18, 7, 15, 3044859264UL, 4292149248UL,  {0}},
    { 2281U, 3586120344UL, 36,72,4286578688UL, 12, 18, 7, 15, 2071772032UL, 4160061440UL,  {0}},
    { 2281U, 2937522841UL, 36,72,4286578688UL, 12, 18, 7, 15, 4214582912UL, 3740631040UL,  {0}},
    { 2281U, 3194978970UL, 36,72,4286578688UL, 12, 18, 7, 15, 3971267200UL, 4156915712UL,  {0}},
    { 2281U, 2750974619UL, 36,72,4286578688UL, 12, 18, 7, 15, 1849473664UL, 4160028672UL,  {0}},
    { 2281U, 3099724444UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153410688UL, 4160061440UL,  {0}},
    { 2281U, 3851010717UL, 36,72,4286578688UL, 12, 18, 7, 15, 770535040UL, 3757408256UL,  {0}},
    { 2281U, 2932402846UL, 36,72,4286578688UL, 12, 18, 7, 15, 1777252224UL, 4276944896UL,  {0}},
    { 2281U, 3544488607UL, 36,72,4286578688UL, 12, 18, 7, 15, 783760000UL, 4159012864UL,  {0}},
    { 2281U, 4148351648UL, 36,72,4286578688UL, 12, 18, 7, 15, 4154292096UL, 4007985152UL,  {0}},
    { 2281U, 2811128481UL, 36,72,4286578688UL, 12, 18, 7, 15, 3596924288UL, 4292182016UL,  {0}},
    { 2281U, 3379731106UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132452480UL, 3723853824UL,  {0}},
    { 2281U, 2246746787UL, 36,72,4286578688UL, 12, 18, 7, 15, 2796608896UL, 4226285568UL,  {0}},
    { 2281U, 2555873956UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008366464UL, 4226252800UL,  {0}},
    { 2281U, 3831728805UL, 36,72,4286578688UL, 12, 18, 7, 15, 4193565312UL, 4159143936UL,  {0}},
    { 2281U, 3651633830UL, 36,72,4286578688UL, 12, 18, 7, 15, 935124352UL, 4225040384UL,  {0}},
    { 2281U, 2604815015UL, 36,72,4286578688UL, 12, 18, 7, 15, 3098884736UL, 4160061440UL,  {0}},
    { 2281U, 3874761384UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115662208UL, 4151672832UL,  {0}},
    { 2281U, 2997342889UL, 36,72,4286578688UL, 12, 18, 7, 15, 3979702144UL, 3738533888UL,  {0}},
    { 2281U, 3489014442UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132960384UL, 3757408256UL,  {0}},
    { 2281U, 3678190251UL, 36,72,4286578688UL, 12, 18, 7, 15, 2042149760UL, 4160094208UL,  {0}},
    { 2281U, 3348923052UL, 36,72,4286578688UL, 12, 18, 7, 15, 2809458304UL, 4258758656UL,  {0}},
    { 2281U, 3090043565UL, 36,72,4286578688UL, 12, 18, 7, 15, 993868544UL, 4159012864UL,  {0}},
    { 2281U, 2305925806UL, 36,72,4286578688UL, 12, 18, 7, 15, 779447936UL, 3721723904UL,  {0}},
    { 2281U, 3576210095UL, 36,72,4286578688UL, 12, 18, 7, 15, 703936384UL, 4282744832UL,  {0}},
    { 2281U, 4046680752UL, 36,72,4286578688UL, 12, 18, 7, 15, 3988090496UL, 3755311104UL,  {0}},
    { 2281U, 2576786097UL, 36,72,4286578688UL, 12, 18, 7, 15, 926735744UL, 4225040384UL,  {0}},
    { 2281U, 2821923506UL, 36,72,4286578688UL, 12, 18, 7, 15, 3998576384UL, 3721723904UL,  {0}},
    { 2281U, 3775646387UL, 36,72,4286578688UL, 12, 18, 7, 15, 3979668736UL, 3755311104UL,  {0}},
    { 2281U, 3079135924UL, 36,72,4286578688UL, 12, 18, 7, 15, 2933209728UL, 4160061440UL,  {0}},
    { 2281U, 3258370741UL, 36,72,4286578688UL, 12, 18, 7, 15, 715602816UL, 4294246400UL,  {0}},
    { 2281U, 2765759158UL, 36,72,4286578688UL, 12, 18, 7, 15, 3056917888UL, 4225040384UL,  {0}},
    { 2281U, 3478231735UL, 36,72,4286578688UL, 12, 18, 7, 15, 3143023488UL, 4155867136UL,  {0}},
    { 2281U, 2375193272UL, 36,72,4286578688UL, 12, 18, 7, 15, 2935307008UL, 4159012864UL,  {0}},
    { 2281U, 2390323897UL, 36,72,4286578688UL, 12, 18, 7, 15, 3152342400UL, 3757473792UL,  {0}},
    { 2281U, 2935364282UL, 36,72,4286578688UL, 12, 18, 7, 15, 2069184384UL, 4142202880UL,  {0}},
    { 2281U, 3324011195UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008374656UL, 4225073152UL,  {0}},
    { 2281U, 2939495100UL, 36,72,4286578688UL, 12, 18, 7, 15, 3003070336UL, 4285628416UL,  {0}},
    { 2281U, 3998051005UL, 36,72,4286578688UL, 12, 18, 7, 15, 947698560UL, 4157931520UL,  {0}},
    { 2281U, 4025090750UL, 36,72,4286578688UL, 12, 18, 7, 15, 3048660352UL, 4292182016UL,  {0}},
    { 2281U, 3509256895UL, 36,72,4286578688UL, 12, 18, 7, 15, 3031752064UL, 4225073152UL,  {0}},
    { 2281U, 3850590912UL, 36,72,4286578688UL, 12, 18, 7, 15, 648372096UL, 4258562048UL,  {0}},
    { 2281U, 3595408065UL, 36,72,4286578688UL, 12, 18, 7, 15, 2914348928UL, 3746889728UL,  {0}},
    { 2281U, 2241436354UL, 36,72,4286578688UL, 12, 18, 7, 15, 1837068160UL, 4291133440UL,  {0}},
    { 2281U, 4293061315UL, 36,72,4286578688UL, 12, 18, 7, 15, 2762268032UL, 4292182016UL,  {0}},
    { 2281U, 3295412932UL, 36,72,4286578688UL, 12, 18, 7, 15, 4206718720UL, 3755311104UL,  {0}},
    { 2281U, 3283784389UL, 36,72,4286578688UL, 12, 18, 7, 15, 997636992UL, 4160061440UL,  {0}},
    { 2281U, 4250929862UL, 36,72,4286578688UL, 12, 18, 7, 15, 3713496960UL, 4007985152UL,  {0}},
    { 2281U, 2976930503UL, 36,72,4286578688UL, 12, 18, 7, 15, 3145644928UL, 4160716800UL,  {0}},
    { 2281U, 3470928584UL, 36,72,4286578688UL, 12, 18, 7, 15, 3119954560UL, 4160061440UL,  {0}},
    { 2281U, 2309935817UL, 36,72,4286578688UL, 12, 18, 7, 15, 888593792UL, 4225204224UL,  {0}},
    { 2281U, 2254766794UL, 36,72,4286578688UL, 12, 18, 7, 15, 847163008UL, 3756359680UL,  {0}},
    { 2281U, 3473400523UL, 36,72,4286578688UL, 12, 18, 7, 15, 1835888512UL, 4277501952UL,  {0}},
    { 2281U, 3816757964UL, 36,72,4286578688UL, 12, 18, 7, 15, 1001728896UL, 4151672832UL,  {0}},
    { 2281U, 3987946189UL, 36,72,4286578688UL, 12, 18, 7, 15, 4151801600UL, 3740631040UL,  {0}},
    { 2281U, 2537347790UL, 36,72,4286578688UL, 12, 18, 7, 15, 3118807936UL, 4151672832UL,  {0}},
    { 2281U, 2415778511UL, 36,72,4286578688UL, 12, 18, 7, 15, 744307456UL, 4160061440UL,  {0}},
    { 2281U, 3946355408UL, 36,72,4286578688UL, 12, 18, 7, 15, 3004493440UL, 3755835392UL,  {0}},
    { 2281U, 3863245521UL, 36,72,4286578688UL, 12, 18, 7, 15, 1840737664UL, 4294246400UL,  {0}},
    { 2281U, 2518964946UL, 36,72,4286578688UL, 12, 18, 7, 15, 3086409088UL, 4225040384UL,  {0}},
    { 2281U, 2975976147UL, 36,72,4286578688UL, 12, 18, 7, 15, 854929024UL, 4292182016UL,  {0}},
    { 2281U, 3018316500UL, 36,72,4286578688UL, 12, 18, 7, 15, 926726016UL, 4277567488UL,  {0}},
    { 2281U, 3150834389UL, 36,72,4286578688UL, 12, 18, 7, 15, 2541008768UL, 4272226304UL,  {0}},
    { 2281U, 4035269334UL, 36,72,4286578688UL, 12, 18, 7, 15, 2009029760UL, 4225040384UL,  {0}},
    { 2281U, 2196898519UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149183616UL, 4160061440UL,  {0}},
    { 2281U, 3380964056UL, 36,72,4286578688UL, 12, 18, 7, 15, 3119856512UL, 4150591488UL,  {0}},
    { 2281U, 2259938009UL, 36,72,4286578688UL, 12, 18, 7, 15, 1994225280UL, 4024762368UL,  {0}},
    { 2281U, 4218667738UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008899456UL, 4208295936UL,  {0}},
    { 2281U, 4270260955UL, 36,72,4286578688UL, 12, 18, 7, 15, 1727983232UL, 3721756672UL,  {0}},
    { 2281U, 2342464220UL, 36,72,4286578688UL, 12, 18, 7, 15, 3152768384UL, 3748626432UL,  {0}},
    { 2281U, 3676795613UL, 36,72,4286578688UL, 12, 18, 7, 15, 670391936UL, 4258594816UL,  {0}},
    { 2281U, 3851236062UL, 36,72,4286578688UL, 12, 18, 7, 15, 989146880UL, 3721756672UL,  {0}},
    { 2281U, 4138799839UL, 36,72,4286578688UL, 12, 18, 7, 15, 2037300096UL, 4160585728UL,  {0}},
    { 2281U, 3889406688UL, 36,72,4286578688UL, 12, 18, 7, 15, 1840606592UL, 4292149248UL,  {0}},
    { 2281U, 2261228257UL, 36,72,4286578688UL, 12, 18, 7, 15, 2905943808UL, 3738533888UL,  {0}},
    { 2281U, 2759189218UL, 36,72,4286578688UL, 12, 18, 7, 15, 2914335360UL, 4158980096UL,  {0}},
    { 2281U, 3559938787UL, 36,72,4286578688UL, 12, 18, 7, 15, 2935307136UL, 4151803904UL,  {0}},
    { 2281U, 2653127396UL, 36,72,4286578688UL, 12, 18, 7, 15, 4013369984UL, 4157964288UL,  {0}},
    { 2281U, 2766330597UL, 36,72,4286578688UL, 12, 18, 7, 15, 3052723584UL, 4225040384UL,  {0}},
    { 2281U, 2657952486UL, 36,72,4286578688UL, 12, 18, 7, 15, 1290254976UL, 4160192512UL,  {0}},
    { 2281U, 3406916327UL, 36,72,4286578688UL, 12, 18, 7, 15, 2067610368UL, 4160061440UL,  {0}},
    { 2281U, 3107107560UL, 36,72,4286578688UL, 12, 18, 7, 15, 1002254208UL, 4143284224UL,  {0}},
    { 2281U, 4095142633UL, 36,72,4286578688UL, 12, 18, 7, 15, 2939501184UL, 4159012864UL,  {0}},
    { 2281U, 2220630762UL, 36,72,4286578688UL, 12, 18, 7, 15, 1836414720UL, 3738468352UL,  {0}},
    { 2281U, 3277730539UL, 36,72,4286578688UL, 12, 18, 7, 15, 3979702016UL, 3738533888UL,  {0}},
    { 2281U, 3188089580UL, 36,72,4286578688UL, 12, 18, 7, 15, 3990187776UL, 3738664960UL,  {0}},
    { 2281U, 3902857965UL, 36,72,4286578688UL, 12, 18, 7, 15, 1715395968UL, 4225040384UL,  {0}},
    { 2281U, 4274662126UL, 36,72,4286578688UL, 12, 18, 7, 15, 3143449344UL, 4160061440UL,  {0}},
    { 2281U, 3894242031UL, 36,72,4286578688UL, 12, 18, 7, 15, 1996184448UL, 4287463424UL,  {0}},
    { 2281U, 3775306480UL, 36,72,4286578688UL, 12, 18, 7, 15, 972372608UL, 4157964288UL,  {0}},
    { 2281U, 2860317425UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149707904UL, 4160061440UL,  {0}},
    { 2281U, 3022140146UL, 36,72,4286578688UL, 12, 18, 7, 15, 1844492160UL, 4277501952UL,  {0}},
    { 2281U, 3564702451UL, 36,72,4286578688UL, 12, 18, 7, 15, 950889856UL, 3756359680UL,  {0}},
    { 2281U, 3950506740UL, 36,72,4286578688UL, 12, 18, 7, 15, 2075474816UL, 4152164352UL,  {0}},
    { 2281U, 3047099125UL, 36,72,4286578688UL, 12, 18, 7, 15, 3110550272UL, 4160061440UL,  {0}},
    { 2281U, 2549129974UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153947904UL, 3755311104UL,  {0}},
    { 2281U, 3313928951UL, 36,72,4286578688UL, 12, 18, 7, 15, 995442560UL, 4143251456UL,  {0}},
    { 2281U, 2980829944UL, 36,72,4286578688UL, 12, 18, 7, 15, 3141352320UL, 4160028672UL,  {0}},
    { 2281U, 2489611001UL, 36,72,4286578688UL, 12, 18, 7, 15, 2075487872UL, 3721756672UL,  {0}},
    { 2281U, 3600323322UL, 36,72,4286578688UL, 12, 18, 7, 15, 2791628032UL, 4225073152UL,  {0}},
    { 2281U, 4029094651UL, 36,72,4286578688UL, 12, 18, 7, 15, 3981929856UL, 3755278336UL,  {0}},
    { 2281U, 4190745340UL, 36,72,4286578688UL, 12, 18, 7, 15, 1768733568UL, 4160028672UL,  {0}},
    { 2281U, 3262046973UL, 36,72,4286578688UL, 12, 18, 7, 15, 3984551808UL, 3737616384UL,  {0}},
    { 2281U, 2189882110UL, 36,72,4286578688UL, 12, 18, 7, 15, 2797394560UL, 4292182016UL,  {0}},
    { 2281U, 3600607999UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995267712UL, 4224024576UL,  {0}},
    { 2281U, 3067941632UL, 36,72,4286578688UL, 12, 18, 7, 15, 2126330752UL, 4157964288UL,  {0}},
    { 2281U, 4006656769UL, 36,72,4286578688UL, 12, 18, 7, 15, 3975494272UL, 4157964288UL,  {0}},
    { 2281U, 2764485378UL, 36,72,4286578688UL, 12, 18, 7, 15, 2800037632UL, 4258627584UL,  {0}},
    { 2281U, 2883320579UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995781760UL, 4294213632UL,  {0}},
    { 2281U, 2540368644UL, 36,72,4286578688UL, 12, 18, 7, 15, 3082106496UL, 4293230592UL,  {0}},
    { 2281U, 2446072581UL, 36,72,4286578688UL, 12, 18, 7, 15, 3991320192UL, 4294279168UL,  {0}},
    { 2281U, 3738168070UL, 36,72,4286578688UL, 12, 18, 7, 15, 2908581632UL, 3738501120UL,  {0}},
    { 2281U, 3606567687UL, 36,72,4286578688UL, 12, 18, 7, 15, 2897571712UL, 3738533888UL,  {0}},
    { 2281U, 4054366984UL, 36,72,4286578688UL, 12, 18, 7, 15, 1935241088UL, 3737616384UL,  {0}},
    { 2281U, 3664120585UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931112832UL, 4159012864UL,  {0}},
    { 2281U, 2630384394UL, 36,72,4286578688UL, 12, 18, 7, 15, 733293184UL, 4158980096UL,  {0}},
    { 2281U, 4126292747UL, 36,72,4286578688UL, 12, 18, 7, 15, 1005927040UL, 4160061440UL,  {0}},
    { 2281U, 2917227276UL, 36,72,4286578688UL, 12, 18, 7, 15, 934196864UL, 4294246400UL,  {0}},
    { 2281U, 4044182285UL, 36,72,4286578688UL, 12, 18, 7, 15, 4079972096UL, 3738533888UL,  {0}},
    { 2281U, 2978077454UL, 36,72,4286578688UL, 12, 18, 7, 15, 3593254272UL, 4294279168UL,  {0}},
    { 2281U, 3212634895UL, 36,72,4286578688UL, 12, 18, 7, 15, 3065337472UL, 4009066496UL,  {0}},
    { 2281U, 3689616144UL, 36,72,4286578688UL, 12, 18, 7, 15, 918511232UL, 4260724736UL,  {0}},
    { 2281U, 3779848977UL, 36,72,4286578688UL, 12, 18, 7, 15, 3143940992UL, 4160061440UL,  {0}},
    { 2281U, 2202684178UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140841216UL, 3740631040UL,  {0}},
    { 2281U, 3217212179UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149314688UL, 4156915712UL,  {0}},
    { 2281U, 2217638676UL, 36,72,4286578688UL, 12, 18, 7, 15, 1690099072UL, 4225171456UL,  {0}},
    { 2281U, 2959608597UL, 36,72,4286578688UL, 12, 18, 7, 15, 852850304UL, 4024795136UL,  {0}},
    { 2281U, 4008321814UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995912960UL, 4294279168UL,  {0}},
    { 2281U, 3902911255UL, 36,72,4286578688UL, 12, 18, 7, 15, 2809453952UL, 4225204224UL,  {0}},
    { 2281U, 2531631896UL, 36,72,4286578688UL, 12, 18, 7, 15, 2013050752UL, 4275535872UL,  {0}},
    { 2281U, 3852231449UL, 36,72,4286578688UL, 12, 18, 7, 15, 984922752UL, 4159012864UL,  {0}},
    { 2281U, 3149912858UL, 36,72,4286578688UL, 12, 18, 7, 15, 2004671872UL, 4225073152UL,  {0}},
    { 2281U, 2726564635UL, 36,72,4286578688UL, 12, 18, 7, 15, 4206194304UL, 3757375488UL,  {0}},
    { 2281U, 3448877852UL, 36,72,4286578688UL, 12, 18, 7, 15, 1936799616UL, 4276453376UL,  {0}},
    { 2281U, 3301567261UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149229824UL, 3737485312UL,  {0}},
    { 2281U, 3469845278UL, 36,72,4286578688UL, 12, 18, 7, 15, 2792676736UL, 4225073152UL,  {0}},
    { 2281U, 2285165343UL, 36,72,4286578688UL, 12, 18, 7, 15, 771046272UL, 4151672832UL,  {0}},
    { 2281U, 3638774560UL, 36,72,4286578688UL, 12, 18, 7, 15, 1836365696UL, 4277501952UL,  {0}},
    { 2281U, 3182887713UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153407744UL, 3737452544UL,  {0}},
    { 2281U, 2317292322UL, 36,72,4286578688UL, 12, 18, 7, 15, 1232549760UL, 4276453376UL,  {0}},
    { 2281U, 2448530211UL, 36,72,4286578688UL, 12, 18, 7, 15, 4006951552UL, 4157964288UL,  {0}},
    { 2281U, 4129323812UL, 36,72,4286578688UL, 12, 18, 7, 15, 2935307008UL, 4160716800UL,  {0}},
    { 2281U, 3335988005UL, 36,72,4286578688UL, 12, 18, 7, 15, 3988748032UL, 3738501120UL,  {0}},
    { 2281U, 3051037478UL, 36,72,4286578688UL, 12, 18, 7, 15, 4152049024UL, 4227301376UL,  {0}},
    { 2281U, 2386406183UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995790976UL, 4292182016UL,  {0}},
    { 2281U, 3289496360UL, 36,72,4286578688UL, 12, 18, 7, 15, 922050176UL, 4260691968UL,  {0}},
    { 2281U, 3210292009UL, 36,72,4286578688UL, 12, 18, 7, 15, 988625664UL, 4157964288UL,  {0}},
    { 2281U, 3992474410UL, 36,72,4286578688UL, 12, 18, 7, 15, 2060892800UL, 4158980096UL,  {0}},
    { 2281U, 3860278059UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009062144UL, 3721723904UL,  {0}},
    { 2281U, 2380522284UL, 36,72,4286578688UL, 12, 18, 7, 15, 766865024UL, 3755278336UL,  {0}},
    { 2281U, 2933623597UL, 36,72,4286578688UL, 12, 18, 7, 15, 2058566400UL, 4160323584UL,  {0}},
    { 2281U, 3082752814UL, 36,72,4286578688UL, 12, 18, 7, 15, 3873795840UL, 3721756672UL,  {0}},
    { 2281U, 4194267951UL, 36,72,4286578688UL, 12, 18, 7, 15, 3148004224UL, 4151803904UL,  {0}},
    { 2281U, 2856588080UL, 36,72,4286578688UL, 12, 18, 7, 15, 2930588288UL, 4160028672UL,  {0}},
    { 2281U, 3214625585UL, 36,72,4286578688UL, 12, 18, 7, 15, 994930432UL, 3720839168UL,  {0}},
    { 2281U, 3533486898UL, 36,72,4286578688UL, 12, 18, 7, 15, 972372608UL, 4156882944UL,  {0}},
    { 2281U, 2714094387UL, 36,72,4286578688UL, 12, 18, 7, 15, 3984014208UL, 4157964288UL,  {0}},
    { 2281U, 2911562548UL, 36,72,4286578688UL, 12, 18, 7, 15, 4210388608UL, 3757375488UL,  {0}},
    { 2281U, 3726502709UL, 36,72,4286578688UL, 12, 18, 7, 15, 3052722816UL, 4292182016UL,  {0}},
    { 2281U, 3910726454UL, 36,72,4286578688UL, 12, 18, 7, 15, 1970199936UL, 4225073152UL,  {0}},
    { 2281U, 3008707383UL, 36,72,4286578688UL, 12, 18, 7, 15, 917856128UL, 4216684544UL,  {0}},
    { 2281U, 3579298616UL, 36,72,4286578688UL, 12, 18, 7, 15, 4080365184UL, 3721723904UL,  {0}},
    { 2281U, 4244015929UL, 36,72,4286578688UL, 12, 18, 7, 15, 1958043264UL, 4276977664UL,  {0}},
    { 2281U, 3492815674UL, 36,72,4286578688UL, 12, 18, 7, 15, 2792152448UL, 4225073152UL,  {0}},
    { 2281U, 3236778811UL, 36,72,4286578688UL, 12, 18, 7, 15, 4007489280UL, 3721756672UL,  {0}},
    { 2281U, 3703808828UL, 36,72,4286578688UL, 12, 18, 7, 15, 4218908288UL, 3740598272UL,  {0}},
    { 2281U, 4065846077UL, 36,72,4286578688UL, 12, 18, 7, 15, 3036469888UL, 4292182016UL,  {0}},
    { 2281U, 3173999422UL, 36,72,4286578688UL, 12, 18, 7, 15, 1006452608UL, 4142333952UL,  {0}},
    { 2281U, 4178596671UL, 36,72,4286578688UL, 12, 18, 7, 15, 703952128UL, 3757408256UL,  {0}},
    { 2281U, 3647253312UL, 36,72,4286578688UL, 12, 18, 7, 15, 2077572480UL, 4160061440UL,  {0}},
    { 2281U, 2723193665UL, 36,72,4286578688UL, 12, 18, 7, 15, 1836412288UL, 4292182016UL,  {0}},
    { 2281U, 3938360130UL, 36,72,4286578688UL, 12, 18, 7, 15, 3141319552UL, 4160061440UL,  {0}},
    { 2281U, 2626323267UL, 36,72,4286578688UL, 12, 18, 7, 15, 2791626368UL, 4292182016UL,  {0}},
    { 2281U, 2972052292UL, 36,72,4286578688UL, 12, 18, 7, 15, 3991320448UL, 4273307648UL,  {0}},
    { 2281U, 3956056901UL, 36,72,4286578688UL, 12, 18, 7, 15, 2046212992UL, 4159537152UL,  {0}},
    { 2281U, 4291285830UL, 36,72,4286578688UL, 12, 18, 7, 15, 932542336UL, 4008148992UL,  {0}},
    { 2281U, 4148710215UL, 36,72,4286578688UL, 12, 18, 7, 15, 917943680UL, 4293230592UL,  {0}},
    { 2281U, 3199099720UL, 36,72,4286578688UL, 12, 18, 7, 15, 766852992UL, 4225597440UL,  {0}},
    { 2281U, 2349325129UL, 36,72,4286578688UL, 12, 18, 7, 15, 2925869696UL, 4160061440UL,  {0}},
    { 2281U, 2714297162UL, 36,72,4286578688UL, 12, 18, 7, 15, 3001364096UL, 4258594816UL,  {0}},
    { 2281U, 3964359499UL, 36,72,4286578688UL, 12, 18, 7, 15, 1958533760UL, 4294803456UL,  {0}},
    { 2281U, 3863137100UL, 36,72,4286578688UL, 12, 18, 7, 15, 1841215360UL, 4277501952UL,  {0}},
    { 2281U, 2801457997UL, 36,72,4286578688UL, 12, 18, 7, 15, 3032276352UL, 4292182016UL,  {0}},
    { 2281U, 3875744590UL, 36,72,4286578688UL, 12, 18, 7, 15, 3119987328UL, 4157964288UL,  {0}},
    { 2281U, 3335891791UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140841216UL, 3738501120UL,  {0}},
    { 2281U, 4091476816UL, 36,72,4286578688UL, 12, 18, 7, 15, 2035760000UL, 4155736064UL,  {0}},
    { 2281U, 2715466577UL, 36,72,4286578688UL, 12, 18, 7, 15, 632479104UL, 4227170304UL,  {0}},
    { 2281U, 3712955218UL, 36,72,4286578688UL, 12, 18, 7, 15, 2079158016UL, 3737485312UL,  {0}},
    { 2281U, 4037962579UL, 36,72,4286578688UL, 12, 18, 7, 15, 995441408UL, 4160061440UL,  {0}},
    { 2281U, 3783289684UL, 36,72,4286578688UL, 12, 18, 7, 15, 4209471104UL, 3756359680UL,  {0}},
    { 2281U, 3086764885UL, 36,72,4286578688UL, 12, 18, 7, 15, 4138038912UL, 4023713792UL,  {0}},
    { 2281U, 2686530390UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140270976UL, 4160028672UL,  {0}},
    { 2281U, 3529483095UL, 36,72,4286578688UL, 12, 18, 7, 15, 4214714112UL, 3723853824UL,  {0}},
    { 2281U, 2167862104UL, 36,72,4286578688UL, 12, 18, 7, 15, 750070656UL, 4158980096UL,  {0}},
    { 2281U, 3950619481UL, 36,72,4286578688UL, 12, 18, 7, 15, 2792676224UL, 4292149248UL,  {0}},
    { 2281U, 2755734362UL, 36,72,4286578688UL, 12, 18, 7, 15, 2933865216UL, 4158881792UL,  {0}},
    { 2281U, 3146881883UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995914112UL, 4284841984UL,  {0}},
    { 2281U, 2220290908UL, 36,72,4286578688UL, 12, 18, 7, 15, 1001700224UL, 4160061440UL,  {0}},
    { 2281U, 3047068509UL, 36,72,4286578688UL, 12, 18, 7, 15, 2906091264UL, 3738501120UL,  {0}},
    { 2281U, 3088952158UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009062272UL, 3720839168UL,  {0}},
    { 2281U, 2182312799UL, 36,72,4286578688UL, 12, 18, 7, 15, 1727360896UL, 4250238976UL,  {0}},
    { 2281U, 2935403360UL, 36,72,4286578688UL, 12, 18, 7, 15, 3165969792UL, 4227170304UL,  {0}},
    { 2281U, 3818177377UL, 36,72,4286578688UL, 12, 18, 7, 15, 1849473664UL, 4160061440UL,  {0}},
    { 2281U, 4006746978UL, 36,72,4286578688UL, 12, 18, 7, 15, 4202117760UL, 4160028672UL,  {0}},
    { 2281U, 2263147363UL, 36,72,4286578688UL, 12, 18, 7, 15, 3136633600UL, 4159012864UL,  {0}},
    { 2281U, 3819883364UL, 36,72,4286578688UL, 12, 18, 7, 15, 2914480000UL, 3738533888UL,  {0}},
    { 2281U, 2868677477UL, 36,72,4286578688UL, 12, 18, 7, 15, 769996416UL, 4292149248UL,  {0}},
    { 2281U, 2551667558UL, 36,72,4286578688UL, 12, 18, 7, 15, 4201986688UL, 4160061440UL,  {0}},
    { 2281U, 2378984295UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008888960UL, 4294279168UL,  {0}},
    { 2281U, 2922097512UL, 36,72,4286578688UL, 12, 18, 7, 15, 3056917888UL, 4225073152UL,  {0}},
    { 2281U, 3354401641UL, 36,72,4286578688UL, 12, 18, 7, 15, 2917608704UL, 3755311104UL,  {0}},
    { 2281U, 3530191722UL, 36,72,4286578688UL, 12, 18, 7, 15, 963472256UL, 3756883968UL,  {0}},
    { 2281U, 4178766699UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153947904UL, 3755311104UL,  {0}},
    { 2281U, 4116345708UL, 36,72,4286578688UL, 12, 18, 7, 15, 2792674560UL, 4291133440UL,  {0}},
    { 2281U, 3034035053UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153934976UL, 4160061440UL,  {0}},
    { 2281U, 2921843566UL, 36,72,4286578688UL, 12, 18, 7, 15, 3067428608UL, 4227170304UL,  {0}},
    { 2281U, 2584154991UL, 36,72,4286578688UL, 12, 18, 7, 15, 2881433472UL, 4143284224UL,  {0}},
    { 2281U, 3558507376UL, 36,72,4286578688UL, 12, 18, 7, 15, 4146935040UL, 4293197824UL,  {0}},
    { 2281U, 4289995633UL, 36,72,4286578688UL, 12, 18, 7, 15, 4217335040UL, 3755311104UL,  {0}},
    { 2281U, 2349491058UL, 36,72,4286578688UL, 12, 18, 7, 15, 930405760UL, 4225073152UL,  {0}},
    { 2281U, 2694247283UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931125888UL, 3721756672UL,  {0}},
    { 2281U, 3329897332UL, 36,72,4286578688UL, 12, 18, 7, 15, 934600064UL, 4225073152UL,  {0}},
    { 2281U, 2472921973UL, 36,72,4286578688UL, 12, 18, 7, 15, 1711107328UL, 3754262528UL,  {0}},
    { 2281U, 3396195190UL, 36,72,4286578688UL, 12, 18, 7, 15, 3077889408UL, 4225204224UL,  {0}},
    { 2281U, 4225137527UL, 36,72,4286578688UL, 12, 18, 7, 15, 3048660352UL, 4292182016UL,  {0}},
    { 2281U, 2357105528UL, 36,72,4286578688UL, 12, 18, 7, 15, 3986648832UL, 3738533888UL,  {0}},
    { 2281U, 2557830009UL, 36,72,4286578688UL, 12, 18, 7, 15, 782593664UL, 3722248192UL,  {0}},
    { 2281U, 2253255546UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008366464UL, 4225171456UL,  {0}},
    { 2281U, 3043146619UL, 36,72,4286578688UL, 12, 18, 7, 15, 3216325248UL, 4157964288UL,  {0}},
    { 2281U, 3692190588UL, 36,72,4286578688UL, 12, 18, 7, 15, 1002401664UL, 3738533888UL,  {0}},
    { 2281U, 2176928637UL, 36,72,4286578688UL, 12, 18, 7, 15, 984821504UL, 3722379264UL,  {0}},
    { 2281U, 4007369598UL, 36,72,4286578688UL, 12, 18, 7, 15, 750073216UL, 4293197824UL,  {0}},
    { 2281U, 3956280191UL, 36,72,4286578688UL, 12, 18, 7, 15, 3702880128UL, 4024795136UL,  {0}},
    { 2281U, 2240107392UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008463232UL, 4275372032UL,  {0}},
    { 2281U, 2815914881UL, 36,72,4286578688UL, 12, 18, 7, 15, 2779700608UL, 4294279168UL,  {0}},
    { 2281U, 3418014594UL, 36,72,4286578688UL, 12, 18, 7, 15, 2033499008UL, 4159537152UL,  {0}},
    { 2281U, 2570431363UL, 36,72,4286578688UL, 12, 18, 7, 15, 3049053568UL, 4292149248UL,  {0}},
    { 2281U, 3006229380UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931125888UL, 3723853824UL,  {0}},
    { 2281U, 3696665477UL, 36,72,4286578688UL, 12, 18, 7, 15, 4080365184UL, 3721723904UL,  {0}},
    { 2281U, 2473118598UL, 36,72,4286578688UL, 12, 18, 7, 15, 917855104UL, 4294279168UL,  {0}},
    { 2281U, 3195560839UL, 36,72,4286578688UL, 12, 18, 7, 15, 2774850944UL, 4292182016UL,  {0}},
    { 2281U, 2453836680UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009062016UL, 3721756672UL,  {0}},
    { 2281U, 2630423433UL, 36,72,4286578688UL, 12, 18, 7, 15, 737491584UL, 4157964288UL,  {0}},
    { 2281U, 3953136522UL, 36,72,4286578688UL, 12, 18, 7, 15, 2918674304UL, 3740631040UL,  {0}},
    { 2281U, 2849737611UL, 36,72,4286578688UL, 12, 18, 7, 15, 993357056UL, 3754262528UL,  {0}},
    { 2281U, 3725005708UL, 36,72,4286578688UL, 12, 18, 7, 15, 1308438144UL, 4292083712UL,  {0}},
    { 2281U, 3770381197UL, 36,72,4286578688UL, 12, 18, 7, 15, 1004878464UL, 4160192512UL,  {0}},
    { 2281U, 3593634702UL, 36,72,4286578688UL, 12, 18, 7, 15, 918380160UL, 4225040384UL,  {0}},
    { 2281U, 2590931855UL, 36,72,4286578688UL, 12, 18, 7, 15, 989687424UL, 3757375488UL,  {0}},
    { 2281U, 2236179344UL, 36,72,4286578688UL, 12, 18, 7, 15, 2067611392UL, 4141187072UL,  {0}},
    { 2281U, 4191048593UL, 36,72,4286578688UL, 12, 18, 7, 15, 1995782016UL, 4283760640UL,  {0}},
    { 2281U, 2247529362UL, 36,72,4286578688UL, 12, 18, 7, 15, 959261440UL, 3754262528UL,  {0}},
    { 2281U, 2477460371UL, 36,72,4286578688UL, 12, 18, 7, 15, 3991760768UL, 3746922496UL,  {0}},
    { 2281U, 3157255060UL, 36,72,4286578688UL, 12, 18, 7, 15, 4217859328UL, 3754754048UL,  {0}},
    { 2281U, 2562263957UL, 36,72,4286578688UL, 12, 18, 7, 15, 922541440UL, 4225073152UL,  {0}},
    { 2281U, 3369118614UL, 36,72,4286578688UL, 12, 18, 7, 15, 3870649088UL, 3755311104UL,  {0}},
    { 2281U, 2154179479UL, 36,72,4286578688UL, 12, 18, 7, 15, 4149573504UL, 3740467200UL,  {0}},
    { 2281U, 3310607256UL, 36,72,4286578688UL, 12, 18, 7, 15, 3985338112UL, 3737485312UL,  {0}},
    { 2281U, 2485289881UL, 36,72,4286578688UL, 12, 18, 7, 15, 4009048704UL, 4157964288UL,  {0}},
    { 2281U, 3358227354UL, 36,72,4286578688UL, 12, 18, 7, 15, 1723129216UL, 4225564672UL,  {0}},
    { 2281U, 4198931355UL, 36,72,4286578688UL, 12, 18, 7, 15, 930929536UL, 4292182016UL,  {0}},
    { 2281U, 3497436060UL, 36,72,4286578688UL, 12, 18, 7, 15, 2916576640UL, 3755278336UL,  {0}},
    { 2281U, 3041469341UL, 36,72,4286578688UL, 12, 18, 7, 15, 3065305984UL, 4292149248UL,  {0}},
    { 2281U, 4101886878UL, 36,72,4286578688UL, 12, 18, 7, 15, 1000422144UL, 4159897600UL,  {0}},
    { 2281U, 4043447199UL, 36,72,4286578688UL, 12, 18, 7, 15, 783105920UL, 4227137536UL,  {0}},
    { 2281U, 2400711584UL, 36,72,4286578688UL, 12, 18, 7, 15, 929881472UL, 4292182016UL,  {0}},
    { 2281U, 3836418977UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991596928UL, 4292182016UL,  {0}},
    { 2281U, 3451452322UL, 36,72,4286578688UL, 12, 18, 7, 15, 995965824UL, 4157964288UL,  {0}},
    { 2281U, 2907470755UL, 36,72,4286578688UL, 12, 18, 7, 15, 3057442176UL, 4225073152UL,  {0}},
    { 2281U, 3214185380UL, 36,72,4286578688UL, 12, 18, 7, 15, 1931833088UL, 3721887744UL,  {0}},
    { 2281U, 2554528677UL, 36,72,4286578688UL, 12, 18, 7, 15, 4221922944UL, 3721756672UL,  {0}},
    { 2281U, 2450189222UL, 36,72,4286578688UL, 12, 18, 7, 15, 1977955968UL, 4294279168UL,  {0}},
    { 2281U, 2758132647UL, 36,72,4286578688UL, 12, 18, 7, 15, 3546592640UL, 4290052096UL,  {0}},
    { 2281U, 3090314152UL, 36,72,4286578688UL, 12, 18, 7, 15, 1843883392UL, 4294803456UL,  {0}},
    { 2281U, 2843782057UL, 36,72,4286578688UL, 12, 18, 7, 15, 2069179776UL, 4160028672UL,  {0}},
    { 2281U, 3773156266UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991587456UL, 4294246400UL,  {0}},
    { 2281U, 2304152491UL, 36,72,4286578688UL, 12, 18, 7, 15, 4209995520UL, 3754786816UL,  {0}},
    { 2281U, 4165995436UL, 36,72,4286578688UL, 12, 18, 7, 15, 917953152UL, 4292182016UL,  {0}},
    { 2281U, 3615019949UL, 36,72,4286578688UL, 12, 18, 7, 15, 4002770688UL, 3721723904UL,  {0}},
    { 2281U, 2900190126UL, 36,72,4286578688UL, 12, 18, 7, 15, 1974820224UL, 4292182016UL,  {0}},
    { 2281U, 2865216431UL, 36,72,4286578688UL, 12, 18, 7, 15, 1991735168UL, 4023746560UL,  {0}},
    { 2281U, 4262861744UL, 36,72,4286578688UL, 12, 18, 7, 15, 4007489280UL, 3721756672UL,  {0}},
    { 2281U, 3803855793UL, 36,72,4286578688UL, 12, 18, 7, 15, 761706112UL, 4291592192UL,  {0}},
    { 2281U, 3666013106UL, 36,72,4286578688UL, 12, 18, 7, 15, 787822208UL, 4294279168UL,  {0}},
    { 2281U, 2429324211UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931125888UL, 3721756672UL,  {0}},
    { 2281U, 2948727732UL, 36,72,4286578688UL, 12, 18, 7, 15, 3140959104UL, 4160061440UL,  {0}},
    { 2281U, 2839264181UL, 36,72,4286578688UL, 12, 18, 7, 15, 3141484288UL, 4141154304UL,  {0}},
    { 2281U, 4031892406UL, 36,72,4286578688UL, 12, 18, 7, 15, 3044334976UL, 4292182016UL,  {0}},
    { 2281U, 2651829175UL, 36,72,4286578688UL, 12, 18, 7, 15, 3131521792UL, 4160061440UL,  {0}},
    { 2281U, 3073088440UL, 36,72,4286578688UL, 12, 18, 7, 15, 4155848576UL, 3740631040UL,  {0}},
    { 2281U, 2176523193UL, 36,72,4286578688UL, 12, 18, 7, 15, 3065329536UL, 4283793408UL,  {0}},
    { 2281U, 3914851258UL, 36,72,4286578688UL, 12, 18, 7, 15, 3046956416UL, 4225073152UL,  {0}},
    { 2281U, 2277487547UL, 36,72,4286578688UL, 12, 18, 7, 15, 4000804480UL, 3721756672UL,  {0}},
    { 2281U, 3368301500UL, 36,72,4286578688UL, 12, 18, 7, 15, 2006277504UL, 4225073152UL,  {0}},
    { 2281U, 3894324157UL, 36,72,4286578688UL, 12, 18, 7, 15, 1962728576UL, 4225073152UL,  {0}},
    { 2281U, 2243228606UL, 36,72,4286578688UL, 12, 18, 7, 15, 1722604928UL, 4225073152UL,  {0}},
    { 2281U, 2357912511UL, 36,72,4286578688UL, 12, 18, 7, 15, 1836936576UL, 4294279168UL,  {0}},
    { 2281U, 3631645632UL, 36,72,4286578688UL, 12, 18, 7, 15, 1823783808UL, 4160061440UL,  {0}},
    { 2281U, 2363681729UL, 36,72,4286578688UL, 12, 18, 7, 15, 2908712320UL, 3755671552UL,  {0}},
    { 2281U, 2300806082UL, 36,72,4286578688UL, 12, 18, 7, 15, 3008812800UL, 4275404800UL,  {0}},
    { 2281U, 3009813443UL, 36,72,4286578688UL, 12, 18, 7, 15, 3126910336UL, 4292050944UL,  {0}},
    { 2281U, 3987946436UL, 36,72,4286578688UL, 12, 18, 7, 15, 2809453952UL, 4225073152UL,  {0}},
    { 2281U, 4200113093UL, 36,72,4286578688UL, 12, 18, 7, 15, 3010410368UL, 4276453376UL,  {0}},
    { 2281U, 2516536262UL, 36,72,4286578688UL, 12, 18, 7, 15, 3031489920UL, 4224024576UL,  {0}},
    { 2281U, 2296873927UL, 36,72,4286578688UL, 12, 18, 7, 15, 3061112192UL, 4225073152UL,  {0}},
    { 2281U, 2192708552UL, 36,72,4286578688UL, 12, 18, 7, 15, 3681893120UL, 4157964288UL,  {0}},
    { 2281U, 2225839049UL, 36,72,4286578688UL, 12, 18, 7, 15, 4068300416UL, 4025810944UL,  {0}},
    { 2281U, 3353117642UL, 36,72,4286578688UL, 12, 18, 7, 15, 3057442176UL, 4225073152UL,  {0}},
    { 2281U, 3707663307UL, 36,72,4286578688UL, 12, 18, 7, 15, 3078020480UL, 4225073152UL,  {0}},
    { 2281U, 3891354572UL, 36,72,4286578688UL, 12, 18, 7, 15, 2008996608UL, 4292182016UL,  {0}},
    { 2281U, 4183602125UL, 36,72,4286578688UL, 12, 18, 7, 15, 3038986112UL, 4227006464UL,  {0}},
    { 2281U, 3688330190UL, 36,72,4286578688UL, 12, 18, 7, 15, 4020596608UL, 3714416640UL,  {0}},
    { 2281U, 2513181647UL, 36,72,4286578688UL, 12, 18, 7, 15, 4210388608UL, 3756359680UL,  {0}},
    { 2281U, 3718128592UL, 36,72,4286578688UL, 12, 18, 7, 15, 3979654784UL, 4294246400UL,  {0}},
    { 2281U, 3569032145UL, 36,72,4286578688UL, 12, 18, 7, 15, 1844801152UL, 4291133440UL,  {0}},
    { 2281U, 2689653714UL, 36,72,4286578688UL, 12, 18, 7, 15, 3971299968UL, 4157964288UL,  {0}},
    { 2281U, 4124068819UL, 36,72,4286578688UL, 12, 18, 7, 15, 785726080UL, 4160061440UL,  {0}},
    { 2281U, 3643950036UL, 36,72,4286578688UL, 12, 18, 7, 15, 665935488UL, 4225564672UL,  {0}},
    { 2281U, 3645752277UL, 36,72,4286578688UL, 12, 18, 7, 15, 3118774912UL, 4160061440UL,  {0}},
    { 2281U, 3463818198UL, 36,72,4286578688UL, 12, 18, 7, 15, 3070024320UL, 4292280320UL,  {0}},
    { 2281U, 2919300055UL, 36,72,4286578688UL, 12, 18, 7, 15, 4012194688UL, 4159897600UL,  {0}},
    { 2281U, 3656066008UL, 36,72,4286578688UL, 12, 18, 7, 15, 1996446592UL, 4287954944UL,  {0}},
    { 2281U, 3676435417UL, 36,72,4286578688UL, 12, 18, 7, 15, 995441536UL, 4155867136UL,  {0}},
    { 2281U, 3884000218UL, 36,72,4286578688UL, 12, 18, 7, 15, 3153407616UL, 3721756672UL,  {0}},
    { 2281U, 3869527003UL, 36,72,4286578688UL, 12, 18, 7, 15, 3136630400UL, 3723853824UL,  {0}},
    { 2281U, 3909831644UL, 36,72,4286578688UL, 12, 18, 7, 15, 1937730816UL, 3755311104UL,  {0}},
    { 2281U, 3978576861UL, 36,72,4286578688UL, 12, 18, 7, 15, 1391802240UL, 4293328896UL,  {0}},
    { 2281U, 3218779102UL, 36,72,4286578688UL, 12, 18, 7, 15, 1970593152UL, 4225073152UL,  {0}},
    { 2281U, 4027847647UL, 36,72,4286578688UL, 12, 18, 7, 15, 3114347136UL, 4160028672UL,  {0}},
    { 2281U, 3003223008UL, 36,72,4286578688UL, 12, 18, 7, 15, 3982932864UL, 4159930368UL,  {0}},
    { 2281U, 3835798497UL, 36,72,4286578688UL, 12, 18, 7, 15, 661970304UL, 4225040384UL,  {0}},
    { 2281U, 2520271842UL, 36,72,4286578688UL, 12, 18, 7, 15, 729116544UL, 4275404800UL,  {0}},
    { 2281U, 2769718243UL, 36,72,4286578688UL, 12, 18, 7, 15, 1706389248UL, 3738533888UL,  {0}},
    { 2281U, 2372320228UL, 36,72,4286578688UL, 12, 18, 7, 15, 783628160UL, 4286021632UL,  {0}},
    { 2281U, 3270679525UL, 36,72,4286578688UL, 12, 18, 7, 15, 1974820224UL, 4292182016UL,  {0}},
    { 2281U, 2626739174UL, 36,72,4286578688UL, 12, 18, 7, 15, 3069500288UL, 4289036288UL,  {0}},
    { 2281U, 2969218023UL, 36,72,4286578688UL, 12, 18, 7, 15, 3086278016UL, 4225204224UL,  {0}},
    { 2281U, 2659038184UL, 36,72,4286578688UL, 12, 18, 7, 15, 2776292736UL, 4227170304UL,  {0}},
    { 2281U, 3940809705UL, 36,72,4286578688UL, 12, 18, 7, 15, 1989498496UL, 4024762368UL,  {0}},
    { 2281U, 3232766954UL, 36,72,4286578688UL, 12, 18, 7, 15, 2931108736UL, 4159012864UL,  {0}},
    { 2281U, 2977981419UL, 36,72,4286578688UL, 12, 18, 7, 15, 3984420736UL, 3738533888UL,  {0}},
    { 2281U, 2586991596UL, 36,72,4286578688UL, 12, 18, 7, 15, 987147136UL, 4155867136UL,  {0}},
    { 2281U, 2997545965UL, 36,72,4286578688UL, 12, 18, 7, 15, 1534442368UL, 4157964288UL,  {0}},
    { 2281U, 2868681710UL, 36,72,4286578688UL, 12, 18, 7, 15, 3065069440UL, 4227137536UL,  {0}},
    { 2281U, 2481945583UL, 36,72,4286578688UL, 12, 18, 7, 15, 3865897600UL, 3755311104UL,  {0}},
    { 2281U, 4286954480UL, 36,72,4286578688UL, 12, 18, 7, 15, 4223102720UL, 3738533888UL,  {0}},
    { 2281U, 3781864433UL, 36,72,4286578688UL, 12, 18, 7, 15, 786907008UL, 4227039232UL,  {0}},
    { 2281U, 2562827250UL, 36,72,4286578688UL, 12, 18, 7, 15, 3136646912UL, 3720675328UL,  {0}},
    { 2281U, 2663013363UL, 36,72,4286578688UL, 12, 18, 7, 15, 930405760UL, 4225073152UL,  {0}},
    { 2281U, 2326578164UL, 36,72,4286578688UL, 12, 18, 7, 15, 2045688704UL, 4160061440UL,  {0}},
    { 2281U, 3276880885UL, 36,72,4286578688UL, 12, 18, 7, 15, 753744768UL, 4151934976UL,  {0}},
    { 2281U, 3537736694UL, 36,72,4286578688UL, 12, 18, 7, 15, 3870125824UL, 3720708096UL,  {0}},
    { 2281U, 3038536695UL, 36,72,4286578688UL, 12, 18, 7, 15, 3887427200UL, 3721723904UL,  {0}},
    { 2281U, 3383544824UL, 36,72,4286578688UL, 12, 18, 7, 15, 2004180864UL, 4208295936UL,  {0}},
    { 2281U, 3935529977UL, 36,72,4286578688UL, 12, 18, 7, 15, 3149873024UL, 4143808512UL,  {0}},
    { 2281U, 4042585082UL, 36,72,4286578688UL, 12, 18, 7, 15, 3132963712UL, 4160061440UL,  {0}},
    { 2281U, 4231158779UL, 36,72,4286578688UL, 12, 18, 7, 15, 3135028096UL, 4155867136UL,  {0}},
    { 2281U, 2401903612UL, 36,72,4286578688UL, 12, 18, 7, 15, 3115658112UL, 4151672832UL,  {0}},
    { 2281U, 3682288637UL, 36,72,4286578688UL, 12, 18, 7, 15, 4013387520UL, 3720708096UL,  {0}},
    { 2281U, 3980671998UL, 36,72,4286578688UL, 12, 18, 7, 15, 3137153792UL, 4159012864UL,  {0}},
    { 2281U, 2957902847UL, 36,72,4286578688UL, 12, 18, 7, 15, 2067094272UL, 4025974784UL,  {0}}
};

#endif // PPU

//  C++ interface
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _MC_RAND_MT_H */
